/*DavitMarg*/
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <unordered_map>
#include <set>
#include <bitset>
#include <queue>
#include <cassert>
#include <random>
#define LL long long
#define mod 1000000007ll
#define all(v) v.begin(),v.end()
#define MP make_pair
#define PB push_back
using namespace std;

const int N=100005;

int n,k,ans[N],used[N+N];
pair<int,int> a[N],b[N];
vector<int> g[2*N],x[4*N];

void makeCloser()
{
	vector<int> v;
	map<int,int> ind;
	for(int i=1;i<=n;i++)
	{
		v.PB(a[i].first);
		v.PB(a[i].second);
		v.PB(b[i].first);
		v.PB(b[i].second);
	}
	sort(all(v));
	for(int i=0;i<v.size();i++)
		if(!i || v[i]!=v[i-1])
			ind[v[i]]=++k;
	for(int i=1;i<=n;i++)
	{
		a[i].first=ind[a[i].first];
		a[i].second=ind[a[i].second];
		b[i].first=ind[b[i].first];
		b[i].second=ind[b[i].second];
	}
}

int hak(int x)
{
	if(x>n)
		return x-n;
	return x+n;
}


int get(int x)
{
	if(x>n)
		return b[x-n].first;
	return a[x].first;
}

void addNode(int a,int b)
{
	if(abs(a-b)==n)
		return;
	g[a].PB(b);
}

void add(int pos,int v)
{
	/*for(int i=0;i<x[pos].size();i++)
	{
		addNode(v,hak(x[pos][i]));
		addNode(x[pos][i],hak(v));
	}*/
	x[pos].PB(v);
}

bool check(int V)
{
	map<int,int> U;
	queue<int> q;
	vector<pair<int,int>> p;
	q.push(V);
	while(!q.empty())
	{
		int v=q.front();
		q.pop();
		p.PB(MP(get(v),v));
		if(U[get(v)])
			continue;
		U[get(v)]=1;
		for(int i=0;i<x[get(v)].size();i++)
		{
			int to=x[get(v)][i];
			if(abs(to-v)==n || to==v)
				continue;
			//cout<<to<<" : ";
			q.push(hak(to));
		}
		//cout<<endl;
	}
	sort(all(p));
	for(int i=0;i<p.size()-1;i++)
		if(get(p[i].second)==get(p[i+1].second) && p[i].second!=p[i+1].second)
			return 0;
	for(int i=0;i<p.size();i++)
	{
		//cout<<p[i].first<<" - "<<p[i].second<<endl;
		used[p[i].second]=1;
		used[hak(p[i].second)]=2;
	}
	//cout<<endl;
	return 1;
	
}

int main()
{
	cin>>n;
	for(int i=1;i<=n;i++)
		scanf("%d%d%d%d",&a[i].first,&a[i].second,&b[i].first,&b[i].second);
	makeCloser();
	for(int i=1;i<=n;i++)
	{
		add(a[i].first,i);
		add(b[i].first,i+n);
	}
	for(int i=1;i<=n;i++)
	{
		if(used[i])
			continue;
		if(!check(i))
			if(!check(i+n))
			{
				cout<<"No"<<endl;
				return 0;
			}
	}
	vector<int> V;
	for(int i=1;i<=n;i++)
		if(used[i]==1)
			V.PB(a[i].first);
		else
			V.PB(b[i].first);
	sort(all(V));
	for(int i=0;i<V.size()-1;i++)
		if(V[i]==V[i+1])
		{
			cout<<"No"<<endl;
			return 0;
		}
	cout<<"Yes"<<endl;
	for(int i=1;i<=n;i++)
		cout<<used[i]<<endl;

	return 0;
}

/*

3
1 1 2 2
2 2 3 3
2 2 1 1


3
1 1 2 2
2 2 3 3
2 2 2 2

*/