#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cstring>
#include <string>
#include <bitset>
#include <cassert>
#include <queue>
#include <stack>
#include <list>
#include <deque>
using namespace std;
#define m_p make_pair
const int N = 1003;
struct ban
{
	vector<int> v;
	ban()
	{
		v.assign(N, 0);
	}
};
ban operator+(const ban& a, const ban& b)
{
	ban res;
	int m = 0;
	for (int i = 0; i < N; ++i)
	{
		res.v[i] = (a.v[i] + b.v[i] + m) % 2;
		m = (a.v[i] + b.v[i] + m) /	2;
	}
	return res;
}
bool operator==(const ban& a, const ban &b)
{
	for (int i = 0; i < N; ++i)
	{
		if (a.v[i] != b.v[i])
			return false;
	}
	return true;
}
bool operator>(const ban& a, const ban& b)
{
	for (int i = N - 1; i >= 0; --i)
	{
		if (a.v[i] != b.v[i])
		{
			return a.v[i] > b.v[i];
		}
	}
	return false;
}

int n;

ban nn;
vector<int> v;
bool rec(long long i, ban sum, int q)
{
	if (sum == nn)
	{
		cout << q << endl;
		/*for (int i = 0; i < v.size(); ++i)
			cout << v[i] << ' ';
		cout << endl;*/
		return true;
	}
	if (i < 10)
	{
		if (i == 0)
		{
			return false;
		}
		if (sum > nn)
		{
			return false;
		}
		ban x;
		for (int j = 0; j < i; ++j)
			x.v[j] = 1;
		v.push_back(i);
		if (rec(i - 1, sum + x, q + 1))
			return true;
		v.pop_back();
		if (rec(i - 1, sum, q))
			return true;
	}
	else
	{
		ban x;
		for (int j = 0; j < i; ++j)
			x.v[j] = 1;
		if (i % 2 != n % 2)
		{
			if (rec(i - 1, sum + x, q + 1))
				return true;
		}
		else
		{
			if (rec(i - 1, sum, q))
				return true;
		}
	}
	return false;
}

int main()
{
	cin >> n;
	//for (n = 1; n <= 60; ++n)
	{
		//cout << n << ' ';
		if (n <= 1000)
		{
			nn = ban();
			if (n % 2 == 1)
			{
				for (long long i = 0; i < n; ++i)
				{
					if (i % 2 == 0)
						nn.v[i] = 1;
				}
			}
			else
			{
				for (long long i = 0; i < n; ++i)
				{
					if (i % 2 == 1)
						nn.v[i] = 1;
				}
			}
			v.clear();
			if (!rec(n, ban(), 0))
				cout << 0 << endl;
		}
		else
		{
			cout << 0 << endl;
		}
	}
	system("pause");
	return 0;
}
