#include<iostream>
#include<set>
#include<vector>
#include<queue>
using namespace std;

set<pair<int, bool> > r2, r4;
int n, m;

vector<pair<int, int> > ans;
queue<pair<int, bool> > rem;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for(int i = 0; i < n; i ++)
    {
        int x, y;
        cin >> x >> y;
        if(x == 2)  r2.insert({y, 0});
        if(x == 4)  r4.insert({y, 0});
    }
    cin >> m;
    for(int i = 0; i < m; i ++)
    {
        int x, y;
        cin >> x >> y;
        if(x == 2)  r2.insert({y, 1});
        if(x == 4)  r4.insert({y, 1});
    }

    for(auto i: r2)
    {
        if(i.second == 0 && r4.count(i))
        {
            ans.push_back({3, i.first});
            rem.push(i);
        }
    }
    while(!rem.empty())
    {
        r2.erase(rem.front());
        r4.erase(rem.front());
        rem.pop();
    }
    for(auto i = r2.begin(); i != r2.end(); i ++)
    {
        if(i->second == 0)
        {
            ans.push_back({2, i->first + 1});
            i ++;
            if(i == r2.end())   break;
        }
    }
    for(auto i = r4.begin(); i != r4.end(); i ++)
    {
        if(i->second == 0)
        {
            ans.push_back({4, i->first + 1});
            i ++;
            if(i == r4.end())   break;
        }
    }

    cout << ans.size() << "\n";
    for(auto i: ans)
    {
        cout << i.first << " " << i.second << "\n";
    }
}
/**
4
2 2
2 4
2 6
4 2
0
*/
