#include<bits/stdc++.h>
using namespace std;

const int nmax=4e5+42;

int n,m;

struct info
{
    int x,y,type;
    int id;
    //type=0-> box
    //type=1-> stone
    //type=-1 -> destroyed box
};

info inp[nmax],mem[nmax];

struct out
{
    int type;
    int x,y;
};

vector<out> output;

void add(int x,int y,int type)
{
    out now;
    now.x=x;
    now.y=y;
    now.type=type;
    output.push_back(now);
}
bool cmp_x(info a,info b)
{
    if(a.x!=b.x)return a.x<b.x;
    return a.y<b.y;
}

bool cmp_y(info a,info b)
{
    if(a.y!=b.y)return a.y<b.y;
    return a.x<b.x;
}

bool proper(int i)
{
    return inp[i].type==0;
}

vector<int> adj[nmax];

vector<int> current;

bool been[nmax];

void dfs(int node)
{
    if(been[node])return;
    been[node]=1;

    //cout<<"dfs "<<node<<endl;

    current.push_back(node);

    for(auto k:adj[node])
        dfs(k);
}

bool between(int a,int b,int c)
{
    if(a<=b&&b<=c)return 1;
    if(a>=b&&b>=c)return 1;
    return 0;
}
int main()
{
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>inp[i].x>>inp[i].y;
        inp[i].type=0;
        inp[i].id=i;

        mem[i]=inp[i];
    }

    cin>>m;
    for(int i=1;i<=m;i++)
    {
        cin>>inp[i+n].x>>inp[i+n].y;
        inp[i+n].type=1;
        inp[i+n].id=i+n;

        mem[i+n]=inp[i+n];
    }

    //clear x
    sort(inp+1,inp+n+m+1,cmp_x);

    for(int i=2;i<=n+m;i++)
    {
        if(proper(i-1)&&proper(i)&&inp[i-1].x==inp[i].x)
        {
            //add(inp[i].x,inp[i].y-1,1);
            adj[inp[i-1].id].push_back(inp[i].id);
            adj[inp[i].id].push_back(inp[i-1].id);
        }
    }
    //clear y
    sort(inp+1,inp+n+m+1,cmp_y);

    for(int i=2;i<=n+m;i++)
    {
        if(proper(i-1)&&proper(i)&&inp[i-1].y==inp[i].y)
        {
            //add(inp[i].x-1,inp[i].y,0);
            adj[inp[i-1].id].push_back(inp[i].id);
            adj[inp[i].id].push_back(inp[i-1].id);
        }
    }

    for(int i=1;i<=n+m;i++)
        inp[i]=mem[i];
    /*
    for(int i=1;i<=n;i++)
        for(auto k:adj[i])
        cout<<i<<" -> "<<k<<endl;
    */
    for(int i=1;i<=n+m;i++)
    {
        //cout<<i<<" -> "<<inp[i].x<<" "<<inp[i].y<<" "<<inp[i].type<<endl;

        if(inp[i].type!=0)continue;

        //cout<<i<<" -> "<<adj[i].size()<<endl;

        if(adj[i].size()==0)
        {
            add(inp[i].x-1,inp[i].y,0);
            continue;
        }

        if(been[i])continue;

        if(adj[i].size()!=1)continue;

        current={};

        dfs(i);

        //cout<<"current: ";for(auto k:current)cout<<k<<" ";cout<<endl;

        for(int j=0;j<current.size();j=j+2)
        {
            if(j==current.size()-1)
            {
                add(inp[current[j]].x-1,inp[current[j]].y,0);
            }
            else
            {
                if(inp[current[j]].x==inp[current[j+1]].x)
                {
                    int y_=inp[current[j+1]].y-1;

                    if(between(inp[current[j]].y,y_,inp[current[j+1]].y)==0)y_=inp[current[j]].y-1;

                    add(inp[current[j+1]].x,y_,1);
                }
                else
                {
                    int x_=inp[current[j+1]].x-1;

                    if(between(inp[current[j]].x,x_,inp[current[j+1]].x)==0)x_=inp[current[j]].x-1;

                    add(x_,inp[current[j+1]].y,0);
                }
            }
        }
    }


    printf("%i\n",output.size());

    for(auto k:output)printf("%i %i %i\n",k.type,k.x,k.y);
    return 0;
}
/*
4
2 2
2 4
4 2
4 5
0

4
3 2
5 2
5 5
2 5
0

2
2 10
2 15
1
2 13
*/
