#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2e5 + 7;

pair<int, int> a[MAXN][2];
int n;

bool collide(pair<int, int> p1, pair<int, int> p2){
    if(p1.first > p2.second || p1.second < p2.first){
        return false;
    }
    return true;
}

bool used[MAXN];
int ans[MAXN];
vector<int> v;

void solve(){
    for(int state = 0; state < (1 << n); ++state){
        bool ok = true;
        for(int i = 0; i < n && ok; ++i){
            for(int j = i + 1; j < n && ok; ++j){
                if(collide(a[i][(bool)(state & (1 << i))], a[j][(bool)(state & (1 << j))])){
                    ok = false;
                }
            }
        }
        if(ok){
            cout << "Yes\n";
            for(int i = 0; i < n; ++i){
                cout << (bool)(state & (1 << i)) + (int)1 << "\n";
            }
            exit(0);
        }
    }
    cout << "No\n";
}

void read(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);


    cin >> n;
    for(int i = 0; i < n; ++i){
        cin >> a[i][0].first >> a[i][0].second;
        cin >> a[i][1].first >> a[i][1].second;
    }
    exit(0);
}

int main(){
    read();
    solve();
}
/*
3
0 0 1 6
2 2 3 4
1 3 5 5
*/
