#include <bits/stdc++.h>
#define ll long long
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 8e3 + 5;
const int NOT = 4e3;

int n;

struct Dance{

    int id;
    int a, b, c, d;

}dancer[N];

vector <int> nb[N], rev_nb[N];

vector <int> ts;
bool vis[N];
void DFS_topsort(int v)
{
    vis[v] = true;
    for(int u: nb[v])
        if(!vis[u])
            DFS_topsort(u);

    ts.pb(v);
}

int comp[N], color;
void DFS(int v)
{
    comp[v] = color;
    for(int u: rev_nb[v])
        if(comp[u] == 0)
            DFS(u);
}

int ans[N];

bool intersect(int l1, int r1, int l2, int r2)
{
    if(l2 > r1 || l1 > r2)
        return false;
    return true;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for(int i = 1; i <= n; i++)
    {
        cin >> dancer[i].a >> dancer[i].b >> dancer[i].c >> dancer[i].d;
        dancer[i].id = i;

        ans[i] = 1;
    }

    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            if(i == j)
                continue;

            if(intersect(dancer[i].a, dancer[i].b, dancer[j].a, dancer[j].b))
            {
                nb[i].pb(j + NOT);
            }
            if(intersect(dancer[i].a, dancer[i].b, dancer[j].c, dancer[j].d))
            {
                nb[i].pb(j);
            }
            if(intersect(dancer[i].c, dancer[i].d, dancer[j].a, dancer[j].b))
            {
                nb[i + NOT].pb(j + NOT);
            }
            if(intersect(dancer[i].c, dancer[i].d, dancer[j].c, dancer[j].d))
            {
                nb[i + NOT].pb(j);
            }
        }
    }

    for(int i = 1; i <= n; i++)
    {
        if(!vis[i])
            DFS_topsort(i);
        if(!vis[i + NOT])
            DFS_topsort(i + NOT);
    }

    for(int i = 1; i <= n; i++)
    {
        for(int v: nb[i])
            rev_nb[v].pb(i);
        for(int v: nb[i + NOT])
            rev_nb[v].pb(i + NOT);
    }

    for(int i = (int)ts.size() - 1; i >= 0; i--)
    {
        if(comp[ts[i]] == 0)
        {
            color++;
            DFS(ts[i]);
        }
    }

    for(int i = 1; i <= n; i++)
    {
        if(comp[i] == comp[i + NOT])
        {
            cout << "No" << endl;
            return 0;
        }
    }

    memset(vis, false, sizeof(vis));
    for(int i = (int)ts.size() - 1; i >= 0; i--)
    {
        if(ts[i] < NOT)
        {
            if(!vis[ts[i] + NOT])
                ans[ts[i]] = 2;
        }
        vis[ts[i]] = true;
    }

    cout << "Yes" << endl;
    for(int i = 1; i <= n; i++)
        cout << ans[i] << endl;

    return 0;
}

/*

3
0 0 1 6
2 2 3 4
1 3 5 5

3
0 0 1 6
2 2 3 4
0 0 1 3

10
21 22 33 35
16 18 26 27
9 10 14 23
0 1 15 34
12 17 19 32
4 28 30 38
5 6 13 31
2 3 20 37
24 25 29 36
7 8 11 39

*/
