#include <iostream>
#include <vector>
#include <algorithm>
#include <utility>
using namespace std;

const int MAXN = 100005;

struct singer
{
    int a, b, c, d;
};

int n;
singer s[MAXN];

vector<pair<int, int>> v;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> s[i].a >> s[i].b >> s[i].c >> s[i].d;
    }
}

bool Check()
{
    int cnt = 0;
    for (int i = 0; i < v.size(); ++ i)
    {
        // cout << v[i].first << ' ' << v[i].second << endl;
        if (v[i].second == 1) cnt++;
        else cnt--;

        if (cnt > 1) return false;
    }
    return true;
}

int main()
{
    Init();

    int pow = 1 << n;
    for (int i = 0; i < pow; ++ i)
    {
        v.clear();
        for (int j = 1; j <= n; ++ j)
        {
            if ((i & (1 << (j - 1))) == 0)
            {
                v.emplace_back(s[j].a, 1);
                v.emplace_back(s[j].b + 1, 0);
            }
            else
            {
                v.emplace_back(s[j].c, 1);
                v.emplace_back(s[j].d + 1, 0);
            }
        }
        sort(v.begin(), v.end());

        if (Check())
        {
            // cout << i << endl;
            cout << "Yes" << endl;
            for (int j = 1; j <= n; ++ j)
            {
                if ((i & (1 << (j - 1))) == 0)
                {
                    cout << 1 << endl;
                }
                else
                {
                    cout << 2 << endl;
                }
            }
            return 0;
        }
    }

    cout << "No" << endl;
    return 0;
}

