#include <iostream>
#include <utility>
#include <vector>
#define fi first
#define se second
using namespace std;

const int MAXN = 400005;

int n, m;
pair<int, int> b[MAXN], s[MAXN];
int ans;
vector<pair<int, pair<int, int>>> bombs, temp;
int d[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    ans = n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> b[i].fi >> b[i].se;
    }
    cin >> m;
    for (int i = 1; i <= m; ++ i)
    {
        cin >> s[i].fi >> s[i].se;
    }
}

void Rec(int cnt = 0, int rem = n)
{
    if (cnt + rem / 2 + 1 > ans) return; //!

    if (rem == 0)
    {
        if (cnt < ans)
        {
            ans = cnt;
            bombs = temp;
        }
        return;
    }

    for (int i = 1; i <= n; ++ i)
    {
        if (d[i] == 1) continue;
        else d[i] = 1;

        int minx = 1 << 30, miny = 1 << 30, maxx = 0, maxy = 0;
        int minxi = 0, minyi = 0, maxxi = 0, maxyi = 0;

        for (int j = 1; j <= n; ++ j)
        {
            if (d[j] == 1) continue;
            if (b[i].se == b[j].se and maxx < b[j].fi and b[i].fi > b[j].fi)
            {
                maxx = b[j].fi;
                maxxi = j;
            }
            if (b[i].se == b[j].se and minx > b[j].fi and b[i].fi < b[j].fi)
            {
                minx = b[j].fi;
                minxi = j;
            }
            if (b[i].fi == b[j].fi and maxy < b[j].se and b[i].se > b[j].se)
            {
                maxy = b[j].se;
                maxyi = j;
            }
            if (b[i].fi == b[j].fi and miny > b[j].se and b[i].se < b[j].se)
            {
                miny = b[j].se;
                minyi = j;
            }
        }

        for (int j = 1; j <= m; ++ j)
        {
            if (maxxi != 0 and b[i].se == s[j].se and s[j].fi < b[i].fi and s[j].fi > b[maxxi].fi) maxxi = 0;
            if (minxi != 0 and b[i].se == s[j].se and s[j].fi > b[i].fi and s[j].fi < b[minxi].fi) minxi = 0;
            if (maxyi != 0 and b[i].fi == s[j].fi and s[j].se < b[i].se and s[j].se > b[maxyi].se) maxyi = 0;
            if (minyi != 0 and b[i].fi == s[j].fi and s[j].se > b[i].se and s[j].se < b[minyi].se) minyi = 0;
        }

        temp.emplace_back(0, make_pair(b[i].fi - 1, b[i].se));
        if (maxxi != 0)
        {
            d[maxxi] = 1;
            Rec(cnt + 1, rem - 2);
            d[maxxi] = 0;
        }
        else Rec(cnt + 1, rem - 1);
        temp.pop_back();

        temp.emplace_back(0, make_pair(b[i].fi + 1, b[i].se));
        if (minxi != 0)
        {
            d[minxi] = 1;
            Rec(cnt + 1, rem - 2);
            d[minxi] = 0;
        }
        else Rec(cnt + 1, rem - 1);
        temp.pop_back();

        temp.emplace_back(1, make_pair(b[i].fi, b[i].se - 1));
        if (maxyi != 0)
        {
            d[maxyi] = 1;
            Rec(cnt + 1, rem - 2);
            d[maxyi] = 0;
        }
        else Rec(cnt + 1, rem - 1);
        temp.pop_back();

        temp.emplace_back(1, make_pair(b[i].fi, b[i].se + 1));
        if (minyi != 0)
        {
            d[minyi] = 1;
            Rec(cnt + 1, rem - 2);
            d[minyi] = 0;
        }
        else Rec(cnt + 1, rem - 1);
        temp.pop_back();

        d[i] = 0;
    }
}

int main()
{
    Init();
    Rec();

    cout << ans << endl;
    for (int i = 0; i < ans; ++ i)
    {
        cout << bombs[i].fi << ' ' << bombs[i].se.fi << ' '<< bombs[i].se.se << endl;
    }
    return 0;
}
