#include <bits/stdc++.h>

using namespace std;

const int maxn = 400003;

int n, m;
pair <int, int> boxes[maxn], rocks[maxn];
void read()
{
    cin >> n;

    for (int i = 1; i <= n; i++)
        cin >> boxes[i].first >> boxes[i].second;

    cin >> m;

    for (int i = 1; i <= m; i++)
        cin >> rocks[i].first >> rocks[i].second;
}

struct bomb
{
    int x, y;
    bool h;

    bomb() {}
    bomb(int _x, int _y, bool _h) {x = _x, y = _y, h = _h;}
};

set <int> boxes1, boxes2, rocks1, rocks2;
vector <bomb> ans;
void solve()
{
    for (int i = 1; i <= n; i++)
    {
        if (boxes[i].first == 2)
            boxes1.insert(boxes[i].second);

        else
            boxes2.insert(boxes[i].second);
    }

    for (int i = 1; i <= m; i++)
    {
        if (rocks[i].first == 2)
            rocks1.insert(rocks[i].second);

        else
            rocks2.insert(rocks[i].second);
    }

    vector <int> to_erase;
    for (auto i: boxes1)
    {
        if (boxes2.find(i) != boxes2.end())
            to_erase.push_back(i);
    }

    for (auto i: to_erase)
    {
        ans.push_back(bomb(3, i, 0));
        boxes1.erase(boxes1.find(i));
        boxes2.erase(boxes2.find(i));
    }

    while (!boxes1.empty())
    {
        auto first = *boxes1.begin();
        if (boxes1.size() == 1)
        {
            ans.push_back(bomb(2, first + 1, 1));
            break;
        }

        auto second = *next(boxes1.begin());

        auto it = rocks1.lower_bound(first);
        if (it != rocks1.end() && *it < second)
        {
            ans.push_back(bomb(2, first + 1, 1));
            boxes1.erase(boxes1.begin());
        }

        else
        {
            ans.push_back(bomb(2, first + 1, 1));
            boxes1.erase(boxes1.begin());
            boxes1.erase(boxes1.begin());
        }
    }

    while (!boxes2.empty())
    {
        auto first = *boxes2.begin();
        if (boxes2.size() == 1)
        {
            ans.push_back(bomb(4, first + 1, 1));
            break;
        }

        auto second = *next(boxes2.begin());

        auto it = rocks2.lower_bound(first);
        if (it != rocks2.end() && *it < second)
        {
            ans.push_back(bomb(4, first + 1, 1));
            boxes2.erase(boxes2.begin());
        }

        else
        {
            ans.push_back(bomb(4, first + 1, 1));
            boxes2.erase(boxes2.begin());
            boxes2.erase(boxes2.begin());
        }
    }

    cout << ans.size() << endl;

    for (auto i: ans)
        cout << i.h << " " << i.x << " " << i.y << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
