#include <bits/stdc++.h>

using namespace std;

const int maxn = 100003;

int n;
pair <int, int> f[maxn], s[maxn];
void read()
{
    cin >> n;

    for (int i = 1; i <= n; i++)
        cin >> f[i].first>> f[i].second >> s[i].first >> s[i].second;
}

struct triple
{
    int l, r, idx;

    triple() {}
    triple(int _l, int _r, int _idx) {l = _l, r = _r, idx = _idx;}
};

bool cmp(triple a, triple b)
{
    if (a.l != b.l)
    return a.l < b.l;

    return a.r < b.r;
}

vector <triple> v;
int ans[maxn];
map <int, bool> is;
void solve()
{
    for (int i = 1; i <= n; i++)
    v.push_back(triple(f[i].first, s[i].first, i));

    sort (v.begin(), v.end(), cmp);
    for (auto i: v)
    {
        if (is.count(i.l) && is.count(i.r))
        {
            cout << "No" << endl;
            return;
        }

        if (!is.count(i.l))
        {
            is[i.l] = true;
            ans[i.idx] = 1;
        }

        else
        {
            is[i.r] = true;
            ans[i.idx] = 2;
        }
    }

    cout << "Yes" << endl;

    for (int i = 1; i <= n; i++)
        cout << ans[i] << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}

/*
3
0 0 1 6
2 2 3 4
1 3 5 5
*/

/*
3
0 0 1 6
2 2 3 4
0 0 1 3
*/

/*
4
2 2 3 3
0 0 4 4
0 0 1 1
1 1 2 2
*/

/*
10
21 22 33 35
16 18 26 27
9 10 14 23
0 1 15 34
12 17 19 32
4 28 30 38
5 6 13 31
2 3 20 37
24 25 29 36
7 8 11 39
*/
