#include <bits/stdc++.h>

using namespace std;

const int maxn = 400003;

int n, m;
pair <int, int> boxes[maxn], rocks[maxn];
void read()
{
    cin >> n;

    for (int i = 1; i <= n; i++)
        cin >> boxes[i].first >> boxes[i].second;

    cin >> m;

    for (int i = 1; i <= m; i++)
        cin >> rocks[i].first >> rocks[i].second;
}

pair <int, bool> dp[1024];
pair <int, int> par[1024];

int f(int mask)
{
    if (mask == 0)
        return 0;

    if (dp[mask].second)
        return dp[mask].first;

    dp[mask].second = true;
    dp[mask].first = INT_MAX;

    for (int i = 0; i < n; i++)
        if (mask & (1 << i))
        if (f(mask - (1 << i)) + 1 < dp[mask].first)
    {
        dp[mask].first = f(mask - (1 << i)) + 1;
        par[mask] = {i, -1};
    }

    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
        if (i != j && (mask & (1 << i)) && (mask & (1 << j)))
    {
        if (boxes[i+1].first == boxes[j+1].first)
        {
            bool can = true;
            for (int k = 0; k < n; k++)
                if (k != i && k != j && (mask & (1 << k)))
                    if (boxes[k+1].first == boxes[i+1].first && boxes[k+1].second > min(boxes[i+1].second, boxes[j+1].second) && boxes[k+1].second < max(boxes[i+1].second, boxes[j+1].second))
            {
                can = false;
                break;
            }

            for (int k = 1; k <= m; k++)
            if (rocks[k].first == boxes[i+1].first && rocks[k].second > min(boxes[i+1].second, boxes[j+1].second) && rocks[k].second < max(boxes[i+1].second, boxes[j+1].second))
            {
                can = false;
                break;
            }

            if (can && f(mask - (1 << i) - (1 << j)) + 1 < dp[mask].first)
            {
                dp[mask].first = f(mask - (1 << i) - (1 << j)) + 1;
                par[mask] = {i, j};
            }
        }

        else
            if (boxes[i+1].second == boxes[j+1].second)
        {
            bool can = true;
            for (int k = 0; k < n; k++)
                if (k != i && k != j && (mask & (1 << k)))
                    if (boxes[k+1].second == boxes[i+1].second && boxes[k+1].first > min(boxes[i+1].first, boxes[j+1].first) && boxes[k+1].first < max(boxes[i+1].first, boxes[j+1].first))
            {
                can = false;
                break;
            }

            for (int k = 1; k <= m; k++)
            if (rocks[k].second == boxes[i+1].second && rocks[k].first > min(boxes[i+1].first, boxes[j+1].first) && rocks[k].first < max(boxes[i+1].first, boxes[j+1].first))
            {
                can = false;
                break;
            }

            if (can && f(mask - (1 << i) - (1 << j)) + 1 < dp[mask].first)
            {
                dp[mask].first = f(mask - (1 << i) - (1 << j)) + 1;
                par[mask] = {i, j};
            }
        }
    }

    return dp[mask].first;
}

void solve()
{
    int curr_mask = (1 << n) - 1;
    cout << f(curr_mask) << endl;

    while (curr_mask)
    {
        auto curr = par[curr_mask];
        if (curr.second == -1)
        {
            cout << 1 << " " << boxes[curr.first + 1].first << " " << boxes[curr.first + 1].second + 1 << endl;
            curr_mask -= (1 << curr.first);
            continue;
        }

        else
        {
            if (boxes[curr.first + 1].first == boxes[curr.second + 1].first)
            {
                if (boxes[curr.first + 1].second < boxes[curr.second + 1].second)
                    cout << 1 << " " << boxes[curr.first + 1].first << " " << boxes[curr.first + 1].second + 1 << endl;

                else
                    cout << 1 << " " << boxes[curr.first + 1].first << " " << boxes[curr.first + 1].second - 1 << endl;
            }

            else
            {
                if (boxes[curr.first + 1].first < boxes[curr.second + 1].first)
                    cout << 1 << " " << boxes[curr.first + 1].first + 1 << " " << boxes[curr.first + 1].second << endl;

                else
                    cout << 1 << " " << boxes[curr.first + 1].first - 1 << " " << boxes[curr.first + 1].second << endl;
            }

            curr_mask -= (1 << curr.first) + (1 << curr.second);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}

/*
8
6 2
11 4
2 9
6 7
4 9
6 4
6 9
11 9
2
11 7
8 9
*/
