#include<iostream>
#include<algorithm>

using namespace std;

const int MAXN = 2e6 + 5;

int n;
int a[MAXN];

int l1;
int n1[MAXN];

int l2;
int n2[MAXN];

void add(int x)
{
    l1 = 0;
    for(int i = 0;i<=100;i++) n1[i] = 0;

    while(x!=0)
    {
        n1[l1] = x%2;

        l1++;
        x/=2;
    }

    for(int i = 0;i<=n+5;i++) n2[i] = 0;

    l2 = max(n, l1);
    for(int i = 0;i<l2;i++)
    {
        n2[i] += a[i] + n1[i];

        n2[i+1] += n2[i]/2;
        n2[i] %= 2;
    }

    if(n2[l2]!=0) l2++;
}

int cntOnes()
{
    int cnt = 0;
    for(int i = 0;i<l2;i++) cnt += n2[i];

    return cnt;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    int expected = n/2 + n%2;

    for(int i = 1;i<=n;i++)
    {
        a[i-1] = i%2;
    }

    reverse(a, a+n);

    int ans = 0;
    bool hasExpected = false, hasSolution = false;

    for(int i = max(n/2-100, 1);i<=min(n, n/2+100);i++)
    {
        add(i);
        if(cntOnes()==i)
        {
            cout << i << '\n';
            return 0;
        }
    }

    cout << "0" << '\n';
}
