#include<iostream>
#include<vector>
#include<set>

using namespace std;

set <pair <int, int>> row2, row4;
vector <pair <int, int>> answer1, answer2;

int main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(NULL);

    int n = 1000;
    cin >> n;
    for(int i = 0;i<n;i++)
    {
        int x = 2, y = 2*i + 1;
        cin >> x >> y;

        if(x==2) row2.insert({y, 0});
        else if(x==4) row4.insert({y, 0});
        else cout << 1/0 << '\n';
    }

    int m = 0;
    cin >> m;
    for(int i = 0;i<m;i++)
    {
        int x, y;
        cin >> x >> y;

        if(x==2) row2.insert({y, 1});
        else if(x==4) row4.insert({y, 1});
        else cout << 1/0 << '\n';
    }

    set <int> toRemove;
    for(auto it = row2.begin();it!=row2.end();it++)
    {
        if(it->second==1) continue;
        if(row4.count(*it)==true)
        {
            toRemove.insert(it->first);
            answer1.push_back({3, it->first});
        }
    }

    for(auto it = toRemove.begin();it!=toRemove.end();it++)
    {
        row2.erase({*it, 0});
        row4.erase({*it, 0});
    }

    while(row2.empty()==false)
    {
        auto it1 = row2.begin();
        if(it1->second==1)
        {
            row2.erase(it1);
            continue;
        }
        auto it2 = it1;it2++;

        answer2.push_back({2, it1->first+1});
        row2.erase(row2.begin());

        if(row2.empty()==false && row2.begin()->second==0)
        {
            row2.erase(row2.begin());
        }
    }

    while(row4.empty()==false)
    {
        auto it1 = row4.begin();
        if(it1->second==1)
        {
            row4.erase(it1);
            continue;
        }
        auto it2 = it1;it2++;

        answer2.push_back({2, it1->first+1});
        row4.erase(row4.begin());

        if(row4.empty()==false && row4.begin()->second==0)
        {
            row4.erase(row4.begin());
        }
    }

    cout << answer1.size() + answer2.size() << '\n';
    for(pair <int, int> x: answer1)
    {
        cout << "0 " << x.first << " " << x.second << '\n';
    }
    for(pair <int, int> x: answer2)
    {
        cout << "1 " << x.first << " " << x.second << '\n';
    }
}
/*
6
2 1
2 5
2 9
4 1
4 11
4 13
3
2 3
4 3
2 7
*/
