#include<iostream>
#include<vector>
#include<algorithm>
//#pragma optimize "gcc -Ofast"
using namespace std;
struct component
{
    long long i;
    vector<long long>vurhove,susedi;
};
struct singer{
    long long i,a,b,c,d;
};
struct pair2SAT{
    bool isa,isb;
    long long a,b;
};
struct concert{
    long long i,a,b;
    bool operator <(concert a)const{
        if(this->a==a.a){
            return this->b<a.b;
        }else{
            return this->a<a.a;
        }
    }
};
vector<concert>cons;
vector<long long>susedi[2000000],revsusedi[2000000];
vector<long long>dfsorder,comporder;
vector<singer>singers;
vector<component>comps;
vector<pair2SAT>input;
long long vcomp[2000000];
bool visited[2000000];
void dfs(long long v)
{
    if(visited[v])
    {
        return;
    }
    visited[v]=1;
    for(long long i=0; i<susedi[v].size(); i++)
    {
        dfs(susedi[v][i]);
    }
    dfsorder.push_back(v);
}
void revdfs(long long v,long long c)
{
    if(visited[v])
    {
        return;
    }
    visited[v]=1;
    vcomp[v]=c;
    comps[c].vurhove.push_back(v);
    //cout<<""
    for(long long i=0; i<revsusedi[v].size(); i++)
    {
        if(visited[revsusedi[v][i]] && vcomp[revsusedi[v][i]]!=c){
            comps[vcomp[revsusedi[v][i]]].susedi.push_back(c);
        }else{
            revdfs(revsusedi[v][i],c);
        }
    }
}
void compdfs(long long v){
    if(visited[v]){
        return;
    }
    visited[v]=1;
    for(long long i=0;i<comps[v].susedi.size();i++){
        compdfs(comps[v].susedi[i]);
    }
    comporder.push_back(v);
}
bool intersect(long long a,long long b,long long c,long long d){
    if(min(b,d)<max(a,c))return 0;
    return 1;
}
long long state[10005];
int main()
{
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);
    long long n,m;
    cin>>m;
    n=m*2;
    /*for(int i=0;i<m;i++){
        singer a;
        a.i=i;
        cin>>a.a>>a.b>>a.c>>a.d;
        singers.push_back(a);
    }*/
    for(long long i=0;i<m;i++){
        long long a,b,c,d;
        concert e,f;
        cin>>a>>b>>c>>d;
        e.i=i*2;
        f.i=i*2+1;
        e.a=a;
        e.b=b;
        f.a=c;
        f.b=d;
        cons.push_back(e);
        cons.push_back(f);
    }
    for(long long i=0;i<m;i++){
        input.push_back({1,1,i*2,i*2+1});
    }
    sort(cons.begin(),cons.end());
    for(long long i=0;i<n;i++){
        for(long long j=i+1;j<n;j++){
            if(intersect(cons[i].a,cons[i].b,cons[j].a,cons[j].b)){
                input.push_back({0,0,cons[i].i,cons[j].i});
            }
            if(cons[j].a>cons[i].b){
                break;
            }
        }
    }

    /*for(int i=0;i<m;i++){
        for(int j=i+1;j<m;j++){
            if(intersect(singers[i].a,singers[i].b,singers[j].a,singers[j].b)){
                input.push_back({0,0,singers[i].i*2,singers[j].i*2});
            }
            if(intersect(singers[i].a,singers[i].b,singers[j].c,singers[j].d)){
                input.push_back({0,0,singers[i].i*2,singers[j].i*2+1});
            }
            if(intersect(singers[i].c,singers[i].d,singers[j].a,singers[j].b)){
                input.push_back({0,0,singers[i].i*2+1,singers[j].i*2});
            }
            if(intersect(singers[i].c,singers[i].d,singers[j].c,singers[j].d)){
                input.push_back({0,0,singers[i].i*2+1,singers[j].i*2|1});
            }
        }
    }*/
    for(long long i=0; i<input.size(); i++)
    {
        long long a,b;
        bool isa,isb;
        //cin>>isa>>a>>isb>>b;
        isa=input[i].isa;
        isb=input[i].isb;
        a=input[i].a;
        b=input[i].b;
        //cout<<isa<<" "<<a<<" "<<isb<<" "<<b<<endl;
        susedi[a*2+isa].push_back(b*2+!isb);
        susedi[b*2+isb].push_back(a*2+!isa);
        revsusedi[a*2+!isa].push_back(b*2+isb);
        revsusedi[b*2+!isb].push_back(a*2+isa);
    }
    for(long long i=0; i<n*2; i++)
    {
        dfs(i);
    }
    for(long long i=0;i<n*2;i++){
        visited[i]=0;
    }
    for(long long k=dfsorder.size()-1; k>=0; k--)
    {
        long long i=dfsorder[k];
        if(!visited[i]){
            component ccomp;
            ccomp.i=comps.size();
            comps.push_back(ccomp);
            //cout<<"a"<<endl;
            revdfs(i,ccomp.i);
        }
    }
    for(long long i=0;i<n*2;i++){
        visited[i]=0;
    }
    for(long long i=0;i<comps.size();i++){
        compdfs(i);
    }
    for(long long i=0;i<comporder.size();i++){
        for(long long j=0;j<comps[i].vurhove.size();j++){
            long long v=comps[i].vurhove[j];
            long long rv=v/2;
            long long vstate=v%2+1;
            if(state[rv]==0){
                state[rv]=vstate;
            }else if(vcomp[rv*2]==vcomp[rv*2+1]){
                //while(1);
                cout<<"No"<<endl;
                return 0;
            }
        }
    }
    cout<<"Yes"<<endl;
    //while(1);
    for(long long i=0;i<m;i++){
        if(state[i*2+1]==0){
            while(1);
        }
        cout<<state[i*2+1]<<endl;
    }
    std::cout.flush();
    return 0;
}
//cherven karton za mario metushev i ...
