#include <iostream>
#include <bitset>
#include <unordered_map>
#include <map>

#pragma GCC optimize "Ofast"
using std::cin; using std::cout; using std::endl;

/*
№1->res   carry
0 -> 0      0
1 -> 1      0
2 -> 0      1
3 -> 1      1
4 -> 0      2
5 -> 1      2
6 -> 0      3
7 -> 1      3
*/

int n;
inline bool isone(int index) {
	return (n - index) % 2;
}

bool poss(int index, int prev_carry, int last_ones) {
	int target = isone(index);
	if(index == n-1) return last_ones == 1 and prev_carry == target;

	//if(index == n) return prev_carry == 0 and last_ones == 1;
	//cout << "call " << index << ' ' << prev_carry << ' ' << last_ones << endl;

	int from;
	if(target == prev_carry % 2) { // ones % 2 = 0
		from = 0;
	} else { // ones % 2 = 1
		from = 1;
	}

	if(last_ones % 2 == from) {
		return poss(index + 1, (last_ones + prev_carry) / 2, last_ones);
	}

	return poss(index + 1, (last_ones-1 + prev_carry) / 2, last_ones - 1);
}


int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);
	
	cin >> n;

	const int CF = 10;
	int bottom = n/2 - CF;
	if(bottom < 0) bottom = 0;
	for(int i = bottom;i < n/2 + 8;i ++) {
		if(poss(0, 0, i)) {
			cout << i << endl;
			return 0;
		}
	}
	cout << 0 << endl;

	return 0;
}