#include<bits/stdc++.h>
#define ll long long
using namespace std;
struct node
{
    ll x,y;
    vector<int> adj;
    node(ll a,ll b)
    {
        x=a;
        y=b;
    }
    node()
    {
        x=0;
        y=0;
    }
};
ll n,m;
queue<pair<pair<ll,ll>,bool>> ans;
bool killed[2000];
node points[2000];
node stones[2000];
int dfs(int curr,int prev,bool bomb)
{
    if(killed[curr])
    {
        return 0;
    }
    bool once=true;
    for(int i=0;i<points[curr].adj.size();i++)
    {
        if(prev!=points[curr].adj[i] and !killed[points[curr].adj[i]])
        {
            if(bomb and once)
            {
                once=false;
                ans.push({{(points[curr].x+points[points[curr].adj[i]].x)/2,(points[curr].y+points[points[curr].adj[i]].y)/2},points[curr].y==points[points[curr].adj[i]].y});
                killed[curr]=1;
                killed[points[curr].adj[i]]=1;
                dfs(points[curr].adj[i],curr,!bomb);
            }


        }else
            dfs(points[curr].adj[i],curr,bomb);
    }
    killed[curr]=1;
    ans.push({{points[curr].x+1,points[curr].y},0});
    return 1;
}
int main()
{
    ll u,v;
    cin>>n;
    for(ll i=0;i<n;i++)
    {
        cin>>u>>v;
        points[i].x=u;
        points[i].y=v;
    }
    cin>>m;
    for(ll i=0;i<m;i++)
    {
        cin>>u>>v;
        stones[i].x=u;
        stones[i].y=v;
    }
    for(ll a=0;a<n-1;a++)
    {
        for(ll b=a+1;b<n;b++)
        {
            //cout<<a<<" "<<b<<endl;
            if(points[a].x==points[b].x)
            {
                bool ok =true;
                for(int j=0;j<m;j++)
                {
                    if(points[a].x!=stones[j].x)
                    {
                        continue;
                    }
                    if((points[a].y<stones[j].y and stones[j].y<points[b].y)or(points[a].y>stones[j].y and stones[j].y>points[b].y))
                    {
                        ok=false;
                        break;
                    }
                }
                if(ok)
                {
                    points[a].adj.push_back(b);
                    points[b].adj.push_back(a);
                }
            }
            if(points[a].y == points[b].y)
            {
                bool ok =true;
                for(int j=0;j<m;j++)
                {
                    if(points[a].y!=stones[j].y)
                    {
                        continue;
                    }
                    if((points[a].x<stones[j].x and stones[j].x<points[b].x)or(points[a].x>stones[j].x and stones[j].x>points[b].x))
                    {
                        ok=false;
                        break;
                    }
                }
                if(ok)
                {
                    points[a].adj.push_back(b);
                    points[b].adj.push_back(a);
                }
            }
        }
    }
    ll res=0;
    for(int i=0;i<n;i++)
    {
        if(!killed[i])
        {
            res+=dfs(i,-1,1);
        }
    }
    cout<<ans.size()<<endl;
    while(!ans.empty())
    {
        pair<pair<ll,ll>,bool> tt=ans.front();
        ans.pop();
        cout<<tt.second<<" "<<tt.first.first<<" "<<tt.first.second<<endl;
    }
    return 0;
}
