#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 400004
using namespace std;
int n, m;

struct point
{
    bool t;
    int x, y;
    point () {}
    point (int _x, int _y, bool _t = 0)
    {
        x = _x;
        y = _y;
        t = _t;
    }
};

bool cmp_x(point q, point p)
{
    if (q.x < p.x)
        return 1;
    if (q.x > p.x)
        return 0;
    if (q.y < p.y)
        return 1;
    return 0;
}

bool cmp_y(point q, point p)
{
    if (q.y < p.y)
        return 1;
    if (q.y > p.y)
        return 0;
    if (q.x < p.x)
        return 1;
    return 0;
}



vector <point> v;
vector <point> d;
bool used[2*MAXN];

void input()
{
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        int x, y;
        cin >> x >> y;
        v.push_back(point(x, y, 1));
    }
    cin >> m;
    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;
        v.push_back(point(x, y, 0));
    }
}

vector <point> ans;

void solve()
{
    sort(v.begin(), v.end(), cmp_x);
    for (int i = 0; i < n + m - 1; ++i)
        if(v[i].t && v[i+1].t)
        {
            if (v[i].x == v[i+1].x)
            {
                ans.push_back(point(v[i].x, v[i].y + 1, 1));
                used[i] = 1;
                used[i+1] = 1;
            }
        }
    for (int i = 0; i < n + m; ++i)
        if (!used[i])
            d.push_back(v[i]);
    sort(d.begin(), d.end(), cmp_y);
    for (int i = 0; i < d.size() - 1; ++i)
        if (d[i].t && d[i+1].t)
        {
            if (d[i].y == d[i+1].y)
            {
                ans.push_back(point(d[i].x + 1, d[i].y, 0));
                used[i] = 1;
                used[i+1] = 1;
            }
        }
    for (int i = 0; i < d.size(); ++i)
        if (!used[i] && d[i].t)
            ans.push_back(point(d[i].x, d[i].y + 1, 1));
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i)
        cout << ans[i].t << " " << ans[i].x << " " << ans[i].y << endl;
}

/**
8
6 2
11 4
2 9
6 7
4 9
6 4
6 9
11 9
2
11 7
8 9

*/

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
