#include <iostream>
#include <cstdio>
#include <cstdlib>
using namespace std;

#define NMax 100000

int n, a[NMax + 2], b[NMax + 2], c[NMax + 2], d[NMax + 2];

bool intersect(int tb1, int te1, int tb2, int te2)
{
    if(te1 < tb2 || te2 < tb1) return 0;
    return 1;
}

void solve(string s)
{
    if(s.size() == n)
    {
        bool ok = 1;
        for(int i = 0; i < n; i++)
            for(int j = i+1; j < n; j++)
            {
                bool res;

                if(s[i] == '1' && s[j] == '1') res = intersect(a[i], b[i], a[j], b[j]);
                else if(s[i] == '1' && s[j] == '2') res = intersect(a[i], b[i], c[j], d[j]);
                else if(s[i] == '2' && s[j] == '1') res = intersect(c[i], d[i], a[j], b[j]);
                else if(s[i] == '2' && s[j] == '2') res = intersect(c[i], d[i], c[j], d[j]);

                if(res == 1)
                {
                    ok = 0;
                    break;
                }
            }

        if(ok == 1)
        {
            printf("Yes\n");
            for(int i = 0; i < s.size(); i++)
                printf("%c\n", s[i]);
            exit(0);
        }
        return ;
    }

    solve(s + "1");
    solve(s + "2");
}

int main()
{
    scanf("%d", &n);

    for(int i = 0; i < n; i++)
        scanf("%d%d%d%d", &a[i], &b[i], &c[i], &d[i]);

    solve("");

    printf("No\n");

    return 0;
}
/**
10
21 22 33 35
16 18 26 27
9 10 14 23
0 1 15 34
12 17 19 32
4 28 30 38
5 6 13 31
2 3 20 37
24 25 29 36
7 8 11 39
*/
