#include <iostream>
#include <cstdio>
using namespace std;

string inttobin(int n)
{
    string s = "";

    while(n)
    {
        s = char(n%2 + '0') + s;
        n >>= 1;
    }

    return s;
}

string sumbin(string a, string b)
{
    string c = "";
    while(a.size() < b.size()) a = "0" + a;
    while(b.size() < a.size()) b = "0" + b;

    int naum = 0;
    for(int i = a.size()-1; i >= 0; i--)
    {
        int cur = (a[i] - '0') + (b[i] - '0') + naum;
        c = char(cur % 2 + '0') + c;
        naum = cur >> 1;
    }

    return c;
}

int cntbin1(string a)
{
    int cnt = 0;
    for(int i = 0; i < a.size(); i++)
        if(a[i] == '1') cnt++;

    return cnt;
}

int n;

int main()
{
    string init = "";
    scanf("%d", &n);

    if(n == 1)
    {
        printf("1\n");
        return 0;
    }

    if(n < 60)
    {
        for(int i = 0; i < n; i++)
        {
            if(i%2 == 0) init += "1";
            else init += "0";
        }

        for(int i = 1; i < n; i++)
        {
            string cur = sumbin(init, inttobin(i));
            if(cur[cur.size() - 1] == '0' && cntbin1(cur) == i)
            {
                printf("%d\n", i);
                return 0;
            }
        }

        printf("0\n");
    }
    else if(n % 2 == 0)
    {
        for(int i = 0; i < 64; i++)
        {
            if(i%2 == 0) init += "1";
            else init += "0";
        }
        for(int i = max(n/2 - 10, 1); i <= n/2 + 10; i++)
        {
            string cur = sumbin(init, inttobin(i));

            if(cur[cur.size() - 1] == '0' && cntbin1(cur) + (n - 64)/2 == i)
            {
                printf("%d\n", i);
                return 0;
            }
        }

        printf("0\n");
    }

    else if(n % 2 == 1)
    {
        for(int i = 0; i < 65; i++)
        {
            if(i%2 == 0) init += "1";
            else init += "0";
        }
        for(int i = max(n/2 - 10, 1); i <= n/2 + 10; i++)
        {
            string cur = sumbin(init, inttobin(i));

            if(cur[cur.size() - 1] == '0' && cntbin1(cur) + (n - 65)/2 == i)
            {
                printf("%d\n", i);
                return 0;
            }
        }

        printf("0\n");
    }

    return 0;
}
