#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl "\n"
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

int len;
long long num;

int f(long long num, int last = len) {
	if (num == 0) {
		return 0;
	}

	int answer = 0;
	for (int i = last; i >= 1; i--) {
		long long add = (1 << i) - 1;

		if (add <= num) {
			answer = max(answer, f(num - add, i - 1) + 1);
		}
	}

	return answer;
}

bool possible(long long num, int last = len) {
	if (num == 0) {
		return true;
	}

	for (int i = last; i >= 1; i--) {
		long long add = (1 << i) - 1;

		if (add <= num) {
			if (possible(num - add, i - 1)) {
				return true;
			}
		}
	}

	return false;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);

	cin >> len;

	num = 0;
	for (int i = 0; i < len; i++) {
		num <<= 1;
		if ((i & 1) == 0) {
			num++;
		}
	}

	cout << (possible(num) ? f(num) : 0) << endl;

	return EXIT_SUCCESS;
}