#pragma GCC optimize("O3, Ofast , unroll-loops")
#pragma target("avx2")
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
#define pb push_back
#define pii pair<int,int>
using namespace std;
//using namespace __gnu_pbds;
const int inf = 1e9+5;
typedef long long ll;
typedef unsigned int uint;
const ll linf = 1e18+5;
//typedef tree<int, null_type , less<int> , rb_tree_tag , tree_order_statistics_node_update> ordset;
int n;
//ordset st;
int rez ;
bitset <1000005> nr;
int sg[4000005], lz[4000005];
void build(int nod  , int l , int r){
	if(l == r){
		sg[nod] = nr[l];
	}
	int mid = (l+r)/2;
	build(nod*2,l,mid);
	build(nod*2+1,mid+1,r);
	sg[nod] = sg[nod*2] + sg[nod*2 + 1];
}
void update_nod(int nod){
	if(lz[nod] == 1){
		lz[nod] = 0;
		sg[nod] = 0;
		lz[nod*2] = 1;
		lz[nod*2+1] = 1;
	}
}
int query(int nod , int l , int r , int lt , int rt){
	if(l > r ||  rt < l || lt > r){return 0;}
	update_nod(nod);
	if(lt >= l && rt <= r)return sg[nod];
	int mid = (lt+rt)/2
	return query(nod*2,l,r,lt,mid) + query(nod*2+1,l,r,mid+1,rt);
}
void set_0(int nod, int l , int r , int lt , int rt){
	if(lt > rt || rt < l || lt > r){return ;}
	if(lt >= l && rt <= r){
		lz[nod] = 1;
		update_nod(nod);
	}
	int mid = (lt+rt)/2;
	set_0(nod*2,l,r,lt,mid);
	set_0(nod*2+1,l,r,mid+1,rt);
	sg[nod] = sg[nod*2] + sg[nod*2 + 1];
}
void update(int nod , int pos , int l , int r, int val){
	if(pos < l || pos > r || l > r){
		return ;
	}
	update_nod(nod);
	sg[nod] += val;
	if(l != r){
		int mid = (l+r)/2;
		update(nod*2,pos,l,mid);
		update(nod*2+1,pos,mid+1,r);
	}
}
int find_val(int nod , int l , int r , int val){
	update_nod(nod);
	if(l == r){
		if(sg[nod] == val)return l;
	}
	update_nod(2*nod);
	update_nod(2*nod+1);
	int mid = (l+r)/2;
	if(sg[2*nod] < val){
		return find_val(2*nod +1 , mid + 1 , r  , val - sg[2*nod]);
	}else{
		return find_val(2*nod , l , mid , val);
	}
}
int find_first_zero(int nod , int l , int r , int val){
	update_nod(nod);
	if(l == r){
		if(sg[l] == 0 && l - 1 == val)return l;
	}
	int mid = (l+r)/2;
	update_nod(2*nod);
	update_nod(2*nod+1);
	if(sg[2*nod] < mid - val){
		return find_first_zero(nod*2 , l , mid , val);
	}else{
		return find_first_zero(nod*2 + 1 , mid + 1 , r , val + sg[nod*2]);
	}
}
int rec(){
	++rez;
	int bits = query(1,1,n,1,n);
	if(!bits){
		return 0;
	}
	bool check;
	if(query(1,1,n,1,bits) == bits){
		return 1;
	}
	if(query(1,1,n,1,1) == 0 && query(1,1,n,1,bits) == bits){
		return 0;
	}
	int last_bit = find_val(1,1,n,bits);

	// cautam pozitia in care query(1,1,n,1,pos) = bits && query(1,1,n,1,pos-1) = 0

	update(1,last_bit,1,n, -1);
	// set nr[base] = 0;
	int frzero = find_first_zero(1,1,n,0);
	update(1,frzero,1,n,1);
	set_0(1,1 , frzero - 1, 1, n);
	return rec();
}
int main(){
	cin >> n;
	bitset <1000001> nr; 
	build(1,1,n);
	for(ll i = 0 ; i < n ; i++){
		if(i % 2 != n % 2){
			nr[i] = 1 ;
		}
	}
	if(rec()){
		cout << rez << '\n';
	}else{
		cout << 0 << '\n';
	}
	return 0;
	/*for(int i = 1;  i <= (1 << 10) ; i++){
		if(__builtin_popcount(i+1) == 1){
			dp[i] = 1;
			continue;
		}
		int base = 1;
		while(base < i){
			base  = base << 1;
		}
		base  = base >> 1;
		dp[i] = dp[i - base + 1];
	}
	for(int i = 1; i <= (1<<10); i++){
		for(int k = 0 ; k < 10 ; k++){
			cout << (i&(1<<k) ? 1 : 0) << ' ';
		}
		cout << "res: " << dp[i] << '\n';
	}
	*/
}