#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using namespace std;

#define pb push_back
#define dbg(x) cerr << #x << " " << x << "\n"
#define get_here() cerr << "-1\n"
typedef long long ll;

struct Concert {
    int a;
    int b;
    int c;
    int d;
};
struct Interval {
    int x;
    int y;
    int type;
    int ind;
};

const int N = 3e5;
Concert con[1 + N];
bool ok;
vector <int> path;
vector <Interval> v;
int viz[1 + N];
int go[1 + N];
int pos[1 + N][3];
int nxt[1 + N];
vector <int> b;
void dfs (int x) {
    if (!ok)
        return;
    path.pb (v[x].ind);
    viz[v[x].ind] = v[x].type;
    for (int y = x + 1; y < v.size (); y++) {
        if (v[y].x > v[x].y)
            break;
        if (viz[v[y].ind] == 0) {
            dfs (go[y]);
        }
        else if (viz[v[y].ind] == v[y].type)
            ok = false;
        if (!ok)
            return;
    }
    for (int j = nxt[x] - 1; j >= 0; j--) {
        int y = b[j];
        if (v[y].y < v[x].x)
            break;
        if (viz[v[y].ind] == 0) {
            dfs (go[y]);
        }
        else if (viz[v[y].ind] == v[y].type)
            ok = false;
        if (!ok)
            return;
    }
}
bool incearca (int x) {
    ok = true;
    path.clear ();
    dfs (x);
    if (!ok)
        for (auto  y : path)
            viz[y] = 0;
    return ok;
}

bool cmp (Interval a, Interval b) {
    if (a.x != b.x)
        return a.x < b.x;
    return a.y < b.y;
}
bool cmp2 (int a, int b) {
    if (v[a].y != v[b].y)
        return v[a].y < v[b].y;
    return v[a].x < v[b].x;
}
int main () {
    ios::sync_with_stdio (false);
    cin.tie (0); cout.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> con[i].a >> con[i].b >> con[i].c >> con[i].d;
        v.pb ({con[i].a, con[i].b, 1, i});
        v.pb ({con[i].c, con[i].d, 2, i});
    }
    sort (v.begin (), v.end (), cmp);
    for (int i = 0; i < v.size (); i++) {
        pos[v[i].ind][v[i].type] = i;
        b.pb (i);
    }
    sort (b.begin (), b.end (), cmp2);
    for (int i = 0 ;i < b.size (); i++) {
        nxt[b[i]] = i;
    }
    for (int i = 0; i < v.size (); i++) {
        int tt;
        if (v[i].type == 1)
            tt = 2;
        else
            tt = 1;
        go[i] = pos[v[i].ind][tt];
    }
    for (int i = 0; i < v.size (); i++) {
        if (viz[v[i].ind] == 0) {
            bool ok = false;
            for (int j = i; j < v.size (); j++) {
                if (v[j].x > v[i].y)
                    break;
                bool t = incearca (j);
                if (t) {
                    ok = true;
                    break;
                }
            }
            if (!ok)
                for (int k = nxt[i] - 1; k >= 0; k--) {
                    int j = b[k];
                    if (v[j].y < v[i].x)
                        break;
                    bool t = incearca (j);
                    if (t) {
                        ok = true;
                        break;
                    }
                }
            if (!ok) {
                cout << "No\n";
                return 0;
            }
        }
    }
    cout << "Yes\n";
    for (int i = 1; i <= n; i++)
        cout << viz[i] << "\n";
    return 0;
}
