#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <stack>
#define ll long long


using namespace std;

const int MAXN = 1001000;

int arr[MAXN + 1];

inline int brut(int n) {
    int cnt = 0;
    int i;
    for(i = n; i > 0; i -= 2) {
        arr[i] = 1;
        cnt++;
    }
    for(i = 1; i <= n; i++) {
        int pos = 1;
        while(arr[pos] == 1) {
            arr[pos] = 0;
            cnt--;
            pos++;
        }
        arr[pos] = 1;
        cnt++;
        if(cnt == i) {
            return i;
        }
    }

    return 0;
}

inline int get(int n, int pos) {
    if(pos <= 0) return 0;
    return pos % 2;
}

inline int smart(int n) {
    for(int k = max(1, n / 2 - 100); k <= min(n, n / 2 + 100); k++) {
        int i = n;
        int t = k;
        int cnt = (n + 1) / 2;
        while(t > 0) {
            t = t + get(n, i);
            cnt -= get(n, i);
            cnt += t % 2;
            t /= 2;
            i--;
        }
        if(cnt == k) {
            return k;
        }
    }

    return 0;
}

int main() {
#ifdef HOME
    ifstream cin("A.in");
    ofstream cout("A.out");
#endif // HOME
    int i, n;
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);

    /*for(int x = 1; x <= 100000; x++) {
        if(smart(x) != brut(x)) {
            cout << x << "\n";
        }
    }*/

    cin >> n;
    cout << smart(n);

    return 0;
}
