#include <bits/stdc++.h>
#define DIM 5000
#define INF 2000000000
using namespace std;
struct idk{
    int a,b,c,d;
};
idk v[DIM];
int capacitate[DIM][DIM];
vector <pair<int,int> > L[DIM];
deque <int> c;
int dist[DIM],start[DIM],w[2*DIM],s[DIM],f[DIM];
vector < pair<int,int> > event;
int n,i,j,x,y,bit,k,sursa,dest;
inline int cmp2 (pair<int,int> a, pair <int,int> b){
    if (a.first == b.first)
        return a.second < b.second;
    return a.first < b.first;
}
int cautare_binara (int v[], int n, int val){
    int st = 1, dr = n;
    while (st <= dr){
        int mid = (st+dr)>>1;
        if (v[mid] == val)
            return mid;
        if (v[mid] < val)
            st = mid+1;
        else dr = mid-1;
    }
}
void bfs (int sursa, int dest){
    for (int i=sursa;i<=dest;i++){
        dist[i] = INF;
    }
    c.clear();
    c.push_back(sursa);
    dist[sursa] = 0;
    while (!c.empty()){
        int nod = c.front();
        c.pop_front();
        if (nod == dest)
            break;
        for (int i=0;i<L[nod].size();i++){
            int vecin = L[nod][i].first;
            if (!capacitate[nod][vecin])
                continue;
            if (dist[vecin] == INF){
                dist[vecin] = 1+dist[nod];
                c.push_back(vecin);
            }}}}
int dfs (int nod, int dest, int max_flow){
    if (nod == dest || !max_flow)
        return max_flow;
    int flow = 0;
    for (;start[nod]<L[nod].size();++start[nod]){
        int vecin = L[nod][start[nod]].first;
        if (!capacitate[nod][vecin] || dist[vecin] != dist[nod]+1)
            continue;
        int val = dfs (vecin,dest,min(capacitate[nod][vecin],max_flow-flow));
        flow += val;
        capacitate[nod][vecin] -= val;
        capacitate[vecin][nod] += val;
    }
    return flow;
}
int main (){

    cin>>n;
    int ok = 0;
    for (i=1;i<=n;i++){
        cin>>v[i].a>>v[i].b>>v[i].c>>v[i].d;
        if (v[i].a != v[i].b || v[i].c != v[i].d)
            ok = 1;
    }
    if (n <= 20){
        for (int mask=0;mask<=(1<<n)-1;mask++){
            event.clear();
            for (bit=0;bit<n;bit++){
                if ((mask&(1<<bit)))
                    event.push_back(make_pair(v[bit+1].a,v[bit+1].b));
                else event.push_back(make_pair(v[bit+1].c,v[bit+1].d));
            }
            sort (event.begin(),event.end(),cmp2);
            int ok = 0;
            for (i=1;i<event.size();i++){
                if (event[i].first <= event[i-1].second){
                    ok = 1;
                    break;
                }
            }
            if (!ok){
                /// am gasit o configuratie buna
                cout<<"Yes\n";
                for (bit=0;bit<n;bit++){
                    if ((mask&(1<<bit)))
                        cout<<"1\n";
                    else cout<<"2\n";
                }
                return 0;
            }
        }
        cout<<"No";
        return 0;
    }

    /// normalizez valorile
    for (i=1;i<=n;i++){
        w[++k] = v[i].a;
        w[++k] = v[i].c;
    }
    sort (w+1,w+k+1);
    int k2 = 1;
    for (i=2;i<=k;i++)
        if (w[i] != w[i-1])
            w[++k2] = w[i];
    k = k2;

    int maxi = 0;
    for (i=1;i<=n;i++){
        v[i].a = cautare_binara(w,k,v[i].a);
        v[i].c = cautare_binara(w,k,v[i].c);
        maxi = max (maxi,v[i].a);
        maxi = max (maxi,v[i].c);
    }
    /// acum formez graful
    /// muchie intre sursa si nodurile din stanga
    sursa = 0, dest = 2*maxi+1;
    for (i=1;i<=maxi;i++){
        L[sursa].push_back(make_pair(i,0));
        L[i].push_back(make_pair(sursa,0));
        capacitate[sursa][i] = 1;
    }
    for (i=1;i<=n;i++){
        int x = v[i].a, y = v[i].c + maxi;
        L[x].push_back(make_pair(y,i));
        L[y].push_back(make_pair(x,i));
        capacitate[x][y] = 1;
    }
    /// muchie de la nodurile din stanga la dest
    for (i=maxi+1;i<=2*maxi;i++){
        L[i].push_back(make_pair(dest,0));
        L[dest].push_back(make_pair(i,0));
        capacitate[i][dest] = 1;
    }

    /// acum fluxul
    int sol = 0, flux = 0;
    do{
        for (i=sursa;i<=dest;i++)
            start[i] = 0;
        bfs (sursa,dest);
        flux = dfs (sursa,dest,INF);
        sol += flux;

    } while (flux);

  /*  if (sol != n){
        cout<<"No";
        return 0;
    }*/

    /// acum vad cum le distribui
    for (i=1;i<=maxi;i++){
        /// o sa am un singur vecin care va avea muchia de capacitate 1
        for (j=0;j<L[i].size();j++){
            int vecin = L[i][j].first;
            int poz = L[i][j].second;
            if (vecin > maxi && vecin <= 2*maxi){
                if (!capacitate[i][vecin]){
                    /// inseamna ca vreau sa l pun nod
                    if (s[poz] == 0){
                        s[poz] = 2;
                        break;
                    }
                }
            }
        }
    }
    for (i=1;i<=n;i++)
        if (!s[i])
            s[i] = 1;

    /*for (i=1;i<=n;i++){
        int x;
        if (s[i] == 1)
            x = v[i].a;
        else x = v[i].c;

        if (f[x]){
            cout<<"No";
            return 0;
        }
        f[x] = 1;
    }*/


    cout<<"Yes\n";
    for (i=1;i<=n;i++)
        cout<<s[i]<<"\n";





    return 0;
}
