#include <bits/stdc++.h>

using namespace std;

const int inf = 1e8;
const int MAXN = 1e5 + 5;

int a[MAXN], b[MAXN], c[MAXN], d[MAXN];

vector<int>G[4 * MAXN];
vector<int>Gt[4 * MAXN];
vector<int>ct[4 * MAXN];

int sol[4 * MAXN];

int m;

int neg(int val) {
	if (val > m)
		val -= m;
	else
		val += m;
	return val;
}

void addEdge(int x, int y) {
	G[x].push_back(y);
	Gt[y].push_back(x);
}

bool viz[4 * MAXN];
int cl;
int comp[4 * MAXN];
int lista[4 * MAXN];
int k;

void dfs(int node) {
	viz[node] = 1;
	lista[++k] = node;
	for (auto it:G[node])
		if (!viz[it])
			dfs(it);
}

void dfst(int node) {
	viz[node] = 0;
	comp[node] = cl;
	ct[cl].push_back(node);
	for (auto it:Gt[node])
		if (viz[it])
			dfst(it);
}

int main() {
	//freopen("date.in", "r", stdin);
	//freopen("date.out", "w", stdout);

	int n;
	scanf("%d", &n);
	m = 2 * n;
	for (int i = 1; i <= n; ++i) {
		scanf("%d%d%d%d", &a[i], &b[i], &c[i], &d[i]);
		int i1 = 2 * i - 1;
		int i2 = i1 + 1;
		addEdge(i1, neg(i2));
		addEdge(neg(i1), i2);
		addEdge(i2, neg(i1));
		addEdge(neg(i2), i1);
		for (int j = 1; j < i; ++j) {
			if (max(a[i], a[j]) <= min(b[i], b[j])) {
				addEdge(2 * i - 1, neg(2 * j - 1));
				addEdge(2 * j - 1, neg(2 * i - 1));
			}
			if (max(a[i], c[j]) <= min(b[i], d[j])) {
				addEdge(2 * i - 1, neg(2 * j));
				addEdge(2 * j, neg(2 * i - 1));
			}
			if (max(c[i], a[j]) <= min(d[i], b[j])) {
				addEdge(2 * i, neg(2 * j - 1));
				addEdge(2 * j - 1, neg(2 * i));
			}
			if (max(c[i], c[j]) <= min(d[i], d[j])) {
				addEdge(2 * i, neg(2 * j));
				addEdge(2 * j, neg(2 * i));
			}
		}
	}

	for (int i = 1; i <= 2 * m; ++i)
		if (!viz[i])
			dfs(i);
	for (int i = 2 * m; i >= 1; --i)
		if (viz[lista[i]]) {
			cl++;
			dfst(lista[i]);
		}

	for (int i = 1; i <= 2 * m; ++i)
		if (comp[i] == comp[neg(i)]) {
			printf("No\n");
			return 0;
		}

	printf("Yes\n");

	for (int i = cl; i >= 1; --i) {
		for (auto it:ct[i])
			if (sol[neg(it)]) {
				if (sol[neg(it)] == 1)
					sol[it] = 2;
				else
					sol[it] = 1;
			} else {
				sol[it] = 1;
			}
	}

	for (int i = 1; i <= n; ++i) {
		if (sol[2 * i - 1] == 1)
			printf("%d\n", 1);
		else
			printf("%d\n", 2);
	}

	return 0;
}

