#include <bits/stdc++.h>

using namespace std;


const int Nmax = 4e5 + 5;
typedef pair<int,int> Pair;


const int inf = 1e9;

int n, N, nr_comps;
int where[Nmax];
vector<int> v[Nmax];
vector<Pair> w;
vector<int> ord;

bool concert[Nmax], used[Nmax];

set<Pair> SL, SR;

int where_LV[Nmax];

vector<Pair> LV;

#define left_son (node<<1)
#define right_son ((node<<1)|1)
#define mid ((st+dr)>>1)


class SegTree
{
    Pair a[Nmax<<2];

    Pair get_max(int node, int st, int dr, int L, int R)
    {
        if(L <= st && dr <= R)
            return a[node];

        Pair res = {0, 0};
        if(L <= mid) res = max(res, get_max(left_son, st, mid, L, R));
        if(mid < R) res = max(res, get_max(right_son, mid+1, dr, L, R));
        return res;
    }

    void update(int node, int st, int dr, int pos, Pair val)
    {
        if(st == dr)
        {
            a[node] = val;
            return;
        }
        if(pos <= mid) update(left_son, st, mid, pos, val);
            else update(right_son, mid+1, dr, pos, val);

        a[node] = max(a[left_son], a[right_son]);
    }

public:
    void clear()
    {
        int i;
        for(i=1; i<=4*N; ++i) a[i] = {0, 0};
    }

    void update(int id)
    {
        int pos = where_LV[id];
        update(1, 0, N-1, pos, make_pair(w[id].second, id));
    }

    Pair get_max(int val)
    {
        int pos = upper_bound( LV.begin(), LV.end(), make_pair(val, 0) ) - LV.begin() - 1;
        if(pos == -1) return {0, 0};
        return get_max(1, 0, N-1, 0, pos);
    }

    void scoate(int id)
    {
        int pos = where_LV[id];
        update(1, 0, N-1, pos, make_pair(0, 0));
    }
}
 aint1, aint2;


/*
bool in(int x, Pair a)
{
    return x >= a.first && x <= a.second;
}

bool intersect(Pair a, Pair b)
{
    return in(a.first, b) || in(a.second, b) || in(b.first, a) || in(b.second, a);
}
*/


void get_negh1(int node, int rev)
{
    int who = (node >= N ? node - N : node);
    bool bad = 0;

    set< Pair > :: iterator it, start;
    it = start = SL.lower_bound( { w[who].first, 0} );

    while(it != SL.end() && it->first <= w[who].second)
    {
        int vec = it->second;
        if(!rev) vec += N;
        v[node].push_back(vec);
        ++it;

        if(vec == node + N || vec == node - N) bad = 1;
    }

    SL.erase(start, it);

    if(bad)
    {
        int ww = (!rev ? node : node - N);
        SR.insert({w[ww].first, ww});
    }
}

void get_negh2(int node, int rev)
{
    int who = (node >= N ? node - N : node);
    bool bad = 0;

    set< Pair > :: iterator it, start;
    it = start = SR.lower_bound( { w[who].first, 0} );

    while(it != SR.end() && it->first <= w[who].second)
    {
        int vec = it->second;
        if(!rev) vec += N;
        v[node].push_back(vec);
        ++it;

        if(vec == node + N || vec == node - N) bad = 1;
    }

    SR.erase(start, it);

    if(bad)
    {
        int ww = (!rev ? node : node - N);
        SR.insert({w[ww].second, ww});
    }
}

void get_negh3(int node, int rev)
{
    int who = (node >= N ? node - N : node);
    bool bad = 0;

    while(1)
    {
        Pair res = aint1.get_max(w[who].first);
        if(res.first < w[who].first)
            break;

        int vec = res.second;
        if(!rev) vec += N;
        v[node].push_back(vec);


        if(vec == node + N || vec == node - N) bad = 1;
//
        aint1.scoate(res.second);
    }


    if(bad)
    {
        int ww = (!rev ? node: node - N);
        aint1.update(ww);
    }
}

void get_negh4(int node, int rev)
{
    int who = (node >= N ? node - N : node);
    bool bad = 0;

    while(1)
    {
        Pair res = aint2.get_max(w[who].second);
        if(res.first < w[who].second)
            break;

        int vec = res.second;
        if(!rev) vec += N;
        v[node].push_back(vec);

        if(vec == node + N || vec == node - N) bad = 1;

        aint2.scoate(res.second);
    }

    if(bad)
    {
        int ww = (!rev ? node: node - N);
        aint2.update(ww);
    }
}

void get_negh(int node, int rev)
{
    if(!rev && node >= N) return;
    if(rev && node < N) return;

    get_negh1(node, rev);
    get_negh2(node, rev);
    get_negh3(node, rev);
    get_negh4(node, rev);
}

void dfs(int node, int rev)
{
    used[node] = 1;
    if(rev) where[node] = nr_comps;

    get_negh(node, rev);

    for(auto it : v[node])
        if(!used[it] && it != node - N && it != node + N) dfs(it, rev);

    if(!rev) ord.push_back(node);
}

void solve1()
{
    int i;

    for(i=0; i<N; ++i) LV.push_back({ w[i].first, i});
    sort(LV.begin(), LV.end());
    for(i=0; i<N; ++i)
        where_LV[LV[i].second] = i;


    aint1.clear(); aint2.clear();

    for(i=0; i<n; ++i)
        v[N + 2*i].push_back(2*i+1),
        v[N + 2*i+1].push_back(2*i);

    for(i=0; i<N; ++i)
    {
        SL.insert({w[i].first, i});
        SR.insert({w[i].second, i});
        aint1.update(i);
        aint2.update(i);
    }

    for(i=0; i<2*N; ++i)
        if(!used[i]) dfs(i, 0);
}


void solve2()
{
    int i;
    for(i=0; i<2*N; ++i)
        v[i].clear();

    SL.clear(); SR.clear();
    aint1.clear(); aint2.clear();

    for(i=0; i<n; ++i)
        v[2*i+1].push_back(N+2*i),
        v[2*i].push_back(N+2*i+1);

    for(i=0; i<N; ++i)
    {
        SL.insert({w[i].first, i});
        SR.insert({w[i].second, i});
        aint1.update(i);
        aint2.update(i);
    }

    memset(used, 0, sizeof(used));
    reverse(ord.begin(), ord.end());

    for(auto it : ord)
        if(!used[it])
        {
            ++nr_comps;
            dfs(it, 1);
        }
}

void print()
{
    int i;
    for(i=0; i<N; ++i)
        if(where[i] == where[i + N])
        {
            cout << "No\n";
            return;
        }
     //   else cerr << where[i] << ' ' << where[i+N] << '\n';

    cout << "Yes\n";

    for(i=0; i<N; ++i)
        concert[i] = (where[i] > where[i+N]);

    for(i=0; i<n; ++i)
        if(concert[2*i]) cout << 1 << '\n';
            else cout << 2 << '\n';
}

int main()
{
 //   freopen("input", "r", stdin);
    cin.sync_with_stdio(false); cin.tie(0);

    cin >> n;
    int i;
    for(i=0; i<n; ++i)
    {
        int A, B, C, D;
        cin >> A >> B >> C >> D;
        ++A; ++B; ++C; ++D;
        w.push_back({A, B});
        w.push_back({C, D});
    }

    N = 2 * n;

    solve1();
    solve2();
    print();

    return 0;
}
