#include <bits/stdc++.h>
#define x first
#define y second
using namespace std;

using pii = pair<int, int>;

const int N = 2e5 + 5;

int val[N];
pii v[N];
bool f[N];

vector<int> top;
int n, bnd;

struct Megastructure {
	struct Comp {
		int idx;
		int pos;

		inline bool operator (const Nod &arg) const {
			return make_pair(pos, idx) < make_pair(arg.pos, arg.idx); } };

	multiset<Comp> pom[N * 4];
	Comp qval;
	int ql, qr, qup, qdn, ux, uy, uidx, bnd;

	Megastructure(int _bnd) {
		bnd = _bnd; }

	int query(int nod, int st, int dr) {
		if (ql <= st && dr <= qr) {
			auto it = pom[nod].lower_bound(Comp {qdn, -1});
			if (it != end(pom[nod]) && it->x <= qup)
				return it->y; 
			return -1; }
		int mid = (st + dr) / 2, ant = -1;
		if (ql <= mid)
			ant = max(ant, query(2 * nod, st, mid));
		if (ant == -1 && mid < qr)
			ant = max(ant, query(2 * nod + 1, mid + 1, dr));
		return ant; }

	void update(int nod, int st, int dr) { // baga
		pom[nod].insert(Comp{uy, uidx});
		if (st == dr)	
			return;
		int mid = (st + dr) / 2;
		if (ux <= mid)
			update(2 * nod, st, mid);
		else
			update(2 * nod + 1, mid + 1, dr); }

	void scoate(int nod, int st, int dr) {
		auto it = pom[nod].find(Comp{uy, uidx});
		if (st == dr)	
			return;
		int mid = (st + dr) / 2;
		if (ux <= mid)
			scoate(2 * nod, st, mid);
		else
			scoate(2 * nod + 1, mid + 1, dr); }	

	int find(pii pos) {
		int ans = -1;
		qup = 1e9;
		qdn = -1;
		ql = pos.x, qr = pos.y;
		ans = query(1, 0, bnd);
		if (ans != -1)
			return ans;

		qdn = pos.x;
		qup = pos.y;
		ql = -1, qr = 1e9;
		ans = query(1, 0, bnd);
		if (ans != -1)
			return ans;		

		ql = -1, qr = pos.x;
		qdn = -1, qr = pos.x;

		ans = query(1, 0, bnd);
		if (ans != -1)
			return ans;

		ql = -1, qr = pos.y;
		qdn = -1, qr = pos.y;

		ans = query(1, 0, bnd);
		if (ans != -1)
			return ans;
			
		return -1; }

	void scoate(int idx, pii pos) {
		ux = pos.x;
		uy = pos.y;
		uidx = idx;
		scoate(0, 0, bnd); }

	void baga(int idx, pii pos) {
		ux = pos.x;
		uy = pos.y;
		uidx = idx;
		update(0, 0, bnd); } } *lookup;

static int normalize() {
	vector<int> pos;
	pos.reserve(4 * n);
	for (int i = 0; i < 2 * n; ++i) {
		pos.push_back(v[i].x);
		pos.push_back(v[i].y); }
	sort(begin(pos), end(pos));
	pos.erase(unique(begin(pos), end(pos)), end(pos));

	function<int(int)> findpos = [&](int x) {
		int ans = 0;
		for (int msk = 1 << 20; msk > 0; msk/= 2)
			if (ans + msk < pos.size() && pos[ans + msk] <= x)
				ans+= msk;
		return ans + 1; };

	for (int i = 0; i < 2 * n; ++i) {
		v[i].x = findpos(v[i].x);
		v[i].y = findpos(v[i].y); }

	return pos.size(); }

static int neg(int val) {
	return (val ^ 1); };

static void dfs1(int u) {
	lookup->scoate(u, v[u]);
	for (int nxt = lookup->find(v[u]); nxt != -1; nxt = lookup->find(v[u]))
		dfs1(nxt);
	top.push_back(u); }

static void topsort() {
	lookup = new Megastructure(bnd);
	for (int i = 0; i < 2 * n; ++i)
		lookup->baga(i, v[i]);

	for (int u = 0; u < 2 * n; ++u)
		if (!f[u])
			dfs(u);
	reverse(begin(top), end(top));

	delete lookup; }

static void sat() {
	lookup = new Megastructure(bnd);
	for (int i = 0; i < 2 * n; ++i)
		lookup->baga(i, v[i]);
	memset(val, 0xff, sizeof val);
	memset(f, 0x00, sizeof f);

	for (auto i: top) {
		if (val[i] == -1) // red flag
			val[i] = 1;
		val[neg(i)] = !val[i];
		for (int j = lookup->find(v[i]); j != 1; lookup->scoate(v[j]))
			val[j] = val[i]; }

	delete lookup; }


int main() {
#ifdef HOME
	freopen("music.in", "r", stdin);
	freopen("music.out", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	cin >> n;
	v.resize(2 * n);
	for (int i = 0; i < 2 * n; ++i)
		cin >> v[i].x >> v[i].y;

	bnd = normalize() + 5;
	topsort();
	sat();

	if (check()) {
		cout << "Yes\n";
		for (int i = 0; i < 2 * n; i+= 2)
			cout << (val[i] ? 1 : 2); }
	else {
		cout << "No\n"; }

	return 0; }

