#include <bits/stdc++.h>
#define x first
#define y second
using namespace std;

using pii = pair<int, int>;

const int N = 2e5 + 5;

vector<vector<int>> ctc;
vector<int> g[N], gt[N];
int val[N], my_ctc[N], ctc_val[N];
pii v[N];
bool f[N];

vector<int> top;
int n, bnd;

static inline int neg(int x) {
	return (x ^ 1); }

static inline bool cross(pii a, pii b) {
	if (a > b)
		swap(a, b);
	return b.x <= a.y; }

static void dfs(int u) {
	f[u] = true;
	for (auto v: g[u]) if (!f[v])
		dfs(v);
	top.push_back(u); }

static void dfs2(int u) {
	f[u] = true;
	my_ctc[u] = ctc.size() - 1;
	for (auto v: gt[u]) if (!f[v])
		dfs2(v);
	ctc.back().push_back(u); }

static void topsort() {
	for (int i = 0; i < 2 * n; ++i) {
		for (int j = 0; j < 2 * n; ++j)
			if (j != i && j != (i ^ 1) && cross(v[i], v[j])) {
				gt[neg(j)].push_back(i);
				g[i].push_back(neg(j)); } }

	for (int i = 0; i < 2 * n; ++i) if (!f[i])
		dfs(i);
	memset(f, 0x00, sizeof f);
	reverse(begin(top), end(top));
	for (auto i: top) if (!f[i]) {
		ctc.emplace_back();
		dfs2(i); }

	memset(val, 0xff, sizeof val);
	memset(ctc_val, 0xff, sizeof ctc_val);
	reverse(begin(ctc), end(ctc));
	for (auto &c: ctc) {
		int idx = my_ctc[c[0]];
		if (ctc_val[idx] == -1)
			ctc_val[idx] = 1;
		for (auto j: c) {
			int him = my_ctc[neg(j)];
			ctc_val[him] = 1 - ctc_val[idx]; } }

	for (int i = 0; i < 2 * n; ++i)
		val[i] = ctc_val[my_ctc[i]]; }

static bool check() {
	vector<pii> ivs;
	int lst = -1e9;
	ivs.reserve(n);
	for (int i = 0; i < 2 * n; ++i) if (val[i] == true) {
		ivs.push_back(v[i]); }
	assert(ivs.size() == n);
	sort(begin(ivs), end(ivs));
	for (auto i: ivs) {
		if (i.x <= lst)
			return false;
		lst = i.y; }
	return true; }

int main() {
#ifdef HOME
	freopen("music.in", "r", stdin);
	freopen("music.out", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	cin >> n;
	for (int i = 0; i < 2 * n; ++i)
		cin >> v[i].x >> v[i].y;

	topsort();

	if (check()) {
		cout << "Yes\n";
		for (int i = 0; i < 2 * n; i+= 2)
			cout << (val[i] ? 1 : 2) << '\n'; }
	else {
		cout << "No\n"; }

	return 0; }
/*
10
21 22 33 35
16 18 26 27
9 10 14 23
0 1 15 34
12 17 19 32
4 28 30 38
5 6 13 31
2 3 20 37
24 25 29 36
7 8 11 39
*/
