#include <iostream>

using namespace std;

int N;
char S[100];

static inline void Build (long long &Nr, int N)
{
    Nr = 0;

    for(int i = 1; i <= N; ++i)
    {
        if(i % 2 == 1)
            S[i] = '1';
        else
            S[i] = '0';
    }

    int B = -1;

    for(int i = N; i >= 1; --i)
    {
        ++B;

        if(S[i] == '1')
            Nr += 1LL * (1LL << B);
    }

    return;
}

static inline int Precalculation (int N)
{
    long long Nr = 0;

    Build(Nr, N);

    int ans = 0;

    long long M = 0;

    long long Aux = Nr;

    for(int j = N - 1; j >= 0; --j)
        if((1LL << (j + 1)) - 1LL <= Aux)
        {
            M += (1LL << (j + 1)) - 1LL;

            Aux -= (1LL << (j + 1)) - 1LL;

            ++ans;
        }

    if(ans == 0 || M != Nr)
        ans = -1;

    return ans;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N;

    cout << Precalculation(N) << '\n';

    return 0;
}
