#include <iostream>
#include <algorithm>

using namespace std;

const int NMAX = 1e3 + 5;

int N;
int S[NMAX];

static inline void Build (int N)
{
    for(int i = 1; i <= N; ++i)
        if(i % 2)
            S[i] = 1;
        else
            S[i] = 0;

    reverse(S + 1, S + N + 1);

    return;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N;

    Build(N);

    for(int T = 1; T <= 1000; ++T)
    {
        int pos = 0, r = 1;

        for(int j = 1; j <= N || r; ++j)
        {
            int Now = S[j] + r;

            if(Now == 1)
            {
                S[++pos] = 1;

                r = 0;
            }
            else
            {
                if(r)
                    S[++pos] = 0;
                else
                    S[++pos] = S[j];
            }
        }

        N = pos;

        int cnt = 0;

        for(int j = 1; j <= N; ++j)
            if(S[j] == 1)
                ++cnt;

        if(cnt == T)
        {
            cout << T << '\n';

            return 0;
        }
    }

    cout << 0 << '\n';

    return 0;
}
