#include <iostream>
#include <algorithm>

using namespace std;

const int NMAX = 1e6 + 5;

int N, A[NMAX];

static inline void Build (int N)
{
    for(int i = 1; i <= N; ++i)
        if(i % 2)
            A[i] = 1;
        else
            A[i] = 0;

    reverse(A + 1, A + N + 1);

    return;
}

static inline int Solve (int N)
{
    Build(N);

    for(int T = 1; T <= 2e3; ++T)
    {
        int pos = 0, r = 1;

        for(int j = 1; j <= N || pos; ++j)
        {
            int Now = A[j] + r;

            if(Now == 1)
            {
                r = 0;

                A[++pos] = 1;
            }
            else
            {
                if(r)
                    A[++pos] = 0;
                else
                {
                    A[++pos] = A[j];

                    break;
                }
            }
        }

        if(pos > N)
            N = pos;

        int cnt = 0;

        for(int j = 1; j <= N; ++j)
            if(A[j])
            {
                ++cnt;

                if(cnt > T)
                    break;
            }

        if(cnt == T)
            return T;
    }

    return 0;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N;

    cout << Solve(N) << '\n';

    return 0;
}
