//#include <bits/stdc++.h>
//#include <fstream>
#include <iostream>
#include <algorithm>
#include <vector>
#include <cstring>

//#define LOCAL 1

#define MAX_N 1000000

using namespace std;

typedef long long lint;

#ifdef LOCAL
ifstream cin("present10.in");
ofstream cout("present10.out");
#endif // LOCAL

int n;
int rez;

lint p11[MAX_N + 9];
lint nr[MAX_N + 9];

int n10[1009][1009];
int rr[MAX_N + 9];

void readFile()
{
    cin >> n;
}

lint getN60(int n)
{
    lint x = 0;
    lint cr = 1;
    for(int i = n; i >= 1; i --)
    {
        x = (x << 1) + cr;
        cr = 1 - cr;
    }

    return x;
}

void solveN60(lint x)
{
    p11[1] = 1;

    for(int i = 2; i <= n; i ++)
    {
        p11[i] = (p11[i - 1] << 1) + 1;
    }


    lint y = x;
   // cout << y << "\n";
    int cate = 0;
    for(int i = n; i >= 1; i --)
    {
        if(p11[i] <= y)
        {
            //cout << " SCADEM " << i << " " << p11[i] << "\n";
            y -= p11[i];
            cate ++;
        }
    }
    //cout << y << " RMASM\n";

    if(y == 0)
        rez += cate;

    else
        rez = 0;
}

void printFile()
{
    cout << rez << "\n";
}

bool intra(int p2)
{
    if(rr[0] > n10[p2][0])
        return 1;

    if(rr[0] < n10[p2][0])
        return 0;

    for(int i = rr[0]; i >= 1; i --)
    {
        if(rr[i] > n10[p2][i])
            return 1;

        if(rr[i] < n10[p2][i])
            return 0;
    }

    return 1;
}

void scade(int p2)
{
    int t = 0;
    for(int i = 1; i <= rr[0]; i ++)
    {
        rr[i] = rr[i] - t - n10[p2][i];
        t = 0;
        if(rr[i] < 0)
        {
            rr[i] += 2;
            t = 1;
        }
    }

    while(rr[0] > 0 && rr[rr[0]] == 0)
        rr[0] --;
}

void solveN1000()
{
    if(n <= 1000)
    {
        rez = 0;
        for(int i = 1; i <= n; i ++)
        {
            n10[i][0] = i;
            for(int j = 1; j <= i; j ++)
                n10[i][j] = 1;
        }

        int cr = 1;
        for(int i = n; i >= 1; i --)
        {
            rr[i] = cr;
            cr = 1 - cr;
        }

        rr[0] = n;

        int cate = 0;
        for(int i = max(1, n - 1); i >= 1; i --)
        {
            if(intra(i))
            {
                cate ++;
                scade(i);
            }
        }

        if((rr[0] == 1 && rr[1] == 0) || rr[0] == 0)
            rez += cate;

        else
            rez = 0;

        cout << rez << "\n";
        return ;
    }
}

void solveALL()
{
    if(n <= 60)
    {
        rez = 0;
        lint x = getN60(n);
        solveN60(x);
        cout << rez << "\n";

        ///return ;
    }

    if(n > 60 && n <= 63)
    {
        rez = 0;
        lint x = getN60(n);
        solveN60(x);
        cout << rez << "\n";
    }

    solveN1000();
}

void solveONLY60()
{
    if(n <= 60)
    {
        rez = 0;
        lint x = getN60(n);
        solveN60(x);
        cout << rez << "\n";

        ///return ;
    }
}

int main()
{
    readFile();

    solveN1000();


/*
    for(n = 1; n <= 100; n ++)
    {
        solveALL();

        cout << "\n";
    }*/
/*
    for(n = 1; n <= 63; n ++)
    {
        solve();
        cout << " +++++++++++++++++ " << n << " " << rez << "\n";
    }*/

    ///printFile();

    return 0;
}
