#include <bits/stdc++.h>
using namespace std;

//const int INF = 80000000;

struct festival1{
    int a, b, c, d, p;
    bool operator < (const festival1 &aux)const{
        if(b != aux.b) return b < aux.b;
        return a < aux.a;
    }
};
struct festival2{
    int a, b, c, d, p;
    bool operator < (const festival2 &aux)const{
        if(d != aux.d) return d < aux.d;
        return c < aux.c;
    }
};

festival1 x[100005];
festival2 y[100005];

int n;
int nrc, tmp;
int h[400005], low[400005], id[400005], val[400005];
bitset <400005> instack;
bitset <400005> viz;
vector <int> v[400005];
vector <int> ctc[400005];

int edges = 0;
int nigation(int x){
    if(x <= 2 * n) return 2 * n + x;
    return x - 2 * n;
}

void build_edge(int x, int y){
//    edges += 2;
    v[x].push_back(nigation(y));
    v[y].push_back(nigation(x));
}

bool intersect(int st, int dr, int x, int y){
    if(x <= st && dr <= y) return 1;
    if(st <= x && y <= dr) return 1;

    if(st <= y && dr >= y)
        return 1;
    if(x <= dr && y >= dr)
        return 1;
    return 0;
}

void build_graph(){
    srand(time(NULL));
    sort(x + 1, x + n + 1);
    sort(y + 1, y + n + 1);

    int lim = n;
    for(int i = 1; i <= n ; ++i){
        int A = 2 * x[i].p - 1, B = 2 * x[i].p;
        build_edge(A, B);
        build_edge(nigation(A), nigation(B));

        int st = 1, dr = n;
        while(st <= dr){
            int mij = (st + dr) / 2;
            if(x[mij].b < x[i].a) st = mij + 1;
            else dr = mij - 1;
        }

        int lim = n;
        lim = min(st + 420, n);

        for(int j = st; j <= lim ; ++j){
            if(x[j].p == x[i].p) continue ;
            int X = 2 * x[j].p - 1, Y = 2 * x[j].p;
            if(intersect(x[i].a, x[i].b, x[j].a, x[j].b)) build_edge(nigation(A), nigation(X));
            else break ;
        }

        st = 1, dr = n;
        while(st <= dr){
            int mij = (st + dr) / 2;
            if(y[mij].d < x[i].a) st = mij + 1;
            else dr = mij - 1;
        }

        lim = n;
        lim = min(st + 420, n);

        for(int j = st; j <= lim ; ++j){
            if(y[j].p == x[i].p) continue ;
            int X = 2 * y[j].p - 1, Y = 2 * y[j].p;
            if(intersect(x[i].a, x[i].b, y[j].c, y[j].d)) build_edge(nigation(A), nigation(Y));
            else break ;
        }
    }

    for(int i = 1; i <= n ; ++i){
        int A = 2 * y[i].p - 1, B = 2 * y[i].p;

        int st = 1, dr = n;
        while(st <= dr){
            int mij = (st + dr) / 2;
            if(x[mij].b < y[i].c) st = mij + 1;
            else dr = mij - 1;
        }

        int lim = n;
        lim = min(st + 420, n);

        for(int j = st; j <= lim ; ++j){
            if(x[j].p == y[i].p) continue ;
            int X = 2 * x[j].p - 1, Y = 2 * x[j].p;
            if(intersect(y[i].c, y[i].d, x[j].a, x[j].b)) build_edge(nigation(B), nigation(X));
            else break ;
        }

        st = 1, dr = n;
        while(st <= dr){
            int mij = (st + dr) / 2;
            if(y[mij].d < y[i].c) st = mij + 1;
            else dr = mij - 1;
        }

        lim = n;
        lim = min(st + 420, n);
        for(int j = st; j <= lim ; ++j){
            if(y[j].p == y[i].p) continue ;
            int X = 2 * y[j].p - 1, Y = 2 * y[j].p;
            if(intersect(y[i].c, y[i].d, y[j].c, y[j].d)) build_edge(nigation(B), nigation(Y));
            else break ;
        }
    }

}

stack <int> st;
void tarjan(int nod){
    viz[nod] = 1;
    instack[nod] = 1;
    st.push(nod);

    for(auto it : v[nod]){
        if(!viz[it]){
            h[it] = low[it] = h[nod] + 1;
            tarjan(it);
            low[nod] = min(low[nod], low[it]);
        }
        else if(instack[it]) low[nod] = min(low[nod], h[it]);
    }

    if(low[nod] == h[nod]){
        int x = 0;
        ++nrc;
        do{
            x = st.top();
            st.pop();
            instack[x] = 0;
            id[x] = nrc;
            ctc[nrc].push_back(x);
        }while(x != nod);
    }
}

int main()
{
//    freopen("1.in", "r", stdin);

    scanf("%d", &n);
    for(int i = 1; i <= n ; ++i){
        scanf("%d%d%d%d", &x[i].a, &x[i].b, &x[i].c, &x[i].d), x[i].p = i;
        y[i] = {x[i].a, x[i].b, x[i].c, x[i].d, x[i].p};
    }

    build_graph();

    for(int i = 1; i <= 4 * n ; ++i){
        val[i] = -1;
        if(!viz[i]){
            h[i] = low[i] = 1;
            tarjan(i);
        }
    }

    for(int i = 1; i <= n ; ++i){
        if(id[2 * i - 1] == id[nigation(2 * i - 1)]){
            printf("No\n");
            return 0;
        }
        if(id[2 * i] == id[nigation(2 * i)]){
            printf("No\n");
            return 0;
        }
    }

    for(int i = nrc; i >= 1 ; --i){
        int x = 1;
        for(auto it : ctc[i])
            if(val[it] == 0) x = 0;

        for(auto it : ctc[i]){
            if(val[it] == -1){
                val[it] = x;
                val[nigation(it)] = 1 - x;
            }
            else if(val[it] != x){
                printf("No\n");
                return 0;
            }

            if(val[it] == 0){
                for(auto nod : v[it]){
                    if(id[nod] != id[it]){
                        if(val[nod] == 1){
                            printf("No\n");
                            return 0;
                        }
                        else val[nod] = 0;
                    }
                }
            }
        }
    }

    for(int i = 1; i <= n ; ++i){
        if(val[2 * i - 1] == val[2 * i] && val[2 * i] == 0){
            printf("No\n");
            return 0;
        }
    }

    printf("Yes\n");
    for(int i = 1; i <= n ; ++i){
        if(val[2 * i - 1] == 1) printf("1\n");
        else printf("2\n");
    }

    return 0;
}
















