#include<bits/stdc++.h>

using namespace std;
//#define int long long
#define endl '\n'
int n;
vector<pair<int, int> > seg;
vector<set<int> > g;
set<int> path;
void dfs(int v){
	if(path.size() >= n) return;
	path.insert(v);
	int c = 0;
	for(int to: g[v]){
		if(path.find(to) != path.end()) c++;
	}
	if(c == n - 1){
		cout << "Yes" << endl;
		for(auto a: path){
			cout << a % 2 + 1 << endl;
		}
		exit(0);
	}
	if(c == path.size() - 1){
		for(int to: g[v]){
			if(to / 2 - 1 == v / 2) dfs(to);
		}
	}
	path.erase(v);
}

signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for(int i = 0; i < n; i++){
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		seg.push_back({a, b});
		seg.push_back({c, d});
	}
	g.resize(2 * n);
	for(int i = 0; i < 2 * n; i++){
		for(int j = (i / 2 + 1) * 2; j < 2 * n; j++){
			int a = seg[i].first, b = seg[i].second, c = seg[j].first, d = seg[j].second;
			if(c > b || a > d){
				g[i].insert(j);
				g[j].insert(i);
			}
		}
	}
	for(int i = 0; i < 2 * n; i++){
		bool ok = false;
		for(int j = (i / 2 + 1) * 2; j < (i / 2 + 1) * 2 + 2; j++){
			int a = seg[i].first, b = seg[i].second, c = seg[j].first, d = seg[j].second;
			if((c > b || a > d)) ok = ok || 1;
		}
		if(!ok){
			for(int to: g[i]) g[to].erase(i);
			g[i].clear();
		}
	}
	dfs(0);
	dfs(1);
	cout << "No";
	return 0;
}
