#include<bits/stdc++.h>

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define f first
#define s second
#define size(x) (int)x.size()

using namespace std;

typedef long long ll;
typedef long double ld;

void io() {
#ifdef MLOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

void solve() {
	int n;
	cin >> n;
	vector<int> a(n), b(n), c(n), d(n);
	set<int> s;
	for(int i = 0; i < n; i++) {
        cin >> a[i] >> b[i] >> c[i] >> d[i];
        s.insert(a[i]);
        s.insert(b[i]);
        s.insert(c[i]);
        s.insert(d[i]);
	}
	int id = 0;
	map<int, int> mp;
	for(int i : s) {
        mp[i] = id++;
	}
	for(int i = 0; i < n; i++) {
        a[i] = mp[a[i]];
        b[i] = mp[b[i]];
        c[i] = mp[c[i]];
        d[i] = mp[d[i]];
	}
	vector<int> p(id);
	bool ok;
	int i, j;
	for(int mask = 0; mask < (1 << n); mask++) {
        for(i = 0; i < id; i++) {
            p[i] = 0;
        }
        ok = true;
        for(i = 0; i < n; i++) {
            if(mask & (1 << i)) {
                for(j = a[i]; j <= b[i]; j++) {
                    if(p[j] == 1) {
                        ok = false;
                        break;
                    }else {
                        p[j] = 1;
                    }
                }
            }else {
                for(j = c[i]; j <= d[i]; j++) {
                    if(p[j] == 1) {
                        ok = false;
                        break;
                    }else {
                        p[j] = 1;
                    }
                }
            }
        }
        if(ok) {
            cout << "Yes\n";
            for(int i = 0; i < n; i++) {
                if(mask & (1 << i)) {
                    cout << 1 << "\n";
                }else {
                    cout << 2 << "\n";
                }
            }
            exit(0);
        }
	}
	cout << "No";
}

int main() {
	io();
	solve();
	return 0;
}
