#include<bits/stdc++.h>

#pragma GCC optimize("Ofast,fast-math,unroll-loops")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,abm,mmx,popcnt,tune=native")

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define f first
#define s second
#define size(x) (int)x.size()

using namespace std;

typedef long long ll;
typedef long double ld;

void io() {
#ifdef MLOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

void solve() {
	int n;
	cin >> n;
	if(n == 1) {
        cout << 1;
        exit(0);
	}
	vector<int> t(n - 1);
	for(int i = 0; i < n - 1; i++) {
        t[i] = 1;
	}
	vector<int> a(n);
	for(int i = 0; i < n; i++) {
        if(i % 2 == 0) {
            a[i] = 1;
        }else {
            a[i] = 0;
        }
	}
	reverse(all(a));
	int ans = 0;
	while(!t.empty()) {
        ans++;
        for(int i = 0; i < size(t); i++) {
            if(a[i] < t[i]) {
                a[i] += 2;
                a[i + 1]--;
            }
            a[i] -= t[i];
        }
        while(!a.empty() && a.back() == 0) {
            a.pop_back();
        }
        if(a.empty()) {
            cout << ans;
            exit(0);
        }
        bool ok = true;
        for(int i : a) {
            if(i == 0) {
                ok = false;
                break;
            }
        }
        if(ok) {
            t.pop_back();
            while(size(t) > size(a)) {
                t.pop_back();
            }
        }else {
            t.pop_back();
            while(size(t) >= size(a)) {
                t.pop_back();
            }
        }
	}
	cout << 0;
}

int main() {
	io();
	solve();
	return 0;
}
