#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define size(x) (int)x.size()
#define x first
#define y second
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)

ld d = clock();

mt19937_64 gen;

const int N = 2e5;
int f[2][N];

void R(int &x) {
  x = 0;
  int st = 0;
  char c;
  while (1) {
    c = getchar();
    if ('0' <= c && c <= '9') {
      x = x * 10 + (c - '0');
      st = 1;
    } else if (st) break;
  }
}

inline void inc(int z, int x, int y) {
  for(; x < N; x |= (x + 1))
    f[z][x] += y;
}

inline int get(int z, int x) {
  int res = 0;
  for(; x >= 0; x = (x & (x + 1)) - 1)
    res += f[z][x];
  return res;
}

inline int get(int z, int x, int y) {
  return get(z, y) - get(z, x - 1);
}

int a[2 * N], b[2 * N];
int res[N];

inline bool check(int x) {
  if (get(0, a[x])) return 0;
  if (get(1, a[x], b[x])) return 0;
  return 1;
}

inline void put(int x) {
  res[x >> 1] = x & 1;
  inc(0, a[x], 1);
  inc(0, b[x] + 1, -1);
  inc(1, a[x], 1);
}

void run() {
  int n;
  vector<int> xs;
  R(n);
  for(int i = 0; i < 2 * n; i++) {
    R(a[i]);
    R(b[i]);
    xs.push_back(a[i]);
    xs.push_back(b[i]);
  }
  sort(all(xs));
  xs.resize(unique(all(xs)) - xs.begin());
  for(int i = 0; i < 2 * n; i++) {
    a[i] = lower_bound(all(xs), a[i]) - xs.begin();
    b[i] = lower_bound(all(xs), b[i]) - xs.begin();
  }
  vector<int> ord(2 * n);
  iota(all(ord), 0);
  while ((clock() - d) / CLOCKS_PER_SEC <= 2.5) {
    shuffle(all(ord), gen);
    fill(f[0], f[0] + N, 0);
    fill(f[1], f[1] + N, 0);
    int fl = 1;
    fill(res, res + n, -1);
    for(int x : ord) {
      if (res[x >> 1] != -1) continue;
      if (!check(x)) {
        if (!check(x ^ 1)) {
          fl = 0;
          break;
        } else{
          put(x ^ 1);
        }
      } else {
        put(x);
      }
    }
    if (fl) {
      cout << "Yes\n";
      for(int i = 0; i < n; i++){
        cout << res[i] + 1 << ' ';
      }
      return;
    }
  }
  cout << "No\n";
}

signed main()
{
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  gen.seed(12 * 21);
#else
  gen.seed(time(0));
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  cout << fixed << setprecision(16);
  run();
}
