#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define size(x) (int)x.size()
#define x first
#define y second
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)
#define pb emplace_back

ld d = clock();

mt19937_64 gen;

const int N = 1e4;
int used[N];
int a[N], b[N];
int res[N];
vector<int> g[N], gr[N];
vector<int> ord;

void dfs(int v) {
  used[v] = 1;
  for(int to : g[v])
    if (!used[to])
      dfs(to);
  ord.pb(v);
}

int cmp[N];

void dfs2(int v, int clr) {
  cmp[v] = clr;
  for(int to : gr[v]) {
    if (!cmp[to]) dfs2(to, clr);
  }
}

void run() {
  int n;
  vector<int> xs;
  cin >> n;
  const int inf = 1e9;
  for(int i = 0; i < 2 * n; i++) {
    cin >> a[i] >> b[i];
  }
  for(int i = 0; i < 2 * n; i++) {
    for(int j = 0; j < 2 * n; j++) {
      if (i == j) continue;
      if ((i ^ 1) == j) continue;
      int fl = 0;
      if (a[i] <= a[j] && a[j] <= b[i]) fl = 1;
      if (a[i] <= b[j] && b[j] <= b[i]) fl = 1;
      if (a[j] <= a[i] && a[i] <= b[j]) fl = 1;
      if (a[j] <= b[i] && b[i] <= b[j]) fl = 1;
      if (fl) {
        g[i].pb(j ^ 1);
        gr[j ^ 1].pb(i);
      }
    }
  }
  for(int i = 0; i < 2 * n; i++) {
    if (!used[i]) dfs(i);
  }
  reverse(all(ord));
  int tt = 1;
  for(int x : ord) {
    if (!cmp[x]){
      dfs2(x, tt++);
    }
  }
  for(int i = 0; i < 2 * n; i++) {
    if (cmp[i] == cmp[i ^ 1]) {
      cout << "No\n";
      return;
    }
  }
  cout << "Yes\n";
  for(int i = 0; i < n; i++) {
    if (cmp[i * 2] < cmp[i * 2 + 1]) {
      cout << 2 << ' ';
    } else {
      cout << 1 << ' ';
    }
  }
}

signed main()
{
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  gen.seed(12 * 21);
#else
  gen.seed(time(0));
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  cout << fixed << setprecision(16);
  run();
}
