#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
/*
#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
*/
ll INF = (ll) 1e20;
ll mod = 1e9 + 7;

mt19937 gen(time(0));

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    vector <pair <ll, ll>> v(n);
    for(int i = 0; i < n; ++i) {
        cin >> v[i].first >> v[i].second;
    }
    ll m;
    cin >> m;
    vector <pair <ll, ll>> r(m);
    for(int i = 0; i < m; ++i) {
        cin >> r[i].first >> r[i].second;
    }
    vector <pair<ll, ll> > up(n, {-1, -1});
    vector <pair <ll, ll> > down(n, {INF, -1});
    vector <pair <ll, ll> > left(n, {-1, -1});
    vector <pair <ll, ll> > right(n, {INF, -1});
    vector <ll> upr(n, -1);
    vector <ll> downr(n, INF);
    vector <ll> leftr(n, -1);
    vector <ll> rightr(n, INF);
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < m; ++j) {
            if(r[j].first == v[i].first) {
                if(r[j].second > v[i].second) {
                    downr[i] = min(downr[i], r[j].second);
                }
                if(r[j].second < v[i].second) {
                    upr[i] = max(upr[i], r[j].second);
                }
            }
            if(r[j].second == v[i].second) {
                if(r[j].first > v[i].first) {
                    rightr[i] = min(rightr[i], r[j].first);
                }
                if(r[j].first < v[i].first) {
                    leftr[i] = max(leftr[i], r[j].first);
                }
            }
        }
    }
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j) {
                if(i == j)
                continue;
            if(v[j].first == v[i].first) {
                if(v[j].second > v[i].second) {
                    down[i] = min(down[i], {v[j].second, j});
                }
                if(v[j].second < v[i].second) {
                    up[i] = max(up[i], {v[j].second, j});
                }
            }
            if(v[j].second == v[i].second) {
                if(v[j].first > v[i].first) {
                    right[i] = min(right[i], {v[j].first, j});
                }
                if(v[j].first < v[i].first) {
                    left[i] = max(left[i], {v[j].first, j});
                }
            }
        }
    }
    vector <bool> alive(n, true);
    vector <pair <ll, pair <ll, ll>>> bombs;
    for(int t = 0; t < n; ++t) {
        pair <ll, ll> maxim = {0, -1};
        for(int i = 0; i < n; ++i) {
                if(!alive[i])
                continue;
            ll cnt = 0;
            if(up[i].second != -1) {
                if(up[i].first > upr[i]) {
                    if(alive[up[i].second]) {
                        ++cnt;
                    }
                }
            }
            if(down[i].second != -1) {
                if(down[i].first < downr[i]) {
                    if(alive[down[i].second]) {
                        ++cnt;
                    }
                }
            }
            if(left[i].second != -1) {
                if(left[i].first > leftr[i]) {
                    if(alive[left[i].second]) {
                        ++cnt;
                    }
                }
            }
            if(right[i].second != -1) {
                if(right[i].first < rightr[i]) {
                    if(alive[right[i].second]) {
                        ++cnt;
                    }
                }
            }
        maxim = max(maxim, {cnt, i});
        }
     //   cout << maxim.first << ' ' << maxim.second << '\n';
        if(maxim.first == 0)
            break;
        ll i = maxim.second;
        if(up[i].second != -1) {
                if(up[i].first > upr[i]) {
                    if(alive[up[i].second]) {
                 //           cout << i << " asdf " << up[i].second << '\n';
                        alive[i] = false;
                        alive[up[i].second] = false;
                        bombs.push_back({1, {v[i].first, v[i].second - 1}});
                        continue;
                    }
                }
            }
            if(down[i].second != -1) {
                if(down[i].first < downr[i]) {
                    if(alive[down[i].second]) {
                        alive[i] = false;
                        alive[down[i].second] = false;
                        bombs.push_back({1, {v[i].first, v[i].second + 1}});
                        continue;
                    }
                }
            }
            if(left[i].second != -1) {
                if(left[i].first > leftr[i]) {
                    if(alive[left[i].second]) {
                        alive[i] = false;
                        alive[left[i].second] = false;
                        bombs.push_back({0, {v[i].first - 1, v[i].second}});
                        continue;
                    }
                }
            }
            if(right[i].second != -1) {
                if(right[i].first < rightr[i]) {
                    if(alive[right[i].second]) {
                        alive[i] = false;
                        alive[right[i].second] = false;
                        bombs.push_back({0, {v[i].first + 1, v[i].second}});
                        continue;
                    }
                }
            }
    }
    for(int i = 0; i < n; ++i) {
        if(alive[i]) {
                        bombs.push_back({1, {v[i].first, v[i].second + 1}});
        }
}
cout << bombs.size() << '\n';
for(int i = 0; i < bombs.size(); ++i) {
    cout << bombs[i].first << ' ' << bombs[i].second.first << ' ' << bombs[i].second.second << '\n';
}
}
/*
4
2 1
1 2
2 3
3 2
1
2 2


4
1 2
1 4
3 2
3 4
0
*/
