#include <iostream>
#include <cstdio>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <deque>
#include <queue>
#include <cmath>
#include <cstring>
#include <cassert>
#include <string>
#include <random>
#include <bitset>
#include <algorithm>
#include <numeric>
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).end()
#define rep(i, n) for (int i = 0; i < (n); i++)

using namespace std;
using ll = long long;
using ld = long double;
using ul = unsigned long long;

const int N = 100003, T = 1 << 19, M = T * 4 + N * 10;
vector<int> g[M], rg[M], ord, li;
int n, cc;
int x[N][4], used[M], c[M];

void add(int u, int v) {
	g[u].push_back(v);
	g[v ^ 1].push_back(u ^ 1);
	rg[v].push_back(u);
	rg[u ^ 1].push_back(v ^ 1);
}

void seg(int cl, int cr, int t, int v=1, int l=0, int r=T) {
	if (cr <= l || r <= cl)
		return;
	if (cl <= l && r <= cr) {
		add(v * 2 + 1, t);
		return;
	}
	seg(cl, cr, t, v * 2, l, (l + r) / 2);
	seg(cl, cr, t, v * 2 + 1, (l + r) / 2, r);
}

void dfs(int v) {
	used[v] = 1;
	for (int u : g[v])
		if (!used[u])
			dfs(u);
	ord.push_back(v);
}
void rdfs(int v) {
	c[v] = cc;
	for (int u : rg[v])
		if (!c[u])
			rdfs(u);
}

int main() {
#ifdef ONPC
	freopen("in", "r", stdin);
#endif
	ios_base::sync_with_stdio(false); cin.tie(0);
	cin >> n;
	for (int i = 1; i < T; i++) {
		add(i * 2 * 2 + 1, i * 2 + 1);
		add((i * 2 + 1) * 2 + 1, i * 2 + 1);
	}
	map<pair<int, int>, vector<int>> mp;
	rep(i, n)
		rep(j, 4) {
			cin >> x[i][j];
			li.push_back(x[i][j]);
		}
	sort(all(li));
	li.resize(unique(all(li)) - li.begin());
	rep(i, n) {
		rep(j, 4)
			x[i][j] = lower_bound(all(li), x[i][j]) - li.begin();
		int cv = (2 * T + 4 * N) + i;
		add(cv * 2 + 1, (T + x[i][2]) * 2 + 1);
		add(cv * 2 + 1, (T + x[i][3] + 1) * 2 + 1);
		add(cv * 2, (T + x[i][0]) * 2 + 1);
		add(cv * 2, (T + x[i][1] + 1) * 2 + 1);
		seg(x[i][0] + 1, x[i][1] + 1, cv * 2 + 1);
		seg(x[i][2] + 1, x[i][3] + 1, cv * 2);
		mp[{x[i][0], x[i][1]}].push_back(cv * 2);
		mp[{x[i][2], x[i][3]}].push_back(cv * 2 + 1);
	}
	for (auto &pp : mp)
		for (int i = 1; i < pp.second.size(); i++) {
			int u = pp.second[i - 1], v = pp.second[i], u1 = u - 10 * N, v1 = v - 10 * N, u2 = u1 + 2 * N, v2 = v1 + 2 * N;
			add(v1 * 2 + 1, u1 * 2 + 1);
			add(u2 * 2 + 1, v2 * 2 + 1);
			add(v, u1 * 2 + 1);
			add(u, v2 * 2 + 1);
			if (i == 1) {
				add(u, u1 * 2);
				add(u, u2 * 2);
			}
			add(v, v1 * 2);
			add(v, v2 * 2);
		}
	rep(i, M)
		if (!used[i])
			dfs(i);
	for (int i = (int) ord.size() - 1; i >= 0; i--)
		if (!c[ord[i]]) {
			cc++;
			rdfs(ord[i]);
		}
	rep(i, M / 2)
		if (c[i * 2] == c[i * 2 + 1]) {
			cout << "No";
			return 0;
		}
	cout << "Yes\n";
	rep(i, n) {
		if (c[(2 * T + 4 * N + i) * 2] < c[(2 * T + 4 * N + i) * 2 + 1])
			cout << "2\n";
		else
			cout << "1\n";
	}
}


