#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 7;

vector <int> g[N], rg[N];

void add_edge(int a, int b) {
	g[a].push_back(b);
	rg[b].push_back(a);
}

bool u[N], vis[N];
int comp[N];

vector <int> t;
int a[N * 2], b[N * 2];

int n;

void dfs(int v) {
	u[v] = true;
	for (int i = 0; i < 2 * n; i++) {
		if (i / 2 != v / 2 && max(a[i], a[v]) <= min(b[i], b[v]) && !u[i ^ 1]) {
			dfs(i ^ 1);
		}
	}
	t.push_back(v);
}

int sz = 0;

void rdfs(int v) {
	comp[v] = sz;
	vis[v] = true;
	for (int i = 0; i < 2 * n; i++) {
		if (i / 2 != v / 2 && max(a[i], a[v ^ 1]) <= min(b[i], b[v ^ 1]) && !vis[i]) {
			rdfs(i);
		}
	}
}

int read() {
	char c = getchar_unlocked();
	while (c < '0' || c > '9') {
		c = getchar_unlocked();
	}
	int ans = 0;
	while ('0' <= c && c <= '9') {
		ans = ans * 10 + c - '0';
		c = getchar_unlocked();
	}
	return ans;
}

struct tree {
	tree *l, *r;
	int vert;
};

int main() {
#ifdef iq
	freopen("a.in", "r", stdin);
#endif
	n = read();
	for (int i = 0; i < n; i++) {
		for (int t = 0; t < 2; t++) {
			a[i * 2 + t] = read(), b[i * 2 + t] = read();
		}
	}
	for (int i = 0; i < 2 * n; i++) {
		if (!u[i]) dfs(i);
	}
	reverse(t.begin(), t.end());
	for (int v : t) {
		if (!vis[v]) {
			rdfs(v);
			sz++;
		}
	}
	for (int i = 0; i < n; i++) {
		if (comp[2 * i] == comp[2 * i + 1]) {
			cout << "No\n";
			return 0;
		}
	}
	cout << "Yes\n";
	for (int i = 0; i < n; i++) {
		if (comp[2 * i] > comp[2 * i + 1]) {
			cout << 1 << '\n';
		} else {
			cout << 2 << '\n';
		}
	}
}
