#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 7;
const int inf = 1e9;

vector <int> g[N], rg[N];

void add_edge(int a, int b) {
	g[a].push_back(b);
	rg[b].push_back(a);
}

bool u[N], vis[N];
int comp[N];

vector <int> t;
int a[N * 2], b[N * 2];

int n;

vector <pair <int, pair <int, int> > > id, rid;

struct rofl {
	vector <set <pair <int, int> > > q;
	vector <int> ids;
	void init(vector <pair <int, pair <int, int> > > t) {
		q.resize(t.size());
		ids.clear();
		for (int i = 0; i < (int) t.size(); i++) {
			ids.push_back(t[i].first);
			for (int j = i; j < (int) t.size(); j = (j | (j + 1))) {
				q[j].insert({-t[i].second.first, t[i].second.second});
			}
		}
	}
	int get(int x, int y, int v) {
		int ind = upper_bound(ids.begin(), ids.end(), x) - ids.begin() - 1;
		for (; ind >= 0; ind = (ind & (ind + 1)) - 1) {
			for (auto &c : q[ind]) {
				if (c.first > -y) {
					break;
				}
				if (c.second / 2 != v / 2) {
					q[ind].erase(c);
					return c.second;
				}
			}
		}
		return -1;
	}
};

rofl ia, ib;

void dfs(int v) {
	u[v] = true;
	while (int x = ia.get(b[v], a[v], v)) {
		if (x == -1) {
			break;
		}
		if (u[x]) continue;
		dfs(x);
	}
	t.push_back(v);
}

int sz = 0;

void rdfs(int v) {
	comp[v] = sz;
	vis[v] = true;
	while (int x = ib.get(b[v ^ 1], a[v ^ 1], v)) {
		if (x == -1) break;
		if (vis[x]) continue;
		rdfs(x);
	}
}

int read() {
	char c = getchar_unlocked();
	while (c < '0' || c > '9') {
		c = getchar_unlocked();
	}
	int ans = 0;
	while ('0' <= c && c <= '9') {
		ans = ans * 10 + c - '0';
		c = getchar_unlocked();
	}
	return ans;
}

struct tree {
	tree *l, *r;
	int vert;
};

int main() {
#ifdef iq
	freopen("a.in", "r", stdin);
#endif
	n = read();
	for (int i = 0; i < n; i++) {
		for (int t = 0; t < 2; t++) {
			a[i * 2 + t] = read(), b[i * 2 + t] = read();
		}
	}
	for (int i = 0; i < 2 * n; i++) {
		id.push_back({a[i ^ 1], {b[i ^ 1], i}});
		rid.push_back({a[i], {b[i], i}});
	}
	sort(id.begin(), id.end());
	sort(rid.begin(), rid.end());
	ia.init(id);
	ib.init(rid);
	for (int i = 0; i < 2 * n; i++) {
		if (!u[i]) dfs(i);
	}
	reverse(t.begin(), t.end());
	for (int v : t) {
		if (!vis[v]) {
			rdfs(v);
			sz++;
		}
	}
	for (int i = 0; i < n; i++) {
		if (comp[2 * i] == comp[2 * i + 1]) {
			cout << "No\n";
			return 0;
		}
	}
	cout << "Yes\n";
	for (int i = 0; i < n; i++) {
		if (comp[2 * i] > comp[2 * i + 1]) {
			cout << 1 << '\n';
		} else {
			cout << 2 << '\n';
		}
	}
}
