#include <bits/stdc++.h>
#define int long long
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

//kek
const int DIV_DIGIT = 60;
ll n;

int get_val(ll d) {
	return (d < n && (d - (n - 1)) % 2 == 0);
}

ll left_digits(ll cnt) {
	return (cnt + 1) / 2;
}

int div_digit = DIV_DIGIT;
const ll K = 3e4;

signed main() {
	fast_io();
	assert(__builtin_popcountll((1LL << 62) + (1LL << 55) + (1LL << 23) + (1LL << 60)) == 4);
	cin >> n;
	if (get_val(div_digit) == 1) {
		div_digit--;
	}
	ll L = left_digits(max(0LL, n - div_digit - 1));
	ll x = 0;
	for (int i = 0; i < div_digit; ++i) {
		if (get_val(i)) {
			x ^= (1LL << i);
		}
	}
	// cerr << "L = " << L << endl;
	// cerr << "x = " << x << endl;
	ll all = left_digits(n);
	ll lbound = max(0LL, all - K);
	ll rbound = all + K;
	for (ll k = lbound; k <= rbound; ++k) {
		if (L + __builtin_popcountll(x + k) == k) {
			cout << k << endl;
			exit(0);
		}
	}
	cout << 0 << endl;
}
