#include <bits/stdc++.h>

using namespace std;
template<class T1, class T2> inline void chkmin(T1 &x, const T2 &y) {x = (x > y ? y: x);}
template<class T1, class T2> inline void chkmax(T1 &x, const T2 &y) {x = (x < y ? y: x);}
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
#define left left228
#define right right228
#define rank rank228
#define y1 y1227
using ll = long long;
using ld = long double;


char readChar() {
	char c = getchar_unlocked();
	while (c <= 32) {
		c = getchar_unlocked();
	}
	return c;
}


int readInt() {
	char c = readChar();
	int sign = 0;
	if (c == '-') {
		sign = true;
		c = getchar_unlocked();
	}
	int res = 0;
	while (c >= '0' && c <= '9') {
		res = ((res << 3) + (res << 1)) + c - '0';
		c = getchar_unlocked();
	}
	return (sign ? -res: res);
}
const int MAXN = 8000228;


int n;
int la[200228], ra[200228];
int uk;
vector<int> g[MAXN];
vector<int> rg[MAXN];
bool used[MAXN];
vector<int> ord;
vector<int> who[200228];
int kek[200228];


void dfs(int u) {
	used[u] = true;
	for (auto h: g[u]) {
		if (!used[h]) {
			dfs(h);
		}
	}
	ord.pb(u);
}


int col[MAXN];

void dfs1(int u, int c) {
	used[u] = true;
	col[u] = c;
	for (auto h: rg[u]) {
		if (!used[h]) {
			dfs1(h, c);
		}
	}
}



void add(int a, int b) {
	g[a].pb(b);
	rg[b].pb(a);
}


vector<pair<int, int> > gp[600000];
vector<int> suff[600000], suff1[600000];
int ss = 1;


void add(int v, int vl, int vr, int l, int bnd, int i) {
	if (l < vl) {
		return;
	}
	if (vr <= l) {
		int pos = lower_bound(all(gp[v]), mp(bnd, 0)) - gp[v].begin();
		if (pos < sz(gp[v])) {
			add(i, suff[v][pos]);
			add(suff1[v][pos], i ^ 1);
		}
		return;
	}
	add(v * 2, vl, (vl + vr) / 2, l, bnd, i);
	add(v * 2 + 1, (vl + vr) / 2 + 1, vr, l, bnd, i);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
//	assert(freopen("input.in", "r", stdin));
	cin >> n;
	vector<int> st1;
	for (int i = 0; i < n; i++) {
		cin >> la[i * 2] >> ra[i * 2] >> la[i * 2 + 1] >> ra[i * 2 + 1];
		st1.pb(la[i * 2]);
		st1.pb(la[i * 2 + 1]);
	}
	sort(all(st1));
	st1.resize(distance(st1.begin(), unique(all(st1))));
	uk = 2 * n;
	while (ss < sz(st1)) {
		ss <<= 1;
	}
	for (int i = 0; i < 2 * n; i++) {
		int pos = lower_bound(all(st1), la[i]) - st1.begin();
		kek[i] = pos;
		who[pos].pb(i);
		gp[ss + pos].pb({ra[i], i});
	}
	for (int i = ss - 1; i >= 1; i--) {
		if (gp[i * 2].empty()) {
			gp[i] = gp[i * 2 + 1];
			continue;
		}
		if (gp[i * 2 + 1].empty()) {
			gp[i] = gp[i * 2];
			continue;
		}
		gp[i].resize(sz(gp[i * 2]) + sz(gp[i * 2 + 1]));
		merge(all(gp[i * 2]), all(gp[i * 2 + 1]), gp[i].begin());
	}
	for (int i = 1; i < 2 * ss; i++) {
		if (!gp[i].empty()) {
			for (int j = sz(gp[i]) - 1; j >= 0; j--) {
				add(uk, gp[i][j].second ^ 1);
				suff[i].pb(uk);
				if (sz(suff[i]) >= 2) {
					add(suff[i].back(), suff[i][sz(suff[i]) - 2]);
				}
				uk++;
			}
			reverse(all(suff[i]));
			for (int j = sz(gp[i]) - 1; j >= 0; j--) {
				add(gp[i][j].second, uk);
				suff1[i].pb(uk);
				if (sz(suff1[i]) >= 2) {
					add(suff1[i][sz(suff1[i]) - 2], suff1[i].back());
				}
				uk++;
			}
			reverse(all(suff1[i]));
		}
	}
	for (int i = 0; i < sz(st1); i++) {
		if (sz(who[i]) <= 1) {
			continue;
		}
		vector<int> pref;
		for (int j = 0; j < sz(who[i]); j++) {
			if (!pref.empty()) {
				add(who[i][j], pref.back());
			}
			add(uk, who[i][j] ^ 1);
			pref.pb(uk);
			if (sz(pref) >= 2) {
				add(pref.back(), pref[sz(pref) - 2]);
			}
			uk++;
		}
		pref.clear();
		reverse(all(who[i]));
		for (int j = 0; j < sz(who[i]); j++) {
			if (!pref.empty()) {
				add(who[i][j], pref.back());
			}
			add(uk, who[i][j] ^ 1);
			pref.pb(uk);
			if (sz(pref) >= 2) {
				add(pref.back(), pref[sz(pref) - 2]);
			}
			uk++;
		}
	}	
	for (int i = 0; i < 2 * n; i++) {
		add(1, 1, ss, kek[i], la[i], i);
	}
	for (int i = 0; i < uk; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	reverse(all(ord));
	memset(used, 0, sizeof(used));
	int c = 0;
	for (auto i: ord) {
		if (!used[i]) {
			c++;
			dfs1(i, c);
		}
	}
	for (int i = 0; i < n; i++) {
		if (col[i * 2] == col[i * 2 + 1]) {
			cout << "No\n";
			return 0;
		}
	}
	cout << "Yes\n";
	for (int i = 0; i < n; i++) {
		if (col[i * 2] > col[i * 2 + 1]) {
			cout << "1\n";
		} else {
			cout << "2\n";
		}
	}
}