#include <bits/stdc++.h>

using namespace std;
template<class T1, class T2> inline void chkmin(T1 &x, const T2 &y) {x = (x > y ? y: x);}
template<class T1, class T2> inline void chkmax(T1 &x, const T2 &y) {x = (x < y ? y: x);}
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
#define left left228
#define right right228
#define rank rank228
#define y1 y1227
using ll = long long;
using ld = long double;


char readChar() {
	char c = getchar_unlocked();
	while (c <= 32) {
		c = getchar_unlocked();
	}
	return c;
}


int readInt() {
	char c = readChar();
	int sign = 0;
	if (c == '-') {
		sign = true;
		c = getchar_unlocked();
	}
	int res = 0;
	while (c >= '0' && c <= '9') {
		res = ((res << 3) + (res << 1)) + c - '0';
		c = getchar_unlocked();
	}
	return (sign ? -res: res);
}

const int MAXN = 800228;


int n, m;
int x[MAXN], y[MAXN];
map<int, vector<pair<int, int> > > whox, whoy;
int ukx, uky;
int wx[MAXN], wy[MAXN];
int valx[MAXN], valy[MAXN];
set<pair<int, int> > sx[MAXN], sy[MAXN], sx1[MAXN], sy1[MAXN];
int mt[MAXN];
bool used[MAXN];
vector<int> g[MAXN];
int deep[MAXN];
vector<pair<int, pair<int, int> > > res;


void add(int x, int y, int x1, int y1) {
	if (x > x1) {
		swap(x, x1);
	}
	if (y > y1) {
		swap(y, y1);
	}
	if (x == x1) {
		res.pb({0, {x, y + 1}});
	} else {
		res.pb({1, {x + 1, y}});
	}
}


void add1(int x, int y) {
	res.pb({0, {x, y + 1}});
}

bool dfs(int u, int pr = -1) {
	used[u] = true;
	vector<int> st;
	for (auto h: g[u]) {
		if (h == pr) {
			continue;
		}
		if (!used[h]) {
			deep[h] = deep[u] + 1;
			if (dfs(h, u)) {
				st.pb(h);
			}
		} else {
			if (deep[h] < deep[u]) {
				st.pb(h);
			}
		}
	}
	//cout << sz(st) << endl;
	bool vs = false;
	if (pr != -1) {
		vs = true;
	}
	if (sz(st) % 2 == 1) {
		if (pr != -1) {
			st.pb(pr);
			vs = false;
		}
	}
	vector<pair<int, int> > g;
	for (auto x: st) {
		if (u < ukx) {
			g.pb({valy[x - ukx], x});
		} else {
			g.pb({valx[x], x});
		}
	}
	sort(all(g));
	while (sz(g) >= 2) {
		int a = g[sz(g) - 2].first;
		if (vs) {
			if (u < ukx) {
				if (valy[pr - ukx] >= a) {
					break;
				}
			} else {
				if (valx[pr] >= a) {
					break;
				}
			}
		}
		if (u < ukx) {
			add(valx[u], g[sz(g) - 2].first, valx[u], g[sz(g) - 1].first);
		} else {
			add(g[sz(g) - 2].first, valy[u - ukx], g[sz(g) - 1].first, valy[u - ukx]);
		}
		g.pop_back();
		g.pop_back();
	}
	reverse(all(g));
	while (sz(g) >= 2) {
		if (u < ukx) {
			add(valx[u], g[sz(g) - 2].first, valx[u], g[sz(g) - 1].first);
		} else {
			add(g[sz(g) - 2].first, valy[u - ukx], g[sz(g) - 1].first, valy[u - ukx]);
		}
		g.pop_back();
		g.pop_back();
	}
	if (pr == -1) {
		if (!g.empty()) {
			if (u < ukx) {
				add1(valx[u], g[0].first);
			} else {
				add1(g[0].first, valy[u - ukx]);
			}
		}
		return false;
	}
	return vs;
}


bool comp(int i, int j) {
	return valy[i - ukx] < valy[j - ukx];
}

bool comp1(int i, int j) {
	return valx[i] < valx[j];
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//assert(freopen("input.in", "r", stdin));
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> y[i];
		whox[x[i]].pb({y[i], i});
		whoy[y[i]].pb({x[i], i});
	}	
	cin >> m;
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		whox[x].pb({y, -1});
		whoy[y].pb({x, -1});
	}
	for (auto z: whox) {
		sort(all(z.second));
		vector<int> cur;
		for (auto cy: z.second) {
			if (cy.second != -1) {
				cur.pb(cy.second);
			} else {
				if (!cur.empty()) {
					for (auto i: cur) {
						sx[ukx].insert({y[i], i});
						wx[i] = ukx;
					}
					valx[ukx] = z.first;
					ukx++;
					cur.clear();
				}
			}
		}
		if (!cur.empty()) {
			for (auto i: cur) {
				sx[ukx].insert({y[i], i});
				wx[i] = ukx;
			}
			valx[ukx] = z.first;
			ukx++;
		}
	}
	for (auto z: whoy) {
		sort(all(z.second));
		vector<int> cur;
		for (auto cy: z.second) {
			if (cy.second != -1) {
				cur.pb(cy.second);
			} else {
				if (!cur.empty()) {
					for (auto i: cur) {
						sy[uky].insert({x[i], i});
						wy[i] = uky;
					}
					valy[uky] = z.first;
					uky++;
					cur.clear();
				}
			}
		}
		if (!cur.empty()) {
			for (auto i: cur) {
				sy[uky].insert({x[i], i});
				wy[i] = uky;
			}
			valy[uky] = z.first;
			uky++;
		}
	}
	for (int i = 0; i < n; i++) {
		g[wx[i]].pb(wy[i] + ukx);
		g[wy[i] + ukx].pb(wx[i]);
		//cout << wx[i] << endl;
	}
	for (int i = 0; i < ukx; i++) {
		sort(all(g[i]), comp);
	}
	for (int i = 0; i < uky; i++) {
		sort(all(g[i + ukx]), comp1);
	}
	for (int i = 0; i < ukx; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	cout << sz(res) << '\n'; 
	for (auto x: res) {
		cout << 1 - x.first << ' ' << x.second.first << ' ' << x.second.second << '\n';
	}
}