#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;

const int N = 1e5 + 100;
struct seg
{
	int l, r;
	seg() {}
	seg(int a, int b) {
		l = a, r = b;
	}
	void in() {
		std::cin >> l >> r;
	}
};
bool inter(seg a, seg b) {
	return std::max(a.l, b.l) <= std::min(a.r, b.r);
}
std::pair<seg,seg> segt[N];
int used[N], cmp[N];
std::vector<int> g[N], gr[N];
void addEdge(int a, int b) {
	g[a].pb(b);
	gr[b].pb(a);
}
std::pair<seg, seg> segments[N];
std::vector<int> order;
void dfs1(int v) {
	used[v] = 1;
	for (auto e : gr[v]) {
		if (!used[e]) {
			dfs1(e);
		}
	}
	order.pb(v);
}
int clr = 1;
void dfs2(int v) {
	cmp[v] = clr;
	for (auto e : g[v]) {
		if (!cmp[e]) {
			dfs2(e);
		}
	}
}
int main() {
	int n;
	std::cin >> n;
	FOR(i, n) {
		segt[i].first.in();
		segt[i].second.in();
		addEdge(4 * i + 1, 4 * i + 2);
		addEdge(4 * i + 3, 4 * i);
		segments[2 * i] = {segt[i].first, {4 * i, 4 * i + 1}};
		segments[2 * i + 1] = {segt[i].second, {4 * i + 2, 4 * i + 3}};
	}
	FOR(i, 2 * n) {
		FOR(j, 2 * n) {
			if (i == j) continue;
			if (inter(segments[i].first, segments[j].first)) {
				addEdge(segments[i].second.l, segments[j].second.r);
			}
		}
	}
	FOR(i, 4 * n) {
		if (!used[i]) {
			dfs1(i);
		}
	}
	std::reverse(order.begin(), order.end());
	for (auto e : order) {
		if (!cmp[e]) {
			dfs2(e);
			clr++;
		}
	}
	FOR(i, 2 * n) {
		if (cmp[2 * i] == cmp[2 * i + 1]) {
			std::cout << "No";
			return 0;
		}
	}
	std::cout << "Yes\n";
	FOR(i, n) {
		if (cmp[4 * i] < cmp[4 * i + 1]) {
			std::cout << 1 << '\n';
		}
		else {
			std::cout << 2 << '\n';
		}
	}
}