#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 1e5;
struct point {
	int x, y;
	friend bool operator<(point a, point b) {
		if (a.x == b.x) {
			return a.y < b.y;
		}
		return a.x < b.x;
	}
};
bool used[N], inAnsw[N];
point a[N], b[N];
std::vector<int> g[N];
std::vector<std::pair<int, point>> answ;
void addTo(int i, int j) {
	if (a[i].x == a[j].x) {
		answ.pb({1, {a[i].x, (a[i].y + a[j].y) / 2}});
	}
	else {
		answ.pb({0, {(a[i].x + a[j].x) / 2, a[i].y}});
	}
}
void dfs(int v, int cnt = 0) {
	used[v] = 1;
	for (auto e : g[v]) {
		if (!used[e]) {
			if (cnt == 0) {
				inAnsw[v] = inAnsw[e] = 1;
				addTo(v, e);
			}
			dfs(e, (cnt + 1) % 2);
		}
	}
}
int main() {
	int n, m;
	std::map<point, int> kek;
	std::cin >> n;
	std::map<int, std::vector<std::pair<int,int>>> x, y;
	FOR(i, n) {
		std::cin >> a[i].x >> a[i].y;
		kek[a[i]] = i;
		x[a[i].x].pb({a[i].y, 0});
		y[a[i].y].pb({a[i].x, 0});
	}
	std::cin >> m;
	FOR(i, m) {
		std::cin >> b[i].x >> b[i].y;
		x[b[i].x].pb({b[i].y, 1});
		y[b[i].y].pb({b[i].x, 1});	
	}
	for (auto e : x) {
		for (int j = 0; j < (int)e.second.size() - 1; ++j) {
			if (e.second[j].second + e.second[j + 1].second == 0) {
				int i1 = kek[{e.first, e.second[j].first}];
				int i2 = kek[{e.first, e.second[j + 1].first}];
				g[i1].pb(i2);
				g[i2].pb(i1);
			}
		}
	}
	for (auto e : y) {
		for (int j = 0; j < (int)e.second.size() - 1; ++j) {
			if (e.second[j].second + e.second[j + 1].second == 0) {
				int i1 = kek[{e.second[j].first, e.first}];
				int i2 = kek[{e.second[j + 1].first, e.first}];
				g[i1].pb(i2);
				g[i2].pb(i1);
			}
		}
	}
	FOR(i, n) {
		if (!used[i]) {
			dfs(i);
		}
		if (!inAnsw[i]) {
			answ.pb({0, {a[i].x - 1, a[i].y}});
		}
	}
	std::cout << answ.size() << '\n';
	for (auto e : answ) {
		std::cout << e.first << ' ' << e.second.x << ' ' << e.second.y << '\n';
	}
}