#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 1e5;
struct point {
	int x, y;
	friend bool operator<(point a, point b) {
		if (a.x == b.x) {
			return a.y < b.y;
		}
		return a.x < b.x;
	}
};
struct fenw
{
	std::vector<int> f;
	fenw(int n) {
		f.resize(n);
	}
	void add(int i, int x) {
		for (; i < f.size(); i = (i | (i + 1))) f[i] += x;
	}
	int get(int r) {
		int s = 0;
		for (; r >= 0; r = (r & (r + 1)) - 1) s += f[r];
		return s;
	}
	int get(int l, int r) {
		return get(r) - get(l - 1);
	}
};
point a[N], b[N];
std::map<int, std::vector<int>> x;
int getInd(std::vector<int> &a, int y) {
	return std::lower_bound(a.begin(), a.end(), y) - a.begin();
}
std::pair<int,int> getBound(std::vector<int> &x, int y) {
	auto it1 = std::lower_bound(x.begin(), x.end(), y) - x.begin();
	return {it1, it1 - 1};
}
int main() {
	int n, m;
	std::cin >> n;
	std::vector<int> compress;
	FOR(i, n) {
		std::cin >> a[i].x >> a[i].y;
		compress.pb(a[i].y);
		// x[b[i].y].pb(a[i].x);
	}
	std::cin >> m;
	for (auto t : {2, 4}) {
		x[t].pb(0);
		x[t].pb(1e9);
	}
	FOR(i, m) {
		std::cin >> b[i].x >> b[i].y;
		x[b[i].x].pb(b[i].y);
	}
	for (auto &e : x) {
		std::sort(e.second.begin(), e.second.end());
	}
	for (auto t : {2, 4}) {
		for (auto e : x[t]) {
			compress.pb(e);
		}
	}
	std::sort(compress.begin(), compress.end());
	compress.resize(std::unique(compress.begin(), compress.end()) - compress.begin());
	fenw f1(compress.size()), f2(compress.size());
	FOR(i, n) {
		if (a[i].x == 2) {
			f1.add(getInd(compress, a[i].y), 1);
		}
		else {
			f2.add(getInd(compress, a[i].y), 1);
		}
	}
	std::vector<std::pair<int, point>> answ;
	while (true) {
		int s = 0, mxI = -1;
		FOR(i, n) {
			int ind = getInd(compress, a[i].y);
			if (f1.get(ind, ind) != 0 && f2.get(ind, ind) != 0) {
				auto bound1 = getBound(x[2], a[i].y), bound2 = getBound(x[4], a[i].y);
				int sum1 = f1.get(getInd(compress, bound1.first), getInd(compress, bound1.second));
				int sum2 = f2.get(getInd(compress, bound2.first), getInd(compress, bound2.second));
				if ((sum1 % 2 + sum2 % 2) > s) {
					s = sum1 % 2 + sum2 % 2;
					mxI = i;
				}
			}
		}
		if (mxI == -1) break;
		answ.pb({0, {3, a[mxI].y}});
		int ind = getInd(compress, a[mxI].y);
		f1.add(ind, -1); f2.add(ind, -1);
	}
	std::vector<int> s1, s2;
	FOR(i, compress.size()) {
		if (f1.get(i, i)) {
			s1.pb(i);
		}
		if (f2.get(i, i)) {
			s2.pb(i);
		}
	}
	{
		int nowBorder = 0, curI = 0;
		while (curI < s1.size()) {
			std::vector<int> kek;
			while (curI < s1.size() && s1[curI] < x[2][nowBorder + 1]) {
				kek.pb(s1[curI++]);
			}
			for (int j = 0; j < kek.size(); j += 2) {
				answ.pb({1, {2, compress[kek[j]] + 1}});
			}
			++nowBorder;
		}
	}
	{
		int nowBorder = 0, curI = 0;
		while (curI < s2.size()) {
			std::vector<int> kek;
			while (curI < s2.size() && s2[curI] < x[4][nowBorder + 1]) {
				kek.pb(s2[curI++]);
			}
			for (int j = 0; j < kek.size(); j += 2) {
				answ.pb({1, {4, compress[kek[j]] + 1}});
			}
			++nowBorder;
		}
	}
	std::cout << answ.size() << '\n';
	for (auto e : answ) {
		std::cout << e.first << ' ' << e.second.x << ' ' << e.second.y << '\n';
	}
}