#include <bits/stdc++.h>
using namespace std;
#define all(x) x.begin(), x.end()



/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////


const int B = 1 << 12;

char input[B];
int inlen = 0;
int inptr = 0;

bool eof() {
	if (inlen == inptr) {
		inlen = (int)fread(input, 1, B, stdin);
		inptr = 0;
	}
	return inlen == inptr;
}

char gc() {
	return eof() ? -1 : input[inptr++];
}

char readchar() {
	char c = gc();
	while (c == ' ') {
		c = gc();
	}
	return c;
}

int readint() {
	int t;
	cin >> t;
	return t;
	int sign = +1;
	int sum  = 0;
	char c = readchar();
	if (c == '-') {
		sign = -1;
		c = gc();
	}
	while ('0' <= c && c <= '9') {
		sum = 10 * sum + c - '0';
		c = gc();
	}
	return sign * sum;
}

char output[B];
int outptr = 0;

void flush() {
	fwrite(output, 1, outptr, stdout);
	outptr = 0;
}

struct flusher {
	~flusher() {
		flush();
	}
} instance;

void pc(char c) {
	if (outptr == B) {
		flush();
	}
	output[outptr++] = c;
}

void writeint(int x, char e = 0) {
	cout << x;
	if (e) {
		cout << e;
	}
	return;
	static char s[30];
	if (x < 0) {
		x *= -1;
		pc('-');
	}
	int n = 0;
	while (!n || x > 0) {
		s[n++] = char('0' + x % 10);
		x /= 10;
	}
	while (--n >= 0) {
		pc(s[n]);
	}
	if (e) {
		pc(e);
	}
}

/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////

const int N = 1e6;
int n;
int m;
int vx[N];
int vy[N];
int sx[N];
int sy[N];

int z[N];
int zsize = 0;

set<pair<int, int>> bx[N];
set<pair<int, int>> by[N];

int zip(int x) {
	return int(lower_bound(z, z + zsize, x) - z);
}

int xless(int v) {
	auto it = by[vy[v]].lower_bound({vx[v], INT_MIN});
	if (it == by[vy[v]].begin()) {
		return -1;
	}
	--it;
	return it->second;
}

int xgreater(int v) {
	auto it = by[vy[v]].upper_bound({vx[v], INT_MAX});
	if (it == by[vy[v]].end()) {
		return -1;
	}
	return it->second;
}

int yless(int v) {
	auto it = bx[vx[v]].lower_bound({vy[v], INT_MIN});
	if (it == bx[vx[v]].begin()) {
		return -1;
	}
	--it;
	return it->second;
}

int ygreater(int v) {
	auto it = bx[vx[v]].upper_bound({vy[v], INT_MAX});
	if (it == bx[vx[v]].end()) {
		return -1;
	}
	return it->second;
}

bool used[N];

int deg(int v) {
	assert(bx[vx[v]].size() && by[vy[v]].size());
	int d = xless(v) != -1;
	d += xgreater(v) != -1;
	d += yless(v) != -1;
	d += ygreater(v) != -1;
	return d;
}

void del(int v) {
	assert(!used[v]);
	used[v] = true;
	bx[vx[v]].erase({vy[v], v});
	by[vy[v]].erase({vx[v], v});
}

vector<tuple<int, int, int>> answer;
set<pair<int, int>> fi, se;
int comp[N];
int size[N];

int main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	
	n = readint();
	for (int i = 0; i < n; ++i) {
		int x = readint();
		int y = readint();
		if (x == 2) {
			fi.emplace(y, i);
		} else {
			se.emplace(y, i);
		}
	}
	m = readint();
	for (int i = 0; i < m; ++i) {
		int x = readint();
		int y = readint();
		if (x == 2) {
			fi.emplace(y, -1);
		} else {
			se.emplace(y, -1);
		}
	}
	
	int curcomp = 0;
	for (auto e : fi) {
		if (e.second == -1) {
			++curcomp;
		} else {
			comp[e.second] = curcomp;
		}
	}
	++curcomp;
	for (auto e : se) {
		if (e.second == -1) {
			++curcomp;
		} else {
			comp[e.second] = curcomp;
		}
	}
	for (int i = 0; i < n; ++i) {
		++size[comp[i]];
	}


	while (1) {
		bool run = false;
		vector<pair<int, int>> er;
		for (auto e : fi) {
			int y = e.first;
			int v = e.second;
			auto it = se.lower_bound({y, INT_MIN});
			if (it != se.end() && it->first == y) {
				int u = it->second;
				if (size[v] % 2 || size[u] % 2) {
					--size[v];
					--size[u];
					er.push_back(e);
					se.erase(*it);
					answer.emplace_back(0, 3, y);
					run = true;
				}
			}
		}
		for (auto e : er) {
			fi.erase(e);
		}
		er.clear();
		for (auto e : se) {
			int y = e.first;
			int v = e.second;
			auto it = fi.lower_bound({y, INT_MIN});
			if (it != fi.end() && it->first == y) {
				int u = it->second;
				if (size[v] % 2 || size[u] % 2) {
					--size[v];
					--size[u];
					er.push_back(e);
					fi.erase(*it);
					answer.emplace_back(0, 3, y);
					run = true;
				}
			}
		}
		for (auto e : er) {
			se.erase(e);
		}
		if (!run) {
			break;
		}
	}
	
	while (fi.size()) {
		int v = fi.begin()->second;
		int y = fi.begin()->first;
		fi.erase(fi.begin());
		if (v == -1) {
			continue;
		}
		if (fi.size()) {
			fi.erase(fi.begin());
		}
		answer.emplace_back(1, 2, y + 1);
	}
	while (se.size()) {
		int v = se.begin()->second;
		int y = se.begin()->first;
		se.erase(se.begin());
		if (v == -1) {
			continue;
		}
		if (se.size()) {
			se.erase(se.begin());
		}
		answer.emplace_back(1, 4, y + 1);
	}
	cout << answer.size() << "\n";
	for (auto e : answer) {
		int a, b, c;
		tie(a, b, c) = e;
		cout << a << " " << b << " " << c << "\n";
	}
	return 0;
}
