#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
//#define int ll

const int N = 1e5 + 10;
vector<int> g[4 * N], rg[4 * N], order;
bool used[4 * N];
int color[4 * N], a[N], b[N], c[N], d[N];

inline bool inter(int a, int b, int c, int d) {
	return max(a, c) <= min(b, d);
}

void dfs(int v) {
	used[v] = true;
	for (auto u : g[v]) {
		if (!used[u]) {
			dfs(u);
		}
	}
	order.pb(v);
}

void dfs2(int v, int cl) {
	color[v] = cl;
	for (auto u : rg[v]) {
		if (!color[u]) {
			dfs2(u, cl);
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> a[i] >> b[i] >> c[i] >> d[i];
		g[2 * n + i].pb(n + i);
		g[3 * n + i].pb(i);
		rg[n + i].pb(2 * n + i);
		rg[i].pb(3 * n + i);
	}
	for (int i = 1; i < n; i++) {
		for (int j = i + 1; j <= n; j++) {
			if (inter(a[i], b[i], a[j], b[j])) {
				g[i].pb(2 * n + j);
				g[j].pb(2 * n + i);
				rg[2 * n + i].pb(j);
				rg[2 * n + j].pb(i);
			}
			if (inter(a[i], b[i], c[j], d[j])) {
				g[i].pb(3 * n + j);
				g[n + j].pb(2 * n + i);
				rg[3 * n + j].pb(i);
				rg[2 * n + i].pb(n + j);
			}
			if (inter(c[i], d[i], a[j], b[j])) {
				g[n + i].pb(2 * n + j);
				g[j].pb(3 * n + i);
				rg[2 * n + j].pb(n + i);
				rg[3 * n + i].pb(j);
			}
			if (inter(c[i], d[i], c[j], d[j])) {
				g[n + i].pb(3 * n + j);
				g[n + j].pb(3 * n + i);
				rg[3 * n + j].pb(n + i);
				rg[3 * n + i].pb(n + j);
			}
		}
	}
	for (int i = 1; i <= 4 * n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	reverse(all(order));
	int cnt = 0;
	for (auto it : order) {
		if (!color[it]) {
			dfs2(it, ++cnt);
		}
	}
	for (int i = 1; i <= 2 * n; i++) {
		if (color[i] == color[i + 2 * n]) {
			cout << "No\n";
			exit(0);
		}
	}
	cout << "Yes\n";
	/*for (int i = 1; i <= n; i++) {
		cout << color[i] << ' ' << color[n + i] << ' ' << color[2 * n + i] << ' ' << color[3 * n + i] << '\n';
	}*/
	for (int i = 1; i <= n; i++) {
		if (color[i] > color[n + i]) {
			cout << 1 << '\n';
		}
		else {
			cout << 2 << '\n';
		}
	}
}