#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
//#define int ll

const int N = 1e5 + 10;
vector<int> g[4 * N], rg[4 * N], order;
bool used[4 * N];
int color[4 * N], a[N], b[N], c[N], d[N], n;
set<pair<pair<int, int>, int>> unused, uncolored;
inline bool inter(int a, int b, int c, int d) {
	return max(a, c) <= min(b, d);
}

void dfs(int v) {
	if (v < 0) {
		exit(0);
	}
	used[v] = true;
	int L, R, id;
	if (v <= n) {
		L = a[v], R = b[v];
	}
	else if (v <= 2 * n) {
		L = c[v - n], R = d[v - n];
	}
	else if (v <= 3 * n) {
		L = a[v - 2 * n], R = b[v - 2 * n];
	}
	else {
		L = c[v - 3 * n], R = d[v - 3 * n];
	}
	if (v <= 2 * n) {
		id = v;
	}
	else {
		id = v - 2 * n;
	}
	if (v > 2 * n) {
		unused.erase(make_pair(make_pair(L, R), id));
		for (auto u : g[v]) {
			if (!used[u]) {
				dfs(u);
			}
		}
	}
	else {
		for (;;) {
			auto cur = unused.upper_bound(make_pair(make_pair(L, R), id));
			if (cur == unused.end() || cur->F.F > R) {
				break;
			}
			if (!used[cur->S + 2 * n]) {
				dfs(cur->S + 2 * n);
			}
		}
		for (;;) {
			auto cur = unused.lower_bound(make_pair(make_pair(L, R), id));
			if (cur == unused.begin()) {
				break;
			}
			cur--;
			if (cur->F.S < L) {
				break;
			}
			if (!used[cur->S + 2 * n]) {
				dfs(cur->S + 2 * n);
			}
		}
	}
	order.pb(v);
}

void dfs2(int v, int cl) {
	color[v] = cl;
	int L, R, id;
	if (v <= n) {
		L = a[v], R = b[v];
	}
	else if (v <= 2 * n) {
		L = c[v - n], R = d[v - n];
	}
	else if (v <= 3 * n) {
		L = a[v - 2 * n], R = b[v - 2 * n];
	}
	else {
		L = c[v - 3 * n], R = d[v - 3 * n];
	}
	if (v <= 2 * n) {
		id = v;
	}
	else {
		id = v - 2 * n;
	}
	if (v <= 2 * n) {
		uncolored.erase(make_pair(make_pair(L, R), id));
		for (auto u : rg[v]) {
			if (!color[u]) {
				dfs2(u, cl);
			}
		}
	}
	else {
		for (;;) {
			auto cur = uncolored.upper_bound(make_pair(make_pair(L, R), id));
			if (cur == uncolored.end() || cur->F.F > R) {
				break;
			}
			if (!color[cur->S]) {
				dfs2(cur->S, cl);
			}
		}
		for (;;) {
			auto cur = uncolored.lower_bound(make_pair(make_pair(L, R), id));
			if (cur == uncolored.begin()) {
				break;
			}
			cur--;
			if (cur->F.S < L) {
				break;
			}
			if (!color[cur->S]) {
				dfs2(cur->S, cl);
			}
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> a[i] >> b[i] >> c[i] >> d[i];
		g[2 * n + i].pb(n + i);
		g[3 * n + i].pb(i);
		rg[n + i].pb(2 * n + i);
		rg[i].pb(3 * n + i);
		unused.insert(make_pair(make_pair(a[i], b[i]), i));
		uncolored.insert(make_pair(make_pair(a[i], b[i]), i));
		unused.insert(make_pair(make_pair(c[i], d[i]), n + i));
		uncolored.insert(make_pair(make_pair(c[i], d[i]), n + i));
	}
	/*for (auto it : arr) {
		//cout << it.S << ' ';
		auto cur = upper_bound(all(arr), it);
		for (;;) {
			if (cur == arr.end() || cur->F.F > it.F.S) {
				break;
			}
			int id1 = it.S, id2 = cur->S;
			g[id1].pb(2 * n + id2);
			g[id2].pb(2 * n + id1);
			rg[2 * n + id1].pb(id2);
			rg[2 * n + id2].pb(id1);
			cur = upper_bound(all(arr), make_pair(make_pair(cur->F.S + 1, 0), 0));
		}
	}*/
	//cout << '\n';
	/*for (int i = 1; i < n; i++) {
		for (int j = i + 1; j <= n; j++) {
			if (inter(a[i], b[i], a[j], b[j])) {
				g[i].pb(2 * n + j);
				g[j].pb(2 * n + i);
				rg[2 * n + i].pb(j);
				rg[2 * n + j].pb(i);
				cout << i << ' ' << j << '\n';
			}
			if (inter(a[i], b[i], c[j], d[j])) {
				g[i].pb(3 * n + j);
				g[n + j].pb(2 * n + i);
				cout << i << ' ' << n + j << '\n';
				rg[3 * n + j].pb(i);
				rg[2 * n + i].pb(n + j);
			}
			if (inter(c[i], d[i], a[j], b[j])) {
				g[n + i].pb(2 * n + j);
				g[j].pb(3 * n + i);
				cout << n + i << ' ' << j << '\n';
				rg[2 * n + j].pb(n + i);
				rg[3 * n + i].pb(j);
			}
			if (inter(c[i], d[i], c[j], d[j])) {
				g[n + i].pb(3 * n + j);
				g[n + j].pb(3 * n + i);
				cout << n + i << ' ' << n + j << '\n';
				rg[3 * n + j].pb(n + i);
				rg[3 * n + i].pb(n + j);
			}
		}
	}*/
	for (int i = 1; i <= 4 * n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	reverse(all(order));
	int cnt = 0;
	for (auto it : order) {
		if (!color[it]) {
			dfs2(it, ++cnt);
		}
	}
	/*for (int i = 1; i <= n; i++) {
		cout << color[i] << ' ' << color[n + i] << ' ' << color[2 * n + i] << ' ' << color[3 * n + i] << '\n';
	}
	cout << '\n';*/
	for (int i = 1; i <= 2 * n; i++) {
		if (color[i] == color[i + 2 * n]) {
			cout << "No\n";
			exit(0);
		}
	}
	cout << "Yes\n";
	/*for (int i = 1; i <= n; i++) {
		cout << color[i] << ' ' << color[n + i] << ' ' << color[2 * n + i] << ' ' << color[3 * n + i] << '\n';
	}*/
	for (int i = 1; i <= n; i++) {
		if (color[i] > color[n + i]) {
			cout << 1 << '\n';
		}
		else {
			cout << 2 << '\n';
		}
	}
}