#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
//#define int ll

const int N = 1e5 + 10;
vector<int> g[4 * N], rg[4 * N], order;
bool used[4 * N];
int color[4 * N], a[N], b[N], c[N], d[N], n;
set<pair<pair<int, int>, int>> unused, uncolored;
inline bool inter(int a, int b, int c, int d) {
	return max(a, c) <= min(b, d);
}

void dfs(int v) {
	used[v] = true;
	int L, R, id;
	if (v <= n) {
		L = a[v], R = b[v];
	}
	else if (v <= 2 * n) {
		L = c[v - n], R = d[v - n];
	}
	else if (v <= 3 * n) {
		L = a[v - 2 * n], R = b[v - 2 * n];
	}
	else {
		L = c[v - 3 * n], R = d[v - 3 * n];
	}
	if (v <= 2 * n) {
		id = v;
	}
	else {
		id = v - 2 * n;
	}
	if (v > 2 * n) {
		unused.erase(make_pair(make_pair(L, R), id));
		for (auto u : g[v]) {
			if (!used[u]) {
				dfs(u);
			}
		}
	}
	else {
		for (;;) {
			auto cur = unused.upper_bound(make_pair(make_pair(L, R), id));
			if (cur == unused.end() || cur->F.F > R) {
				break;
			}
			assert(!used[cur->S + 2 * n]);
			dfs(cur->S + 2 * n);
		}
		for (;;) {
			auto cur = unused.lower_bound(make_pair(make_pair(L, R), id));
			if (cur == unused.begin()) {
				break;
			}
			cur--;
			if (cur->F.S < L) {
				break;
			}
			assert(!used[cur->S + 2 * n]);
			dfs(cur->S + 2 * n);
		}
	}
	order.pb(v);
}

void dfs2(int v, int cl) {
	color[v] = cl;
	int L, R, id;
	if (v <= n) {
		L = a[v], R = b[v];
	}
	else if (v <= 2 * n) {
		L = c[v - n], R = d[v - n];
	}
	else if (v <= 3 * n) {
		L = a[v - 2 * n], R = b[v - 2 * n];
	}
	else {
		L = c[v - 3 * n], R = d[v - 3 * n];
	}
	if (v <= 2 * n) {
		id = v;
	}
	else {
		id = v - 2 * n;
	}
	if (v <= 2 * n) {
		uncolored.erase(make_pair(make_pair(L, R), id));
		for (auto u : rg[v]) {
			if (!color[u]) {
				dfs2(u, cl);
			}
		}
	}
	else {
		for (;;) {
			auto cur = uncolored.upper_bound(make_pair(make_pair(L, R), id));
			if (cur == uncolored.end() || cur->F.F > R) {
				break;
			}
			assert(!color[cur->S]);
			dfs2(cur->S, cl);
		}
		for (;;) {
			auto cur = uncolored.lower_bound(make_pair(make_pair(L, R), id));
			if (cur == uncolored.begin()) {
				break;
			}
			cur--;
			if (cur->F.S < L) {
				break;
			}
			assert(!color[cur->S]);
			dfs2(cur->S, cl);
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> a[i] >> b[i] >> c[i] >> d[i];
		g[2 * n + i].pb(n + i);
		g[3 * n + i].pb(i);
		rg[n + i].pb(2 * n + i);
		rg[i].pb(3 * n + i);
		unused.insert(make_pair(make_pair(a[i], b[i]), i));
		uncolored.insert(make_pair(make_pair(a[i], b[i]), i));
		unused.insert(make_pair(make_pair(c[i], d[i]), n + i));
		uncolored.insert(make_pair(make_pair(c[i], d[i]), n + i));
	}
	for (int i = 1; i <= 4 * n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	reverse(all(order));
	int cnt = 0;
	for (auto it : order) {
		if (!color[it]) {
			dfs2(it, ++cnt);
		}
	}
	for (int i = 1; i <= 2 * n; i++) {
		if (color[i] == color[i + 2 * n]) {
			cout << "No\n";
			exit(0);
		}
	}
	cout << "Yes\n";
	for (int i = 1; i <= n; i++) {
		if (color[i] > color[n + i]) {
			cout << 1 << '\n';
		}
		else {
			cout << 2 << '\n';
		}
	}
}