#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
#define int ll

const int EPS = 100;

vector<int> convert(int n) {
	vector<int> res;
	while (n) {
		res.pb(n % 2);
		n /= 2;
	}
	reverse(all(res));
	return res;
}

int convert2(vector<int> n) {
	int res = 0;
	for (auto it : n) {
		res = res * 2 + it;
	}
	return res;
}

vector<int> sum(vector<int> a, vector<int> b) {
	reverse(all(a));
	reverse(all(b));
	while (SZ(a) < SZ(b)) {
		a.pb(0);
	}
	while (SZ(b) < SZ(a)) {
		b.pb(0);
	}
	vector<int> c;
	int d = 0;
	for (int i = 0; i < SZ(a); i++) {
		c.pb((a[i] + b[i] + d) % 2);
		d = (a[i] + b[i] + d) / 2;
	}
	if (d) {
		c.pb(d);
	}
	reverse(all(c));
	return c;
}

int fast_solve(int n) {
	vector<int> last_kek;
	if (n & 1) {
		for (int i = 1; i <= min(n, 100ll); i++) {
			if (i & 1) {
				last_kek.pb(1);
			}
			else {
				last_kek.pb(0);
			}
		}
	}
	else {
		for (int i = 1; i <= min(n, 100ll); i++) {
			if (i & 1) {
				last_kek.pb(0);
			}
			else {
				last_kek.pb(1);
			}
		}
	}
	reverse(all(last_kek));	
	int cnt_ones = 0;
	for (auto it : last_kek) {
		cnt_ones += it;
	}
	int other_ones = (n + 1) / 2 - cnt_ones;
	for (int i = max(1ll, n / 2 - EPS); i <= min(n, n / 2 + EPS); i++) {
		vector<int> cur = sum(convert(i), last_kek);
		if (cur.back() == 1) {
			continue;
		}
		int flex = 0;
		for (auto it : cur) {
			flex += it;
		}
		if (flex + other_ones == i) {
			return i;
		}
	}
	return 0;
}

int slow_solve(int n) {
	int need = 0;
	for (int i = 1; i <= n; i++) {
		if (i & 1) {
			need = need * 2 + 1;
		}
		else {
			need *= 2;
		}
	}
	for (int i = 1; i <= n; i++) {
		int vl = need + i;
		if (vl % 2 == 0 && __builtin_popcountll(vl / 2) == i) {
			return i;
		}
	}
	return 0;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	cout << fast_solve(n) << '\n';
}	