#include <bits/stdc++.h>

using namespace std;

const int N = 4e3 + 7;

vector <int> g[2 * N];
vector <int> rg[2 * N];

vector <int> t;
bool used[2 * N];

void dfs(int u) {
	used[u] = 1;
	for (auto v : g[u]) {
		if (!used[v]) {
			dfs(v);
		}
	}
	t.push_back(u);
}

void add(int a, int b) {
	g[a].push_back(b);
	rg[b].push_back(a);
}

int cmp[2 * N];

int cnt = 0;

void jhfs(int u) {
	used[u] = 1;
	cmp[u] = cnt;
	for (auto v : rg[u]) {
		if (!used[v]) {
			jhfs(v);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif
	int n;
	cin >> n;
	vector <pair <int, int>> a(n), b(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second >> b[i].first >> b[i].second;
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (i == j) continue;
			if (max(a[i].first, a[j].first) <= min(a[i].second, a[j].second)) {
				add(2 * i, 2 * j + 1);
			}
			if (max(a[i].first, b[j].first) <= min(a[i].second, b[j].second)) {
				add(2 * i, 2 * j);
			}
			if (max(b[i].first, a[j].first) <= min(b[i].second, a[j].second)) {
				add(2 * i + 1, 2 * j + 1);
			}
			if (max(b[i].first, b[j].first) <= min(b[i].second, b[j].second)) {
				add(2 * i + 1, 2 * j);
			}
		}
	}
	for (int i = 0; i < 2 * n; ++i) {
		if (!used[i]) {
			dfs(i);
		}
	}
	reverse(t.begin(), t.end());
	for (int i = 0; i < 2 * n; ++i) used[i] = 0;
	for (int x : t) {
		if (!used[x]) {
			jhfs(x);
			++cnt;
		}
	}
	for (int i = 0; i < n; ++i) {
		if (cmp[2 * i] == cmp[2 * i + 1]) {
			cout << "No\n";
			return 0;
		}
	}
	cout << "Yes\n";
	for (int i = 0; i < n; ++i) {
		if (cmp[2 * i] > cmp[2 * i + 1]) {
			cout << "1\n";
		} else {
			cout << "2\n";
		}
	}
}