#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int smartGet(int n) {
	const int L = 20;
	const ll mx = (1LL << (2 * L)) - 1;
	ll need = 0;
	if (n % 2 == 0) {
		for (int i = 1; i < min(n, 2 * L); i += 2) need |= (1LL << i);
	} else {
		for (int i = 0; i < min(n, 2 * L); i += 2) need |= (1LL << i);
	}
	ll mask = 0;
	int cnt = 0;
	if (n > 2 * L) {
		cnt += (n - 1 - 2 * L) / 2 + 1;
		mask = ((ll)mx * cnt) & mx;
	}
	for (int i = min(n - 1, 2 * L - 1); i >= L; --i) {
		if (i % 2 == (n - 1) % 2) {
			++cnt;
			mask += (1LL << i) - 1;
			mask &= mx;
		}
	}
	int ans = 0;
	for (int ex = 0; ex < (1 << L); ++ex) {
		int cur_cnt = cnt;
		ll cur_mask = mask;
		for (int i = 1; i < L; ++i) {
			if (ex & (1 << i)) {
				cur_mask += (1 << i) - 1;
				cur_mask &= mx;
				++cur_cnt;
			}
		}
		if (cur_mask == need) {
			ans = cur_cnt;
		}
	}
	return ans;
}

int smart2Get(int n) {
	const int L = 10;
	const ll mx = (1 << L) - 1;
	ll need = 0;
	if (n % 2 == 0) {
		for (int i = 1; i < min(n, L); i += 2) need |= (1LL << i);
	} else {
		for (int i = 0; i < min(n, L); i += 2) need |= (1LL << i);
	}
	ll mask = 0;
	int cnt = 0;
	if (n > L) {
		cnt += (n - 1 - L) / 2 + 1;
		mask = ((ll)mx * cnt) & mx;
	}
	int ans = 0;
	for (int ex = 0; ex < (1 << L); ++ex) {
		int cur_cnt = cnt;
		ll cur_mask = mask;
		for (int i = 1; i < L; ++i) {
			if (ex & (1 << i)) {
				cur_mask += (1 << i) - 1;
				cur_mask &= mx;
				++cur_cnt;
			}
		}
		if (cur_mask == need) {
			ans = cur_cnt;
		}
	}
	return ans;
}

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.setf(ios::fixed); cout.precision(20);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif
	int n;
	cin >> n;
	cout << smartGet(n) << endl;
	/*for (int i = 1; i <= 1000; ++i) {
		cout << i << endl;
		if (smartGet(i) != smart2Get(i)) {
			cout << i << ' ' << smartGet(i) << ' ' << smart2Get(i) << endl;
		}
	}*/
}	
