#include <bits/stdc++.h>

using namespace std;

struct go {
	int c; int x, y;
};

map <int, set <pair <int, int>>> xs, ys;

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0); cout.setf(ios::fixed); cout.precision(20);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	#endif
	int n;
	cin >> n;
	vector <pair <int, int>> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].first >> a[i].second;
		xs[a[i].first].insert({a[i].second, 0});
		ys[a[i].second].insert({a[i].first, 0});
	}
	int m;
	cin >> m;
	vector <pair <int, int>> b(m);
	for (int i = 0; i < m; ++i) {
		cin >> b[i].first >> b[i].second;
		xs[b[i].first].insert({b[i].second, 1});
		ys[b[i].second].insert({b[i].first, 1});
	}	
	auto canHor = [&] (int i, int j) {
		int x1 = a[i].first, y1 = a[i].second, x2 = a[j].first, y2 = a[j].second;
		if (x1 != x2) return false;
		if (y1 > y2) swap(y1, y2);
		auto it = xs[x1].lower_bound(make_pair(y1 + 1, -1));
		if (it == xs[x1].end() || (*it) != make_pair(y2, 0)) return false;
		return true;
	};
	auto canVer = [&] (int i, int j) {
		int x1 = a[i].first, y1 = a[i].second, x2 = a[j].first, y2 = a[j].second;
		if (y1 != y2) return false;
		if (x1 > x2) swap(x1, x2);
		auto it = ys[y1].lower_bound(make_pair(x1 + 1, -1));
		if (it == ys[y1].end() || (*it) != make_pair(x2, 0)) return false;
		return true;
	};
	auto del = [&] (int i) {
		xs[a[i].first].erase({a[i].second, 0});
		ys[a[i].second].erase({a[i].first, 0});
	};
	vector <int> id(n);
	iota(id.begin(), id.end(), 0);
	vector <int> ans = id;
	int best = 0;
	map <int, set <pair <int, int>>> ts = xs, ty = ys;
	do {
		if ((double)clock() / CLOCKS_PER_SEC > 0.9) break;
		xs = ts, ys = ty;
		int can = 0;
		for (int i = 0; i + 1 < n; i += 2) {
			if (canVer(id[i], id[i + 1]) || canHor(id[i], id[i + 1])) {
				++can;
				del(id[i]);
				del(id[i + 1]);
			} else {
				break;
			}
		}
		if (can > best) {
			best = can;
			ans = id;
		}
	} while (next_permutation(id.begin(), id.end()));
	cout << n - best << '\n';
	vector <go> res;
	for (int i = 0; i < best; ++i) {
		int x1 = a[ans[2 * i]].first, y1 = a[ans[2 * i]].second, x2 = a[ans[2 * i + 1]].first, y2 = a[ans[2 * i + 1]].second;
		if (x1 == x2) {
			res.push_back({1, x1, min(y1, y2) + 1});
		} else if (y1 == y2) {
			res.push_back({0, min(x1, x2) + 1, y1});
		}
	}
	for (int i = 2 * best; i < n; ++i) {
		res.push_back({0, a[ans[i]].first + 1, a[ans[i]].second});
	}
	for (auto r : res) {
		cout << r.c << ' ' << r.x << ' ' << r.y << '\n';
	}
}		