#include <bits/stdc++.h>
using namespace std;

int xb[10005];
int yb[10005];
int xs[10005];
int ys[10005];

struct solution{
    int a, x, y;
};

int n, m;

set <pair <int, int>> q;

bool poredak(int a, int b, int c){
    return min(a, c) < b && max(a, c) > b;
}

pair <int, vector <solution>> resi(vector <int> boxes){
    //pair <int, vector <solution>> tren;
    //tren.first = n+5;
    for(int i=1; i<=n; i++){
        //cout << boxes[i] << " ";
    }
    //cout << endl;
    while(!q.empty()){
        pair <int, int> p = *q.begin();
        if(boxes[p.first] && boxes[p.second]){
            int a = p.first;
            int b = p.second;
            boxes[a] = 0;
            boxes[b] = 0;
            pair <int, vector <solution>> nesto = resi(boxes);
            nesto.first++;
            if(xb[a] == xb[b]){
                nesto.second.push_back({1, xb[a], min(yb[a], yb[b]) + 1});
            }
            else{
                nesto.second.push_back({0, min(xb[a], xb[b]) + 1, yb[a]});
            }
            return nesto;
        }
        q.erase(p);
    }
    //if(tren.first != n+5) return tren;
    for(int i=1; i<=n; i++){
        if(boxes[i]){
            boxes[i] = 0;
            pair <int, vector <solution>> nesto = resi(boxes);
            nesto.first++;
            nesto.second.push_back({0, xb[i]+1, yb[i]});
            return nesto;
        }
    }
    //if(tren.first == n+5) return ({0, {}});
    return {0, {}};
}

int main(){
    ios_base::sync_with_stdio(false);

    cin >> n;
    vector <int> prvo;
    prvo.push_back(0);
    for(int i=1; i<=n; i++){
        cin >> xb[i] >> yb[i];
        prvo.push_back(1);
    }
    cin >> m;
    for(int i=1; i<=m; i++){
        cin >> xs[i] >> ys[i];
    }

    for(int i=1; i<=n; i++){
        for(int j=i+1; j<=n; j++){
            if(xb[i] == xb[j]){
                bool moze = 1;
                for(int k=1; k<=n; k++){
                    if(xb[k] == xb[i] && poredak(yb[i], yb[k], yb[j])) moze = 0;
                }
                for(int k=1; k<=m; k++){
                    if(xs[k] == xb[i] && poredak(yb[i], ys[k], yb[j])) moze = 0;
                }
                if(moze){
                    q.insert({i, j});
                }
            }
            else if(yb[i] == yb[j]){
                bool moze = 1;
                for(int k=1; k<=n; k++){
                    if(yb[k] == yb[i] && poredak(xb[i], xb[k], xb[j])) moze = 0;
                }
                for(int k=1; k<=m; k++){
                    if(ys[k] == yb[i] && poredak(xb[i], xs[k], xb[j])) moze = 0;
                }
                if(moze){
                    q.insert({i, j});
                }
            }
        }
    }

    pair <int, vector <solution>> resenje = resi(prvo);
    cout << resenje.first << "\n";
    reverse(resenje.second.begin(), resenje.second.end());
    for(int i=0; i<resenje.first; i++){
        cout << resenje.second[i].a << " " << resenje.second[i].x << " " << resenje.second[i].y << "\n";
    }
    return 0;
}

/*
8
6 2
11 4
2 9
6 7
4 9
6 4
6 9
11 9
2
11 7
8 9
*/
