#include <bits/stdc++.h>
using namespace std;

int a[100005];
int b[100005];
int c[100005];
int d[100005];

bool visited[100005];
bool visited2[100005];

vector <int> graf[200005];
vector <int> rgraf[200005];

queue <int> q;

void nazad(int v){
    visited2[v] = 1;
    for(auto c : graf[v]){
        if(!visited2[c]) nazad(c);
    }
}

void dfs(int v){
    visited[v] = 1;
    q.push(v);
    for(auto c : graf[v]){
        if(!visited[c]) nazad(c);
    }
}

int main(){
    ios_base::sync_with_stdio(false);

    int n;
    cin >> n;
    for(int i=1; i<=n; i++){
        cin >> a[i] >> b[i] >> c[i] >> d[i];
    }
    for(int i=1; i<=n; i++){
        for(int j=1; j<=n; j++){
            if(j == i) continue;
            if(a[i] == c[j] && a[i] == a[j]){
                graf[i].push_back(i+n);
                rgraf[i+n].push_back(i);
            }
            if(a[i] == a[j]){
                graf[i].push_back(j+n);
                rgraf[j+n].push_back(i);
            }
            if(a[i] == c[j]){
                graf[i].push_back(j);
                rgraf[j].push_back(i);
            }
            if(c[i] == c[j] && c[i] == a[j]){
                graf[i+n].push_back(i);
                rgraf[i].push_back(i+n);
            }
            if(c[i] == a[j]){
                graf[i+n].push_back(j+n);
                rgraf[j+n].push_back(i+n);
            }
            if(c[i] == c[j]){
                graf[i+n].push_back(j);
                rgraf[j].push_back(i+n);
            }
        }
    }
    for(int i=1; i<=2*n; i++){
        for(auto c : graf[i]){
            cout << c << " ";
        }
        cout << endl;
    }
    bool moze = 1;
    for(int i=1; i<=n; i++){
        if(!visited[i] && !visited[i+n]){
            if(visited2[i] && visited2[i+n]){
                moze = 0;
                break;
            }
            if(!visited2[i]){
                visited2[i+n] = 1;
                dfs(i);
                while(!q.empty()){
                    int v = q.front();
                    q.pop();
                    nazad(v);
                }
            }
            else{
                visited2[i] = 1;
                dfs(i+n);
                while(!q.empty()){
                    int v = q.front();
                    q.pop();
                    nazad(v);
                }
            }
        }
    }
    for(int i=1; i<=n; i++){
        if(visited[i] && visited[i+n]) moze = 0;
    }
    if(moze == 1){
        cout << "Yes\n";
        for(int i=1; i<=n; i++){
            if(visited[i]) cout << "1\n";
            else cout << "2\n";
        }
    }
    return 0;
}
