#include <bits/stdc++.h>
#define MAXN 100005
using namespace std;

vector<pair<int,int>> schedule;
int n,in1,in2;
vector<pair<int,int>> perf[MAXN];
int p1[MAXN];
map<int,int> p2;
map<int,bool> visited;

bool tst()
{
    sort(schedule.begin(),schedule.end());
    int cnt=0;
    for(int i=0;i<schedule.size();i++)
    {
        cnt-=schedule[i].second;
        if(cnt>1)
        {
            return false;
        }
    }
    return true;
}

bool match(int cur)
{
    for(auto i:perf[cur])
    {
        if(visited[i.first])
        {
            continue;
        }
        visited[i.first]=1;
        if(p2[i.first]==0 || match(p2[i.first]))
        {
            p1[cur]=i.first;
            p2[i.first]=cur;
            visited[i.first]=true;
            return true;
        }
    }
    return false;
}

int main()
{
    ios::sync_with_stdio(false);
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>in1>>in2;
        perf[i].push_back({in1,in2});
        cin>>in1>>in2;
        perf[i].push_back({in1,in2});
    }
    if(n<=20)
    {
        bool pos=0;
        for(int i=0;i<(1<<n);i++)
        {
            schedule.clear();
            for(int j=0;j<n;j++)
            {
                schedule.push_back({perf[j+1][(i&(1<<j))>0].first,-1});
                schedule.push_back({perf[j+1][(i&(1<<j))>0].second,1});
            }
            if(tst())
            {
                pos=1;
                cout<<"Yes\n";
                for(int j=0;j<n;j++)
                {
                    cout<<((i&(1<<j))>0)+1<<"\n";
                }
                break;
            }
        }
        if(!pos)
        {
            cout<<"No";
        }
        return 0;
    }
    for(int i=1;i<=n;i++)
    {
        visited.clear();
        if(!match(i))
        {
            cout<<"No";
            return 0;
        }
    }
    cout<<"Yes\n";
    for(int i=1;i<=n;i++)
    {
        cout<<(p1[i]==perf[i][1].first)+1<<"\n";
    }
}
