#include <bits/stdc++.h>
#define MAXN 400005
using namespace std;

int n,m,in1,in2;
vector<pair<int,int>> boxes,rocks;
vector<int> rows,cols;

int idx(int a,vector<int>& x)
{
    return upper_bound(x.begin(),x.end(),a)-x.begin();
}

set<pair<int,bool>> objr[MAXN],objc[MAXN];
set<pair<int,int>> pending;
vector<pair<int,int>> cands[3][2];

vector<pair<int,pair<int,int>>> ans;

void sredi(vector<int>& x)
{
    sort(x.begin(),x.end());
    vector<int> temp={x[0]};
    for(int i=1;i<x.size();i++)
    {
        if(x[i]!=x[i-1])
        {
            temp.push_back(x[i]);
        }
    }
    x=temp;
}

int cnt(int x,int y,bool dir)
{
    int ix=idx(x,rows),iy=idx(y,cols);
    int ret=0;
    auto ptr=objr[ix].lower_bound({y,0});
    if(ptr!=objr[ix].end() && (ptr->second)==1 && dir)
    {
        ret++;
    }
    if(ptr!=objr[ix].begin() && ((--ptr)->second)==1 && dir)
    {
        ret++;
    }
    ptr=objc[iy].lower_bound({x,0});
    if(ptr!=objc[iy].end() && (ptr->second)==1 && !dir)
    {
        ret++;
    }
    if(ptr!=objc[iy].begin() && ((--ptr)->second)==1 && !dir)
    {
        ret++;
    }
    return ret;
}

void dest(int x,int y,bool dir)
{
    int ix=idx(x,rows),iy=idx(y,cols);
    auto ptr=objr[ix].lower_bound({y,0});
    if(ptr!=objr[ix].end() && (ptr->second)==1 && dir)
    {
        objr[ix].erase(ptr);
        objc[idx(ptr->first,cols)].erase({x,1});
        //cout<<"("<<x<<","<<(ptr->first)<<") ";
    }
    if(ptr!=objr[ix].begin() && ((--ptr)->second)==1 && dir)
    {
        objr[ix].erase(ptr);
        objc[idx(ptr->first,cols)].erase({x,1});
        //cout<<"("<<x<<","<<(ptr->first)<<") ";
    }
    ptr=objc[iy].lower_bound({x,0});
    if(ptr!=objc[iy].end() && (ptr->second)==1 && !dir)
    {
        objc[iy].erase(ptr);
        objr[idx(ptr->first,rows)].erase({y,1});
        //cout<<"("<<(ptr->first)<<","<<y<<") ";
    }
    if(ptr!=objc[iy].begin() && ((--ptr)->second)==1 && !dir)
    {
        objc[iy].erase(ptr);
        objr[idx(ptr->first,rows)].erase({y,1});
        //cout<<"("<<(ptr->first)<<","<<y<<") ";
    }
    //cout<<"\n";
}

int main()
{
    ios::sync_with_stdio(false);
    //freopen("input.in","r",stdin);
    cin>>n;
    for(int i=0;i<n;i++)
    {
        cin>>in1>>in2;
        boxes.push_back({in1,in2});
        rows.push_back(in1);
        cols.push_back(in2);
        rows.push_back(in1+1);
        cols.push_back(in2+1);
        rows.push_back(in1-1);
        cols.push_back(in2-1);
    }
    cin>>m;
    for(int i=0;i<m;i++)
    {
        cin>>in1>>in2;
        rocks.push_back({in1,in2});
        rows.push_back(in1);
        cols.push_back(in2);
        rows.push_back(in1+1);
        cols.push_back(in2+1);
        rows.push_back(in1-1);
        cols.push_back(in2-1);
    }
    sredi(rows);
    sredi(cols);
    for(int i=0;i<n;i++)
    {
        objr[idx(boxes[i].first,rows)].insert({boxes[i].second,1});
        objc[idx(boxes[i].second,cols)].insert({boxes[i].first,1});
    }
    for(int i=0;i<m;i++)
    {
        objr[idx(rocks[i].first,rows)].insert({rocks[i].second,0});
        objc[idx(rocks[i].second,cols)].insert({rocks[i].first,0});
    }
    for(int i=0;i<boxes.size();i++)
    {
        int tmp=cnt(boxes[i].first+1,boxes[i].second,0);
        if(tmp>0)
        {
            cands[tmp][0].push_back({boxes[i].first+1,boxes[i].second});
        }
        tmp=cnt(boxes[i].first,boxes[i].second+1,1);
        if(tmp>0)
        {
            cands[tmp][1].push_back({boxes[i].first,boxes[i].second+1});
        }
    }
    /*for(int i=2;i>0;i--)
    {
        for(int j=0;j<=1;j++)
        {
            for(int k=0;k<cands[i][j].size();k++)
            {
                cout<<"("<<cands[i][j][k].first<<","<<cands[i][j][k].second<<") ";
            }
            cout<<"\n";
        }
    }*/
    int ix=2,iy=1;
    while(ix!=0)
    {
        if(cands[ix][iy].empty())
        {
            if(iy==1)
            {
                iy=0;
            }
            else
            {
                ix--;
                iy=1;
            }
            continue;
        }
        pair<int,int> tmp=cands[ix][iy].back();
        int cc=cnt(tmp.first,tmp.second,iy);
        if(cc!=ix)
        {
            cands[ix][iy].pop_back();
            cands[cc][iy].push_back(tmp);
            continue;
        }
        ans.push_back({iy,{tmp.first,tmp.second}});
        dest(tmp.first,tmp.second,iy);
    }
    cout<<ans.size()<<"\n";
    for(int i=0;i<ans.size();i++)
    {
        cout<<ans[i].first<<" "<<ans[i].second.first<<" "<<ans[i].second.second<<"\n";
    }
}
