#include<bits/stdc++.h>
using namespace std;

typedef pair<int,int> pii;
typedef vector<pii> vpii;
typedef vector<int> vi;
#define pb push_back

class Concert
{
    public:
    int st;
    int en;
    int place;
    int type;
    Concert(int s,int e,int p,int t)
    {
        st = s;
        en = e;
        place = p;
        type = t;
    }
};


int n;
vector<Concert> conc;
vector<bool> used;
vi result;



void read()
{
    cin>>n;
    for(int i=0;i<n;i++)
    {
        int k,p,q,l;
        cin>>k>>p>>q>>l;
        conc.pb(Concert(k,p,i,1));
        conc.pb(Concert(q,l,i,2));
    }
}

bool f(Concert a,Concert b)
{
    if(a.st < b.st)return true;
    return false;
}

unordered_map<int,int> temp;

void solve()
{
    sort(conc.begin(),conc.end(),f);
    vector<bool> visited(n,false);
    vector<vector<int> > mem(conc.size(),vi(n,0));
    mem[0] = vi(n,conc[0].en);
    for(int i = 1;i<conc.size();i++)
    {
        for(int j = 0;j<n;j++)
        {
            if(conc[j].st>mem[i-1][j-1]||mem[i-1][j])
                mem[i][j] = min(min(mem[i-1][j-1],mem[i-1][j]),conc[j].en);
        }
    }
    bool check = true;
    for(int i=0;i<n;i++)
        if(mem[conc.size()-1][i]==0)check = false;
    if(!check)cout<<"No"<<endl;
    else
    {
        cout<<"Yes"<<endl;
        for(int i=0;i<n;i++)
            cout<<mem[conc.size()-1][i]<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    read();
    solve();
    return 0;
}
