#include <iostream>
#include <bits/stdc++.h>

using namespace std;

vector<set<int>> g, g2;
vector<int> topsort, comp;
vector<bool> used;

void dfs(int v){
    used[v] = true;
    for(int i : g[v]){
        //cout << i << " " << used[i] << endl;
        if(!used[i]){
            dfs(i);
        }
    }
    topsort.push_back(v);
}

void dfs2(int v, int col){
    comp[v] = col;
    for(int i : g2[v]){
        if(!comp[i]){
            dfs2(i, col);
        }
    }
}

int main()
{
    int n;
    cin >> n;
    vector<pair<pair<int, int>, int>> ar;
    vector<pair<int, int>> br;
    g.resize(n*2);
    g2.resize(n*2);
    for(int i = 0; i < n; i++){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        ar.push_back({{a, b}, i*2});
        br.push_back({b, i*2});
        ar.push_back({{c, d}, i*2 + 1});
        br.push_back({d, i*2 + 1});
    }
    sort(ar.begin(), ar.end());
    sort(br.begin(), br.end());
    int cnt = 0;
    for(int i = 0; i < 2*n; i++){
        while(cnt < 2*n && br[cnt].first < ar[i].first.first){
            cnt++;
        }
        int cur = cnt;
        while(cur < 2*n && br[cur].first <= ar[i].first.second){
            if(br[cur].second != ar[i].second){
                //cout << br[cur].first << " " << ar[i].first.second << endl;
                g[br[cur].second].insert(ar[i].second^1);
                //cout << br[cur].second << " " << (ar[i].second^1) << endl;
                g[ar[i].second].insert(br[cur].second^1);
            }
            cur++;
        }
    }
    for(int i = 0; i < 2*n; i++){
        for(int j : g[i]){
            //cout << j << " " << i << endl;
            g2[j].insert(i);
        }
    }
    used.resize(2*n);
    comp.resize(2*n);
    for(int i = 0; i < 2*n; i++){
        if(!used[i]){
            //cout << i << endl;
            dfs(i);
        }
    }
    int cm = 0;
    for(int i = 2*n - 1; i >= 0; i--){
        if(!comp[topsort[i]]){
                cm++;
            dfs2(topsort[i], cm);
        }
    }
    vector<int> ans(n);
    for(int i = 0; i < n; i++){
        if(comp[2*i] == comp[2*i + 1]){
            cout << "No";
            return 0;
        } else {
            if(comp[2*i] > comp[2*i + 1]){
                ans[i] = 1;
            } else {
                ans[i] = 2;
            }
        }
    }
    cout << "Yes" << endl;
    for(int i = 0; i < n; i++){
        cout << ans[i] << endl;
    }
    return 0;
}
