#include <iostream>
#include <bitset>
#include <algorithm>
#include <vector>
#include <cstdint>
#include <cstdlib>

using namespace std;


#define NMAX 2000000006ULL

typedef bitset<NMAX> bitnum_t;

bitnum_t& operator++ (bitnum_t& a)
{
    uint8_t tmp;

    size_t i=0;
    do
    {
        tmp = a[i];
        tmp+=1;
        a[i]=tmp&1;
        tmp>>=1;
        i++;
    }while(tmp);

    return a;
}

uint32_t n;
bitnum_t a;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n;
    if(n>=NMAX)
        exit(0);
    bool t=true;
    for(int32_t i=(int32_t)n-1; i>=0; i--)
    {
        a[i]=t;
        t=!t;
    }

    //cout<<a.to_string()<<endl;
}

void solve()
{
    //TODO: check smaller n
    for(uint32_t i=1; i<=n+n; i++)
    {
        ++a;
        if(a.count() == i)
        {
            cout<<i<<endl;
            return;
        }
    }

    cout<<0<<endl;
}

int main()
{
    init();
    solve();


    return 0;
}
