#include <iostream>
#include <vector>
#include <algorithm>
#include <cstdint>

using namespace std;

#ifdef EVAL
#define endl '\n'
#endif // EVAL

bool test_e (const vector<pair<uint32_t, bool>> &ends)
{
    uint32_t cur=0;
    for(uint32_t i=0; i<ends.size(); i++)
    {
        if(ends[i].second==0)
            cur++;
        else
            cur--;

        if(cur>1)
            return false;
    }

    return true;
}

struct artist_data
{
    uint32_t c1b, c1e;
    uint32_t c2b, c2e;
};

vector<artist_data> ad;

bool test_c (const vector<uint8_t> &used)
{
    vector<pair<uint32_t, bool>> ends;

    for(uint32_t i=0; i<ad.size(); i++)
    {
        if(used[i]==1)
        {
            ends.push_back(make_pair(ad[i].c1b, 0));
            ends.push_back(make_pair(ad[i].c1e, 1));
        }
        else if(used[i]==2)
        {
            ends.push_back(make_pair(ad[i].c2b, 0));
            ends.push_back(make_pair(ad[i].c2e, 1));
        }
    }

    sort(ends.begin(), ends.end());

    /*
    cout<<"ASDWQ:"<<endl;
    for(auto &x:ends)
        cout<<x.first<<' '<<x.second<<endl;
    cout<<"qwe"<<endl;
    */

    return test_e(ends);
}

vector<uint8_t> useda;

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    uint32_t n;
    cin>>n;

    ad.resize(n);
    useda.resize(n);

    for(uint32_t i=0; i<n; i++)
    {
        cin>>ad[i].c1b>>ad[i].c1e>>ad[i].c2b>>ad[i].c2e;
    }
}

bool is_ready_rec=false;

void rec(uint32_t pos=0)
{
    if(pos==ad.size())
    {
        if(test_c(useda))
            is_ready_rec=true;
        return;
    }

    useda[pos]=1;
    rec(pos+1);
    if(is_ready_rec)
        return;
    useda[pos]=2;
    rec(pos+1);
    if(is_ready_rec)
        return;

    useda[pos]=0;
}

int main()
{
    init();
    rec();

    if(is_ready_rec)
    {
        cout<<"Yes"<<endl;
        for(uint32_t i=0; i<useda.size(); i++)
            cout<<(short)useda[i]<<endl;
    }
    else
    {
        cout<<"No"<<endl;
    }


    return 0;
}

