#include<iostream>
#include<vector>
#include<algorithm>
#include<unordered_set>
#include<map>
using namespace std;
const int maxn = 25;
int n;

vector<int> e[2 * maxn];

pair<pair<int,int>, int>    dates[4 * maxn];

unordered_set<int> op;

int used;

unordered_set<long long> dp;

long long ans;
bool poss(long long state)
{
    bool go[2 * n] = {0};
    for(int i = 0; i < 2 * n; i ++) go[i] = true;
    int cnt = 0;
    for(int i = 0; i < 2 * n; i ++)
    {
        if(state & (1ll<<i))
        {
            cnt ++;
            go[i] = false;
            for(int j: e[i])    go[j] = false;
        }
    }
    if(cnt == n)
    {
        ans = state;
        return true;
    }
    for(int i = 0; i < 2 * n; i ++)
    {
        if(!go[i])  continue;
        if(poss(state | (1ll<<i)))    return true;
    }
    return false;
}

int main()
{
    cin >> n;
    for(int i = 0; i < n; i ++)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        dates[i * 4 + 0] = {{a,0},2 * i + 0};
        dates[i * 4 + 1] = {{b,1},2 * i + 0};
        dates[i * 4 + 2] = {{c,0},2 * i + 1};
        dates[i * 4 + 3] = {{d,1},2 * i + 1};
        e[2 * i + 0].push_back(2 * i + 1);
        e[2 * i + 1].push_back(2 * i + 0);
    }
    sort(dates, dates + 4 * n);

    for(int i = 0; i < 4 * n; i ++)
    {
        //cout << ">" << dates[i].first.first << " " << dates[i].first.second << " " << dates[i].second << endl;
        if(dates[i].first.second == 0)
        {
            for(int j: op)
            {
                e[j].push_back(dates[i].second);
                e[dates[i].second].push_back(j);
            }
            op.insert(dates[i].second);
        } else {
            op.erase(dates[i].second);
        }
    }
    if(!poss(0))
    {
        cout << "No";
        return 0;
    }
    cout << "Yes\n";
    for(int i = 0; i < n; i ++)
    {
        if(ans & (1ll<<(2 * i)))    cout << "1\n";
        else    cout << "2\n";
    }
    return 0;
}
/**
3
0 0 1 6
2 2 3 4
1 3 5 5
*/
