#include<iostream>
#include<vector>
#include<algorithm>
#include<unordered_set>
#include<map>
using namespace std;
const int maxn = 5000;
int n;

vector<int> e[2 * maxn];

pair<pair<int,bool>, int>    dates[4 * maxn];

unordered_set<int> op;


short found[maxn];
short test[maxn];

unordered_set<int>  changed;

bool fit(int i, int st)
{
    if(found[i] != 0 && found[i] != st) return false;
    if(found[i] == st)  return true;
    found[i] = st;
    changed.insert(i);
    int ind = 2 * i + st - 1;
    for(int i: e[ind])
    {
        int to_set = i ^ 1;
        if(!fit(to_set / 2, to_set % 2 + 1))
        {
            return false;
        }
    }
    return true;
}


int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    for(int i = 0; i < n; i ++)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        dates[i * 4 + 0] = {{a,0},2 * i + 0};
        dates[i * 4 + 1] = {{b,1},2 * i + 0};
        dates[i * 4 + 2] = {{c,0},2 * i + 1};
        dates[i * 4 + 3] = {{d,1},2 * i + 1};
    }
    sort(dates, dates + 4 * n);

    for(int i = 0; i < 4 * n; i ++)
    {
        if(dates[i].first.second == 0)
        {
            for(int j: op)
            {
                e[j].push_back(dates[i].second);
                e[dates[i].second].push_back(j);
            }
            op.insert(dates[i].second);
        } else {
            op.erase(dates[i].second);
        }
    }

    for(int i = 0; i < n; i ++)
    {
        if(found[i] == 0)
        {
            changed.clear();
            if(fit(i, 1))
            {
                continue;
            }
            for(auto i: changed)
            {
                found[i] = 0;
            }
            changed.clear();
            if(fit(i, 2))
            {
                continue;
            }
            cout << "No";
            return 0;
        }

    }
    cout << "Yes\n";
    for(int i = 0; i < n; i ++)
    {
        cout << found[i] << "\n";
    }
    return 0;
}
/**
3
0 0 1 6
2 2 3 4
1 3 5 5
*/
