#include<bits/stdc++.h>
using namespace std;

const int nmax=2e5+42;

int n;

struct concert
{
    int l,r,id;
};

concert inp[nmax];

int other(int i)
{
    if(i%2==1)return i+1;
    return i-1;
}

vector<int> adj[nmax],trav[nmax];

void add(int l,int r)
{
    adj[l].push_back(r);
    trav[r].push_back(l);

    adj[other(r)].push_back(other(l));
    trav[other(l)].push_back(other(r));
}

bool been[nmax];

vector<int> order;

void dfs(int node)
{
    if(been[node])return;
    been[node]=1;

    for(auto k:adj[node])
        dfs(k);

    order.push_back(node);
}

int component[nmax];
int c;

void go(int node)
{
    if(been[node])return;
    been[node]=1;

    component[node]=c;

    for(auto k:trav[node])
        go(k);

}

vector<int> adj_new[nmax],trav_new[nmax];

queue<int> active;

int deg[nmax];

int actual_component_order[nmax];

int main()
{
    scanf("%i",&n);

    for(int i=1;i<=2*n;i++)
    {
        scanf("%i%i",&inp[i].l,&inp[i].r);
        inp[i].id=i;
    }

    for(int i=1;i<=2*n;i++)
        for(int j=i+1;j<=2*n;j++)
            if(max(inp[i].l,inp[j].l)<=min(inp[i].r,inp[j].r))
            {
                add(inp[i].id,other(inp[j].id));
            }
    /*
    for(int i=1;i<=2*n;i++)
        for(auto k:adj[i])
            cout<<i<<" -> "<<k<<endl;
    */

    for(int i=1;i<=n;i++)
    {
        dfs(i);
    }

    //for(auto k:order)cout<<k<<" ";cout<<endl;

    reverse(order.begin(),order.end());

    for(int i=1;i<=2*n;i++)been[i]=0;

    for(auto k:order)
    {
        if(component[k]==0)
        {
            c++;
            go(k);
        }
    }

    //for(int i=1;i<=2*n;i++)cout<<component[i]<<" ";cout<<endl;

    for(int i=1;i<=2*n;i=i+2)
        if(component[i]==component[i+1])
        {
            cout<<"No"<<endl;
            return 0;
        }

    for(int i=1;i<=2*n;i++)
        for(auto k:adj[i])
            if(component[i]!=component[k])
            {
                //cout<<"edge between comps "<<component[i]<<" and "<<component[k]<<endl;

                adj_new[component[i]].push_back(component[k]);
                trav_new[component[k]].push_back(component[i]);
            }

    for(int i=1;i<=c;i++)
    {
        deg[i]=adj_new[i].size();

        //cout<<i<<" -> "<<deg[i]<<endl;

        if(deg[i]==0)active.push(i);
    }

    for(int i=1;i<=c;i++)
    {
        if(active.size()==0)
        {
            cout<<"No"<<endl;
            return 0;
        }
        int t=active.front();

        //cout<<"t= "<<t<<endl;

        active.pop();

        for(auto k:trav_new[t])
        {
            deg[k]--;
            if(deg[k]==0)active.push(k);
        }

        actual_component_order[t]=i;
    }

    cout<<"Yes"<<endl;
    for(int i=1;i<=2*n;i=i+2)
    {
        //cout<<actual_component_order[component[i]]<<" "<<actual_component_order[component[i+1]]<<endl;
        if(actual_component_order[component[i]]<actual_component_order[component[i+1]])printf("1\n");
        else printf("2\n");
    }
    return 0;
}
