#include<bits/stdc++.h>
using namespace std;

const int nmax=2e5+42,MX=4e6+42;

int n;

struct concert
{
    int l,r,id;
};

concert inp[nmax];

int other(int i)
{
    if(i%2==1)return i+1;
    return i-1;
}

vector<int> adj[MX],trav[MX];
/*
void add(int l,int r)
{
    adj[l].push_back(r);
    trav[r].push_back(l);

    adj[other(r)].push_back(other(l));
    trav[other(l)].push_back(other(r));
}
*/
bool been[MX];

vector<int> order;

void dfs(int node)
{
    if(been[node])return;
    been[node]=1;

    for(auto k:adj[node])
        dfs(k);

    order.push_back(node);
}

int component[nmax];
int c;

void go(int node)
{
    if(been[node])return;
    been[node]=1;

    component[node]=c;

    for(auto k:trav[node])
        go(k);

}

vector<int> adj_new[nmax],trav_new[nmax];

queue<int> active;

int deg[nmax];

int actual_component_order[nmax];

bool cmp(concert a,concert b)
{
    if(a.l!=b.l)return a.l<b.l;
    return a.r<b.r;
}

bool cmp_by_right(concert a,concert b)
{
    return a.r<b.r;
}

vector<concert> tree[4*nmax];

int where_it_began[4*nmax],where_it_began_back[4*nmax];
int current=0;

void build_merge_sort_tree(int node,int l,int r)
{
    if(l==r)
    {
        //cout<<node<<" "<<l<<" "<<r<<" "<<current<<endl;

        current++;
        where_it_began[node]=current;
        adj[current].push_back(other(inp[l].id));
        tree[node].push_back(inp[l]);

        current++;
        where_it_began_back[node]=current;
        adj[inp[l].id].push_back(current);

        return;
    }

    int av=(l+r)/2;

    build_merge_sort_tree(node*2,l,av);
    build_merge_sort_tree(node*2+1,av+1,r);

    tree[node]=tree[node*2];
    for(auto k:tree[node*2+1])tree[node].push_back(k);

    sort(tree[node].begin(),tree[node].end(),cmp_by_right);

    current++;
    where_it_began[node]=current;

    adj[current].push_back(other(tree[node][0].id));

    for(int i=1;i<tree[node].size();i++)
    {
        current++;
        adj[current].push_back(other(tree[node][i].id));
        adj[current].push_back(current-1);
    }


    current++;

    where_it_began_back[node]=current;

    adj[tree[node][0].id].push_back(current);

    for(int i=1;i<tree[node].size();i++)
    {
        current++;
        adj[tree[node][i].id].push_back(current);
        adj[current-1].push_back(current);
    }
    /*
    cout<<node<<" -> "<<endl;
    for(auto k:tree[node])
    {
        cout<<k.l<<" "<<k.r<<" "<<k.id<<endl;
    }

    cout<<"current= "<<current<<endl;
    cout<<"---"<<endl;
    */
}

int VERTEX_NOW;

void query(int node,int l,int r,int lq,int rq,int at_least)
{
    if(l==lq&&r==rq)
    {
        int ok=tree[node].size()-1;

        if(tree[node][ok].r<at_least)return;

        int not_ok=-1;

        while(ok-not_ok>1)
        {
            int av=(ok+not_ok)/2;
            if(tree[node][av].r<at_least)not_ok=av;
            else ok=av;
        }
        /*
        cout<<"query! "<<VERTEX_NOW<<" "<<node<<" "<<ok<<endl;

        cout<<"added: "<<VERTEX_NOW<<" "<<where_it_began[node]+ok<<endl;
        cout<<"added: "<<where_it_began_back[node]+ok<<" "<<other(VERTEX_NOW)<<endl;
        */
        adj[VERTEX_NOW].push_back(where_it_began[node]+ok);

        adj[where_it_began_back[node]+ok].push_back(other(VERTEX_NOW));

        return;
    }

    int av=(l+r)/2;
    if(lq<=av)query(node*2,l,av,lq,min(av,rq),at_least);
    if(av<rq)query(node*2+1,av+1,r,max(av+1,lq),rq,at_least);
}
int main()
{
    scanf("%i",&n);

    for(int i=1;i<=2*n;i++)
    {
        scanf("%i%i",&inp[i].l,&inp[i].r);
        inp[i].id=i;
    }

    current=2*n;
    sort(inp+1,inp+2*n+1,cmp);

    //for(int i=1;i<=2*n;i++)cout<<inp[i].l<<" "<<inp[i].r<<" "<<inp[i].id<<endl;

    build_merge_sort_tree(1,1,2*n);

    for(int i=2;i<=2*n;i++)
    {
        VERTEX_NOW=inp[i].id;
        query(1,1,2*n,1,i-1,inp[i].l);
    }


    vector< pair<int,int> > bck={};
    for(int i=1;i<=current;i++)
        for(auto k:adj[i])
        bck.push_back({i,k});

    for(auto k:bck)
        trav[k.second].push_back(k.first);
    /*
    for(int i=1;i<=current;i++)
        for(auto k:adj[i])
            cout<<i<<" -> "<<k<<endl;

    cout<<"trav: "<<endl;
    for(int i=1;i<=current;i++)
        for(auto k:trav[i])
            cout<<i<<" -> "<<k<<endl;
    */
    for(int i=1;i<=2*n;i++)
    {
        memset(been,0,sizeof(been));
        dfs(i);
        /*
        for(int j=1;j<=2*n;j++)
            if(been[j])cout<<"edge "<<i<<" "<<j<<endl;
        */
    }
    for(int i=1;i<=current;i++)
    {
        dfs(i);
    }

    //for(auto k:order)cout<<k<<" ";cout<<endl;

    reverse(order.begin(),order.end());

    for(int i=1;i<=current;i++)been[i]=0;

    for(auto k:order)
    {
        //cout<<k<<" -> "<<component[k]<<endl;
        if(component[k]==0)
        {
            c++;
            go(k);
        }
    }

    //for(int i=1;i<=2*n;i++)cout<<component[i]<<" ";cout<<endl;

    for(int i=1;i<=2*n;i=i+2)
        if(component[i]==component[i+1])
        {
            cout<<"No"<<endl;
            return 0;
        }

    for(int i=1;i<=current;i++)
        for(auto k:adj[i])
            if(component[i]!=component[k])
            {
                //cout<<"edge between comps "<<component[i]<<" and "<<component[k]<<endl;

                adj_new[component[i]].push_back(component[k]);
                trav_new[component[k]].push_back(component[i]);
            }

    for(int i=1;i<=c;i++)
    {
        deg[i]=adj_new[i].size();

        //cout<<i<<" -> "<<deg[i]<<endl;

        if(deg[i]==0)active.push(i);
    }

    for(int i=1;i<=c;i++)
    {
        if(active.size()==0)
        {
            cout<<"No"<<endl;
            return 0;
        }
        int t=active.front();

        //cout<<"t= "<<t<<endl;

        active.pop();

        for(auto k:trav_new[t])
        {
            deg[k]--;
            if(deg[k]==0)active.push(k);
        }

        actual_component_order[t]=i;
    }

    cout<<"Yes"<<endl;
    for(int i=1;i<=2*n;i=i+2)
    {
        cout<<actual_component_order[component[i]]<<" "<<actual_component_order[component[i+1]]<<endl;
        if(actual_component_order[component[i]]<actual_component_order[component[i+1]])printf("1\n");
        else printf("2\n");
    }
    return 0;
}
/*
2
0 0 4 8
0 5 6 7
*/
