#include<bits/stdc++.h>
using namespace std;

const int nmax=4e5+42;

int n,m;

struct info
{
    int x,y,type;
    //type=0-> box
    //type=1-> stone
    //type=-1 -> destroyed box
};

info inp[nmax];

struct out
{
    int type;
    int x,y;
};

vector<out> output;

void add(int x,int y,int type)
{
    out now;
    now.x=x;
    now.y=y;
    now.type=type;
    output.push_back(now);
}
bool cmp_x(info a,info b)
{
    if(a.x!=b.x)return a.x<b.x;
    return a.y<b.y;
}

bool cmp_y(info a,info b)
{
    if(a.y!=b.y)return a.y<b.y;
    return a.x<b.x;
}

bool proper(int i)
{
    return inp[i].type==0;
}
int main()
{
    cin>>n;
    for(int i=1;i<=n;i++)
    {
        cin>>inp[i].x>>inp[i].y;
        inp[i].type=0;
    }

    cin>>m;
    for(int i=1;i<=m;i++)
    {
        cin>>inp[i+n].x>>inp[i+n].y;
        inp[i+n].type=1;
    }

    //clear x
    sort(inp+1,inp+n+m+1,cmp_x);

    for(int i=2;i<=n+m;i++)
    {
        if(proper(i-1)&&proper(i)&&inp[i-1].x==inp[i].x)
        {
            add(inp[i].x,inp[i].y-1,1);
            inp[i-1].type=-1;
            inp[i].type=-1;
        }
    }
    //clear y
    sort(inp+1,inp+n+m+1,cmp_y);

    for(int i=2;i<=n+m;i++)
    {
        if(proper(i-1)&&proper(i)&&inp[i-1].y==inp[i].y)
        {
            add(inp[i].x-1,inp[i].y,0);
            inp[i-1].type=-1;
            inp[i].type=-1;
        }
    }

    //clear all left
    for(int i=1;i<=n+m;i++)
        if(proper(i))
        {
            add(inp[i].x,inp[i].y-1,1);
            inp[i].type=-1;
        }

    printf("%i\n",output.size());

    for(auto k:output)printf("%i %i %i\n",k.type,k.x,k.y);
    return 0;
}
