#include <bits/stdc++.h>

using namespace std;

const int maxn = 100003;

int n;
pair <int, int> a[maxn][3];
void read()
{
    cin >> n;

    for (int i = 1; i <= n; i++)
        cin >> a[i][1].first >> a[i][1].second >> a[i][2].first >> a[i][2].second;
}

bool intersect(pair <int, int> a, pair <int, int> b)
{
    if (a.first > b.first)
        swap(a, b);

    return a.second >= b.first;
}

bool taken[maxn];
bool banned[maxn][2];
int ans[maxn];

void bann(int idx)
{
    for (int i = 1; i <= n; i++)
        if (!taken[i])
            for (int j = 1; j <= 2; j++)
                if (intersect(a[idx][ans[idx]], a[i][j]))
                    banned[i][j] = true;
}

bool is_banned(int idx, int which)
{
    for (int i = 1; i <= n; i++)
        if (!taken[i] && i != idx)
        {
            int cnt = 0;
            for (int j = 1; j <= 2; j++)
            {
                if (banned[i][j])
                    continue;

                if (!intersect(a[idx][which], a[i][j]))
                    cnt++;
            }

            if (!cnt)
                return true;
        }

    return false;
}

bool is_bad()
{
    for (int i = 1; i <= n; i++)
        if (!taken[i] && banned[i][1] && banned[i][2])
            return true;

    return false;
}

void update()
{
    for (int i = 1; i <= n; i++)
        if (!taken[i])
            for (int j = 1; j <= 2; j++)
                if (!banned[i][j])
                    banned[i][j] = is_banned(i, j);
}

pair <int, int> choose()
{
    for (int i = 1; i <= n; i++)
        if (!taken[i])
        {
            int cnt = 0;
            if (!banned[i][1])
                cnt++;

            if (!banned[i][2])
                cnt++;

            if (cnt == 1)
            {
                int w;
                if (!banned[i][1])
                    w = 1;

                else
                    w = 2;

                return {i, w};
            }
        }

        /*
    for (int i = 1; i <= n; i++)
        if (!taken[i])
            return {i, 1};
            */
}

bool is_done()
{
    int cnt = 0;
    for (int i = 1; i <= n; i++)
        if (taken[i])
            cnt++;


    return (cnt == n);
}

void solve()
{
    while (!is_done())
    {
        update();

        if (is_bad())
        {
            cout << "No" << endl;
            return;
        }

        auto curr = choose();

        taken[curr.first] = true;
        ans[curr.first] = curr.second;

        bann(curr.first);
    }

    cout << "Yes" << endl;

    for (int i = 1; i <= n; i++)
        cout << ans[i] << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}

/*
3
0 0 1 6
2 2 3 4
1 3 5 5
*/

/*
3
0 0 1 6
2 2 3 4
0 0 1 3
*/

/*
4
2 2 3 3
0 0 4 4
0 0 1 1
1 1 2 2
*/

/*
10
21 22 33 35
16 18 26 27
9 10 14 23
0 1 15 34
12 17 19 32
4 28 30 38
5 6 13 31
2 3 20 37
24 25 29 36
7 8 11 39
*/
