#include <bits/stdc++.h>

using namespace std;

const int maxn = 4003;

int n;
pair <int, int> a[maxn][2];
bool is[maxn * 2][maxn];
bool used[maxn];
int match[maxn];
map <int, vector <int> > mp;

bool dfs(int ver)
{
    for (int i = 1; i <= n; i++)
        if (is[ver][i] && !used[i])
    {
        used[i] = true;

        if (match[i] == -1 || dfs(match[i]))
        {
            match[i] = ver;

            return true;
        }
    }

    return false;
}

void read()
{
    cin >> n;

    for (int i = 1; i <= n; i++)
        cin >> a[i][0].first >> a[i][0].second >> a[i][1].first >> a[i][1].second;
}

map <int, int> key;
void solve()
{

   for (int i = 1; i <= n; i++)
   {
       mp[a[i][0].first].push_back(i);
       mp[a[i][1].first].push_back(i);
   }

   int idx = 0;
   for (auto i: mp)
   {
       idx++;
       key[idx] = i.first;

       for (auto j: i.second)
       is[idx][j] = true;
   }

   memset(match, -1, sizeof(match));

   int cnt = 0;
   for (int i = 1; i <= idx; i++)
   {
       memset(used, 0, sizeof(used));
       if (dfs(i))
        cnt++;
   }

   if (cnt < n)
    cout << "No" << endl;

   else
    {
        cout << "Yes" << endl;

        for (int i = 1; i <= n; i++)
        {
            int curr = key[match[i]];
            if (a[i][0].first == curr)
                cout << 1 << endl;

            else
                cout << 2 << endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}

/*
3
0 0 1 6
2 2 3 4
1 3 5 5
*/

/*
3
0 0 1 6
2 2 3 4
0 0 1 3
*/

/*
4
2 2 3 3
0 0 4 4
0 0 1 1
1 1 2 2
*/

/*
10
21 22 33 35
16 18 26 27
9 10 14 23
0 1 15 34
12 17 19 32
4 28 30 38
5 6 13 31
2 3 20 37
24 25 29 36
7 8 11 39
*/
