#include <bits/stdc++.h>

void subtract(std::string &s, const std::string &t) {
	int32_t aux = 0;
	int32_t indS = s.size() - 1, indT = t.size() - 1;
	std::string res;

	while(indT >= 0) {
		int32_t curr = (s[indS] - '0') - aux - (t[indT] - '0');
		if(curr < 0) {
			curr += 2;
			aux = 1;
		}
		else {
			aux = 0;
		}

		res += (char) (curr + '0');
		indT--;
		indS--;
	}
	while(indS >= 0) {
		int32_t curr = (s[indS] - '0') - aux;
		if(curr < 0) {
			curr += 2;
			aux = 1;
		}
		else {
			aux = 0;
		}

		res += (char) (curr + '0');
		indS--;
	}

	for(int32_t i = res.size() - 1; i >= 0; i--) {
		if(res[i] != '0') {
			res = res.substr(0, i + 1);
			break;
		}
	}
	std::reverse(res.begin(), res.end());
	s = res;
}

int32_t compute_ans(std::string &s, const std::string &lastT) {
	std::string t;
	t.resize(s.size() - 1, '1');
	
	std::string p = t + '1';
	if(p == s && lastT != p) {
		return 1;
	}
	
	if(t.size() == 0 || t == lastT) {
		return -1;
	}

	subtract(s, t); 

	int32_t aux = compute_ans(s, t);
	if(aux == -1) {
		return -1;
	}

	return aux + 1;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);
	
	int32_t n;
    std::cin >> n;
	
	std::string s;
	int32_t nxt = 1;
	for(int32_t i = 0; i < n; i++) {
		s += (char) (nxt + '0');
		nxt ^= 1;
	}
	
	int32_t ans = compute_ans(s, "");
	if(ans == -1) {
		ans = 0;
	}

	std::cout << ans << '\n';
}
