#include<iostream>

using namespace std;

const int MAXN = 100000;
const int cons = 2;

int n;
struct entertainer
{
    int beg[2], en[2];
};
entertainer en[MAXN+10];

bool cc[MAXN+10];
bool pos = 0;

void input()
{
    cin>>n;
    for (int i=0; i<n; i++)
    {
        for (int z=0; z<cons; z++)
        {
            cin>>en[i].beg[z]>>en[i].en[z];
        }
    }
}

void output()
{
    if (pos)
    {
        cout<<"Yes\n";
        for (int i=0; i<n; i++)
        {
            cout<<cc[i]+1<<'\n';
        }
    }
    else
    {
        cout<<"No\n";
    }
}

bool bavna_rekursijka(int curr)
{
    if (curr == n) return 1;

    bool ch[2] = {1, 1};

    for (int i=0; i<curr; i++)
    {
        for (int z=0; z<cons; z++)
            if ((en[curr].beg[z]<=en[i].en[cc[i]] && en[curr].beg[z]>=en[i].beg[cc[i]]) ||
                (en[i].beg[cc[i]]<=en[curr].en[z] && en[i].beg[cc[i]]>=en[curr].beg[z]))
                {
                    ch[z] = 0;
                    if (!ch[!z]) return 0;
                }
    }

    for (int z=0; z<cons; z++)
    {
        if (ch[z])
        {
            cc[curr] = z;
            if (bavna_rekursijka(curr+1)) return 1;
        }
    }

    return 0;
}

void solve()
{
    pos = bavna_rekursijka(0);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    input();
    solve();
    output();
    return 0;
}

/*
3
0 0 1 6
2 2 3 4
1 3 5 5
*/
