#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e5 * 4 + 5;

struct point
{
    int x, y, num, type;

    point()
    {
        num = -1;
    }
    point(int _x, int _type, int _num)
    {
        x = _x;
        num = _num;
        type = _type;
    }

    bool operator<(point other) const
    {
        return x < other.x;
    }
};

int n, m;
map <int, vector<point>> I;
map <int, vector<point>> J;
bool vis[MAXN];
int xr, vr;

int _abs(int f)
{
    if(f < 0) return -f;
    return f;
}
bool cycle = false;

struct ans_b
{
    int x, y, type;

    ans_b(int _x, int _y, int _type)
    {
        x = _x; y = _y; type = _type;
    }
};

vector <ans_b> bombs[2];
set <int> str;
set <int> visit;
map <int, pair<int, int>> rsp;

void dfs(int i, int j, int num, int prev)
{
    //printf("~~%d %d %d\n", i, j, num);
    rsp[num] = {i, j};
    visit.insert(num);
    vis[num] = true;
    int k = 0;
    int ind = 0;
    point otherP;
    int ind2 = -1;
    for(auto z : J[i])
    {
        //printf("^^^^ %d %d\n", i, z.x);
        if(z.type == 0)
        {
            if(z.x == j)
            {
                ind = k;
            }
            else
            {
                otherP = z;
                ind2 = k;
            }
        }
        k++;
        /*if(!vis[z.num] && z.type == 0)
        {
            xr++;
            dfs(z.x, y, z.num);
        }*/
    }
    //printf("%d\n", ind2);
    if(ind2 != -1 && _abs(ind2 - ind) == 1)
    {
        //printf("DSA");
        if(!vis[otherP.num])
        {
            if(ind2 > ind) bombs[0].push_back(ans_b(i, j + 1, 1));
            else bombs[0].push_back(ans_b(i, j - 1, 1));
            dfs(i, otherP.x, otherP.num, num);
            xr++;
            str.insert(otherP.num);
            str.insert(num);
        }
        else if(otherP.num != prev && !cycle)
        {
            //printf("%d %d\n", i, j);
            if(ind2 > ind) bombs[0].push_back(ans_b(i, j + 1, 1));
            else bombs[0].push_back(ans_b(i, j - 1, 1));
            cycle = true;
            xr++;
        }
    }
    ind = 0; ind2 = -1;
    k = 0;
    for(auto z : I[j])
    {
        //printf("^^^^ %d %d\n", z.x, );
        if(z.type == 0)
        {
            if(z.x == i)
            {
                ind = k;
            }
            else
            {
                otherP = z;
                ind2 = k;
            }
        }
        k++;
    }
    if(ind2 != -1 && _abs(ind2 - ind) == 1)
    {
        //printf("DSA");
        if(!vis[otherP.num])
        {
            //printf("~~%d %d\n", i + 1, j);
            if(ind2 > ind) bombs[1].push_back(ans_b(i + 1, j, 0));
            else bombs[1].push_back(ans_b(i - 1, j, 0));
            dfs(otherP.x, j, otherP.num, num);
            vr++;
        }
        else if(otherP.num != prev && !cycle)
        {
            if(ind2 > ind) bombs[1].push_back(ans_b(i + 1, j, 0));
            else bombs[1].push_back(ans_b(i - 1, j, 0));
            cycle = true;
            vr++;
        }
    }

}

int main()
{
    scanf("%d", &n);

    int x, y;
    for(int i = 0; i < n; i++)
    {
        scanf("%d %d", &x, &y);
        //v.push_back(point(x, y, i));
        I[y].push_back(point(x, 0, i));
        J[x].push_back(point(y, 0, i));
    }
    scanf("%d", &m);
    for(int i = 0; i < m; i++)
    {
        scanf("%d %d", &x, &y);
        I[y].push_back(point(x, 1, i));
        J[x].push_back(point(y, 1, i));
    }

    //sort(J[1].begin(), J[1].end());
    for(auto x : I)
    {
        sort(I[x.first].begin(), I[x.first].end());
    }
    for(auto x : J)
    {
        sort(J[x.first].begin(), J[x.first].end());
    }

    vector <ans_b> bmb;
    int answer = 0;
    for(auto x : I)
    {
        for(auto z : x.second)
        {
            if(!vis[z.num] && z.type == 0)
            {
                bombs[0].clear();
                bombs[1].clear();
                rsp.clear();
                visit.clear();
                str.clear();
                xr = 0; vr = 0;
                cycle = false;
                dfs(z.x, x.first, z.num, z.num);

                //printf("%d %d\n", xr, vr);
                answer += max(xr, vr);
                if(xr == vr && !cycle)
                {
                    answer++;
                }

                if(xr == 0 && vr == 0)
                {
                    bmb.push_back(ans_b(x.first + 1, z.num, 0));
                }
                else
                {
                    if(xr > vr)
                    {
                        for(auto po : bombs[0])
                        {
                            bmb.push_back(po);
                        }
                    }
                    else if(xr < vr)
                    {
                        for(auto po : bombs[1])
                        {
                            bmb.push_back(po);
                        }
                    }
                    else
                    {
                        for(auto po : bombs[1])
                        {
                            bmb.push_back(po);
                        }
                        for(auto tr : visit)
                        {
                            if(!str.count(tr))
                            {
                                bmb.push_back(ans_b(rsp[tr].first + 1, rsp[tr].second, 0));
                                break;
                            }
                        }
                    }
                }
                //printf("%d\n", cycle);
                //printf("DSA\n");
            }
        }
    }

    printf("%d\n", answer);
    for(auto x : bmb)
    {
        printf("%d %d %d\n", x.type, x.x, x.y);
    }

    return 0;
}

/*
4
1 1
1 4
4 1
4 4
0
*/

/*
4
1 1
1 4
4 1
4 8
0
*/
