#include<iostream>
#include<vector>
#pragma optimize "gcc -Ofast"
using namespace std;
struct component
{
    int i;
    vector<int>vurhove,susedi;
};
struct singer{
    int i,a,b,c,d;
};
struct pair2SAT{
    bool isa,isb;
    int a,b;
};
vector<int>susedi[1000000],revsusedi[1000000];
vector<int>dfsorder,comporder;
vector<singer>singers;
vector<component>comps;
vector<pair2SAT>input;
int vcomp[1000000];
bool visited[1000000];
void dfs(int v)
{
    if(visited[v])
    {
        return;
    }
    visited[v]=1;
    for(int i=0; i<susedi[v].size(); i++)
    {
        dfs(susedi[v][i]);
    }
    dfsorder.push_back(v);
}
void revdfs(int v,int c)
{
    if(visited[v])
    {
        return;
    }
    visited[v]=1;
    vcomp[v]=c;
    comps[c].vurhove.push_back(v);
    //cout<<""
    for(int i=0; i<revsusedi[v].size(); i++)
    {
        if(visited[revsusedi[v][i]] && vcomp[revsusedi[v][i]]!=c){
            comps[vcomp[revsusedi[v][i]]].susedi.push_back(c);
        }else{
            revdfs(revsusedi[v][i],c);
        }
    }
}
void compdfs(int v){
    if(visited[v]){
        return;
    }
    visited[v]=1;
    for(int i=0;i<comps[v].susedi.size();i++){
        compdfs(comps[v].susedi[i]);
    }
    comporder.push_back(v);
}
bool intersect(int a,int b,int c,int d){
    if(min(b,d)<max(a,c))return 0;
    return 1;
}
int state[10005];
int main()
{
    std::cin.tie(nullptr);
    std::ios::sync_with_stdio(false);
    int n,m;
    cin>>m;
    n=m*2;
    for(int i=0;i<m;i++){
        singer a;
        a.i=i;
        cin>>a.a>>a.b>>a.c>>a.d;
        singers.push_back(a);
    }
    for(int i=0;i<m;i++){
        input.push_back({1,1,i*2,i*2+1});
    }
    for(int i=0;i<m;i++){
        for(int j=i+1;j<m;j++){
            if(intersect(singers[i].a,singers[i].b,singers[j].a,singers[j].b)){
                input.push_back({0,0,singers[i].i*2,singers[j].i*2});
            }
            if(intersect(singers[i].a,singers[i].b,singers[j].c,singers[j].d)){
                input.push_back({0,0,singers[i].i*2,singers[j].i*2+1});
            }
            if(intersect(singers[i].c,singers[i].d,singers[j].a,singers[j].b)){
                input.push_back({0,0,singers[i].i*2+1,singers[j].i*2});
            }
            if(intersect(singers[i].c,singers[i].d,singers[j].c,singers[j].d)){
                input.push_back({0,0,singers[i].i*2+1,singers[j].i*2|1});
            }
        }
    }
    for(int i=0; i<input.size(); i++)
    {
        int a,b;
        bool isa,isb;
        //cin>>isa>>a>>isb>>b;
        isa=input[i].isa;
        isb=input[i].isb;
        a=input[i].a;
        b=input[i].b;
        //cout<<isa<<" "<<a<<" "<<isb<<" "<<b<<endl;
        susedi[a*2+isa].push_back(b*2+!isb);
        susedi[b*2+isb].push_back(a*2+!isa);
        revsusedi[a*2+!isa].push_back(b*2+isb);
        revsusedi[b*2+!isb].push_back(a*2+isa);
    }
    for(int i=0; i<n*2; i++)
    {
        dfs(i);
    }
    for(int i=0;i<n*2;i++){
        visited[i]=0;
    }
    for(int k=dfsorder.size()-1; k>=0; k--)
    {
        int i=dfsorder[k];
        if(!visited[i]){
            component ccomp;
            ccomp.i=comps.size();
            comps.push_back(ccomp);
            //cout<<"a"<<endl;
            revdfs(i,ccomp.i);
        }
    }
    for(int i=0;i<n*2;i++){
        visited[i]=0;
    }
    for(int i=0;i<comps.size();i++){
        compdfs(i);
    }
    for(int i=0;i<comporder.size();i++){
        for(int j=0;j<comps[i].vurhove.size();j++){
            int v=comps[i].vurhove[j];
            int rv=v/2;
            int vstate=v%2+1;
            if(state[rv]==0){
                state[rv]=vstate;
            }else if(vcomp[rv*2]==vcomp[rv*2+1]){
                cout<<"No"<<endl;
                return 0;
            }
        }
    }
    cout<<"Yes"<<endl;
    for(int i=0;i<m;i++){
        cout<<state[i*2+1]<<"\n";
    }
    std::cout.flush();
    return 0;
}
//cherven karton za mario metushev i ...
