#include <bits/stdc++.h>
#define MAXN 100003
#define endl '\n'
using namespace std;

struct st
{
    int a, b, c, d;
    st () {}
    st (int _a, int _b, int _c, int _d)
    {
        a = _a;
        b = _b;
        c = _c;
        d = _d;
    }
};

int n;
st arr[MAXN];
vector <bool> ans;
bool done = 0;

bool check2(int a, int b, int c, int d)
{
    return (max(a, c) > min(b, d));
}

bool check(int a, int b, vector <bool> idx, int sz)
{
    //int sz = idx.size();
    for (int i = 0; i < sz; ++i)
    {
        int c, d;
        if (!idx[i])
        {
            c = arr[i].a;
            d = arr[i].b;
        }
        else
        {
            c = arr[i].c;
            d = arr[i].d;
        }
        if (!check2(a, b, c, d))
            return 0;
    }
    return 1;
}

void dfs(int tmp, vector <bool> idx)
{
    if (tmp == n)
    {
        done = 1;
        ans = idx;
        return;
    }
    if (done)
        return;
    //cout << tmp << "> " << endl;
    int l = arr[tmp].a;
    int r = arr[tmp].b;
    if (check(l, r, idx, tmp))
    {
        //cout << "   1*" << endl;
        idx[tmp] = 0;
        dfs(tmp + 1, idx);
    }
    l = arr[tmp].c;
    r = arr[tmp].d;
    if (check(l, r, idx, tmp))
    {
        //cout << "   2*" << endl;
        idx[tmp] = 1;
        dfs(tmp + 1, idx);
    }
    //cout << "<" << tmp << endl;
}

void input()
{
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        arr[i] = st(a, b, c, d);
    }
}

void solve()
{
    vector <bool> b(n, 0);
    dfs(0, b);
    if (!done)
    {
        cout << "No" << endl;
        return;
    }
    cout << "Yes" << endl;
    for (int i = 0; i < n; ++i)
        cout << (ans[i] ? 2 : 1) << endl;
}

/**
3
0 0 1 6
2 2 3 4
1 3 5 5


3
0 0 1 6
2 2 3 4
0 0 1 3


4
2 2 3 3
0 0 4 4
0 0 1 1
1 1 2 2


*/

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
