#include <bits/stdc++.h>
//#define endl '\n'
#define MAXN 400004
using namespace std;
int n, m;
int nb[MAXN];

struct point
{
    bool t;
    int x, y, idx;
    point () {}
    point (int _x, int _y, bool _t = 0, int _idx = 0)
    {
        x = _x;
        y = _y;
        t = _t;
        idx = _idx;
    }
};

bool cmp_x(point q, point p)
{
    if (q.x < p.x)
        return 1;
    if (q.x > p.x)
        return 0;
    if (q.y < p.y)
        return 1;
    return 0;
}

bool cmp_y(point q, point p)
{
    if (q.y < p.y)
        return 1;
    if (q.y > p.y)
        return 0;
    if (q.x < p.x)
        return 1;
    return 0;
}

bool cmp_pr(point q, point p)
{
    return nb[q.idx] < nb[p.idx];
}

vector <point> v;
vector <point> d;
bool used[2*MAXN];
point box[MAXN];

void input()
{
    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        int x, y;
        cin >> x >> y;
        v.push_back(point(x, y, 1, i));
        box[i].x = x;
        box[i].y = y;
    }
    cin >> m;
    for (int i = 0; i < m; ++i)
    {
        int x, y;
        cin >> x >> y;
        v.push_back(point(x, y, 0));
    }
}

vector <point> ans;
vector <int> adj[MAXN];

void solve()
{

    sort (v.begin(), v.end(), cmp_x);
    for (int i = 0; i < n + m - 1; ++i)
        if (v[i].t && v[i+1].t)
        {
            if (v[i].x == v[i+1].x)
            {
                nb[v[i].idx]++;
                nb[v[i+1].idx]++;
                adj[v[i].idx].push_back(v[i+1].idx);
                adj[v[i+1].idx].push_back(v[i].idx);
            }
        }
    sort(v.begin(), v.end(), cmp_y);
    for (int i = 0; i < n + m - 1; ++i)
        if (v[i].t && v[i+1].t)
        {
            if (v[i].y == v[i+1].y)
            {
                nb[v[i].idx]++;
                nb[v[i+1].idx]++;
                adj[v[i].idx].push_back(v[i+1].idx);
                adj[v[i+1].idx].push_back(v[i].idx);
            }
        }
    sort(v.begin(), v.end(), cmp_pr);
    for (int i = 0; i < v.size(); ++i)
        if (v[i].t && !used[v[i].idx])
        {
            //cout << v[i].x << " * " << v[i].y << endl;
            if (nb[v[i].idx] == 0)
            {
                //cout << "   **" << endl;
                ans.push_back(point(v[i].x, v[i].y + 1, 1));
                used[v[i].idx] = 1;
                continue;
            }
            int min1 = MAXN;
            int id = -1;
            for (auto nxt: adj[v[i].idx])
                if (!used[nxt])
                {
                    if (nb[nxt] < min1)
                    {
                        min1 = nb[nxt];
                        id = nxt;
                    }
                }
            //cout << box[id].x << " - " << box[id].y << endl;
            if (id == -1)
            {
                ans.push_back(point(v[i].x, v[i].y + 1, 1));
                used[v[i].idx] = 1;
            }
            else
            {
                if (box[id].x == v[i].x)
                {
                    if (box[id].y > v[i].y)
                        ans.push_back(point(box[id].x, v[i].y + 1, 1));
                    else
                        ans.push_back(point(box[id].x, v[i].y - 1, 1));
                }
                else
                {
                    if (box[id].x > v[i].x)
                        ans.push_back(point(box[id].x + 1, v[i].y, 0));
                    else
                        ans.push_back(point(box[id].x - 1, v[i].y, 0));
                }
                for (auto ct: adj[v[i].idx])
                    --nb[ct];
                for (auto ct: adj[id])
                    --nb[ct];
                used[id] = 1;
                used[v[i].idx] = 1;
            }
        }
    cout << ans.size() << endl;
    for (int i = 0; i < ans.size(); ++i)
        cout << ans[i].t << " " << ans[i].x << " " << ans[i].y << endl;
}

/**
8
6 2
11 4
2 9
6 7
4 9
6 4
6 9
11 9
2
11 7
8 9

*/

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}
