#include <iostream>
#include <bitset>

using namespace std;

const int MAXN = 1300000000;///2 * 10 ^ 9 = 2000000000

struct binary_number {
    bitset <MAXN> b;
    int len;
};

void gen_num();
void print_num(binary_number x);
void solve();

int n;
int ans;
binary_number num;

void solve() {
    while(true) {
        //print_num(num);
        //cout << ans << endl;
        ++ans;
        /*if(num.len == 2 && num.b[0] == 0 && num.b[1] == 1) {
            ans = 0;
            return;
        }*/
        bool flag = false;
        if(num.b[0] == 0) {
            for(int i = 1; i < num.len; ++i) {
                if(num.b[i] == 0) {
                    flag = true;
                    break;
                }
            }
            if(!flag) {
                ans = 0;
                return;
            }
        }
        if(num.len == 1 && num.b[0] == 1) {
            return;
        }

        flag = false;
        for(int i = 0; i < num.len; ++i) {
            if(num.b[i] == 0) {
                flag = true;
                break;
            }
        }

        if(flag) {
            num.b[num.len - 1] = 0;
            //print_num(num);
            for(int i = 0; i < num.len; ++i) {
                //print_num(num);
                if(num.b[i] == 0) {
                    num.b[i] = 1;
                    break;
                }
                else {
                    num.b[i] = 0;
                }

            }
            for(int i = num.len - 1; i >= 0; --i) {
                if(num.b[i] == 0)
                    --num.len;
                else
                    break;
            }
        }
        else {
            return;
        }
    }
}

int main() {
    cin >> n;

    gen_num();
    //print_num(num);
    solve();

    cout << ans << endl;
    return 0;
}

void print_num(binary_number x) {
    cout << x.len << " ";
    for(int i = 0;i < x.len; ++i) {
        cout << x.b[i];
    }
    cout << " " << ans << endl;
}

void gen_num() {
    if(n % 2 == 0) {
        for(int i = 0; i < n; ++i) {
            if(i % 2 == 0)
                num.b[i] = 0;
            else
                num.b[i] = 1;
        }
    }
    else {
        for(int i = 0; i < n; ++i) {
            if(i % 2 == 0)
                num.b[i] = 1;
            else
                num.b[i] = 0;
        }
    }
    num.len = n;
}
