#pragma GCC optimize("O3, Ofast , unroll-loops , no-stack-protector , fast-math")
#pragma optimization_level_3
#pragma target("avx2")
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
#define pb push_back
#define pii pair<int,int>
using namespace std;
//using namespace __gnu_pbds;
const int inf = 1e9+5;
typedef long long ll;
typedef unsigned int uint;
const ll linf = 1e18+5;
//typedef tree<int, null_type , less<int> , rb_tree_tag , tree_order_statistics_node_update> ordset;
int n;
//ordset st;
int rez ;
int nr[1000005];
int sg[8000005], lz[8000005];
void build(int nod  , int l , int r){
	if(l == r){
		sg[nod] = nr[l];
		return ;
	}
	int mid = (l+r)/2;
	build(nod*2,l,mid);
	build(nod*2+1,mid+1,r);
	sg[nod] = sg[nod*2] + sg[nod*2 + 1];
}
void update_nod(int nod){
	if(lz[nod] == 1){
		lz[nod] = 0;
		sg[nod] = 0;
		lz[nod*2] = 1;
		lz[nod*2+1] = 1;
	}
}
int query(int nod , int l , int r , int lt , int rt){
	if(l > r ||  rt < l || lt > r || lt > rt){return 0;}
	update_nod(nod);
	if(lt >= l && rt <= r)return sg[nod];
	if(lt != rt){
	int mid = (lt+rt)/2;
	return query(nod*2,l,r,lt,mid) + query(nod*2+1,l,r,mid+1,rt);
	}
	else{
		return 0;
	}	
}
void set_0(int nod, int l , int r , int lt , int rt){
	if(lt > rt || rt < l || lt > r || l > r){return ;}
	if(lt >= l && rt <= r){
		lz[nod] = 1;
		update_nod(nod);
	}
	if(lt != rt){
	int mid = (lt+rt)/2;
	set_0(nod*2,l,r,lt,mid);
	set_0(nod*2+1,l,r,mid+1,rt);
	sg[nod] = sg[nod*2] + sg[nod*2 + 1];
	}
}
void update(int nod , int pos , int l , int r, int val){
	if(pos < l || pos > r || l > r){
		return ;
	}
	update_nod(nod);
	sg[nod] += val;
	if(l != r){
		int mid = (l+r)/2;
		update(nod*2,pos,l,mid,val);
		update(nod*2+1,pos,mid+1,r,val);
		sg[nod] = sg[nod*2] + sg[nod*2+1];
	}
}
int find_val(int nod , int l , int r , int val){
	update_nod(nod);
	if(l == r){
		if(sg[nod] == val)return l;
	}
	update_nod(2*nod);
	update_nod(2*nod+1);
	int mid = (l+r)/2;
	if(sg[2*nod] < val){
		return find_val(2*nod +1 , mid + 1 , r  , val - sg[2*nod]);
	}else{
		return find_val(2*nod , l , mid , val);
	}
}
int find_first_zero(int nod , int l , int r , int val){
	update_nod(nod);
	if(l == r){
		if(sg[nod] == 0 && l - 1 == val)return l;
		else{
			return -1;
		}
	}
	int mid = (l+r)/2;
	update_nod(2*nod);
	update_nod(2*nod+1);
	if(sg[2*nod] < mid - val){
		return find_first_zero(nod*2 , l , mid , val);
	}else{
		return find_first_zero(nod*2 + 1 , mid + 1 , r , val + sg[nod*2]);
	}
}
void disp(int nod , int l , int r){
	if(l == r){
		update_nod(nod);
	}else{
		update_nod(nod);
		int mid = (l+r)/2;
		disp(nod*2,l,mid);
		disp(nod*2+1,mid+1,r);
	}
}
int rec(){
	++rez;
	int bits = query(1,1,n,1,n);
	//cout << "CHECKQ" << '\n';
	if(!bits){
		return 0;
	}
	//cout << "CHECKQ" << '\n';
	if(query(1,1,bits,1,n) == bits){
		return 1;
	}
	//cout << "CHECKQ" << '\n';
	if(query(1,1,1,1,n) == 0 && query(1,1,bits+1,1,n) == bits){
		return 0;
	}

	//cout << "CHECKQ2" << '\n';
	int last_bit = find_val(1,1,n,bits);
	//cout << "CHECKF" << '\n';
	// cautam pozitia in care query(1,1,n,1,pos) = bits && query(1,1,n,1,pos-1) = 0

	update(1,last_bit,1,n, -1);
	//cout << "CHECKU" << '\n';
	// set nr[base] = 0;
	int frzero = find_first_zero(1,1,n,0);
	assert(frzero != -1);
	//cout << "CHECKZ" << '\n';
	update(1,frzero,1,n,1);
	//disp(1,1,n);
	//cout << "CHECKU" << '\n';
	//cout << frzero << '\n';
	set_0(1,1 , frzero - 1, 1, n);
	//cout << "CHECKS" << '\n';
 	//disp(1,1,n);
 	//cout << '\n';
	return 2;
}
int main(){
	ios_base::sync_with_stdio(0), cin.tie(0) , cout.tie(0);
	cin >> n;
	for(ll i = 1 ; i <= n ; i++){
		if(i % 2 == n % 2){
			nr[i] = 1 ;
		}
	}
	for(int i = 1; i <= n ; i++){
		//cout << nr[i] << ' ';
	}
	//cout << '\n';
	build(1,1,n);
	int rt = 2;
	while(rt == 2){
		rt = rec();
	}
	if(rt == 1){
		cout << rez << '\n';
	}else{
		cout << 0 << '\n';
	}
	return 0;
	/*for(int i = 1;  i <= (1 << 10) ; i++){
		if(__builtin_popcount(i+1) == 1){
			dp[i] = 1;
			continue;
		}
		int base = 1;
		while(base < i){
			base  = base << 1;
		}
		base  = base >> 1;
		dp[i] = dp[i - base + 1];
	}
	for(int i = 1; i <= (1<<10); i++){
		for(int k = 0 ; k < 10 ; k++){
			cout << (i&(1<<k) ? 1 : 0) << ' ';
		}
		cout << "res: " << dp[i] << '\n';
	}
	*/
}