#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using namespace std;

#define pb push_back
#define dbg(x) cerr << #x << " " << x << "\n"
#define get_here() cerr << "-1\n"
typedef long long ll;


vector <int> adun (vector <int> a, vector <int> b) {
    vector <int> ans;
    ans.resize (max (a.size (), b.size ()));
    a.resize (ans.size ());
    b.resize (ans.size ());
    int r = 0;
    for (int i = 0; i < ans.size (); i++) {
        int t = r + a[i] + b[i];
        ans[i] = t % 2;
        r = t / 2;
    }
    if (r)
        ans.pb (r);
    return ans;
}
bool smaller (vector <int> &a, vector <int> &b) {
    if (a.size () != b.size ())
        return a.size () < b.size ();
    for (int i = a.size () - 1; i >= 0; i--) {
        if (a[i] != b[i])
            return a[i] < b[i];
    }
    return true;
}
int main () {
    ios::sync_with_stdio (false);
    cin.tie (0); cout.tie(0);

    int n;
    cin >> n;
    vector <int> nr (n);
    for (int i = n - 1; i >= 0; i -= 2) {
        nr[i] = 1;
    }
    vector <int> sum;
    sum.pb (0);
    int ans = 0;
    for (int i = n; i > 0; i--) {
        vector <int> a (i);
        for (int j = 0; j < i; j++)
            a[j] = 1;
        auto rez = adun (sum, a);
        if (smaller (rez, nr))
            sum = rez, ans++;
    }
    if (sum == nr) {
        cout << ans << "\n";
    }
    else
        cout << 0;
    return 0;
}
