#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using namespace std;

#define pb push_back
#define dbg(x) cerr << #x << " " << x << "\n"
#define get_here() cerr << "-1\n"
typedef long long ll;

struct Concert {
    int a;
    int b;
    int c;
    int d;
};
struct Interval {
    int x;
    int y;
    int type;
    int ind;
};

const int N = 1e5;
Concert con[1 + N];
bool ok;
vector <int> path;
vector <Interval> v;
int viz[1 + N];
vector <int> gr[1 + N];
void dfs (int x) {
    if (!ok)
        return;
    path.pb (v[x].ind);
    viz[v[x].ind] = v[x].type;
    for (auto y : gr[x]) {
        if (viz[v[y].ind] == 0) {
            if (v[y].type == 1)
                dfs (y + 1);
            else
                dfs (y - 1);
        }
        else if (viz[v[y].ind] == v[y].type)
            ok = false;
        if (!ok)
            return;
    }
}
bool incearca (int x) {
    ok = true;
    path.clear ();
    dfs (x);
    if (!ok)
        for (auto  y : path)
            viz[y] = 0;
    return ok;
}

bool intersect (Interval a, Interval b) {
    if (a.x <= b.x && b.x <= a.y)
        return true;
    if (a.x <= b.y && b.y <= a.y)
        return true;
    if (b.x <= a.x && a.x <= b.y)
        return true;
    if (b.x <= a.y && a.y <= b.y)
        return true;
    return false;
}

int main () {
    ios::sync_with_stdio (false);
    cin.tie (0); cout.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> con[i].a >> con[i].b >> con[i].c >> con[i].d;
        v.pb ({con[i].a, con[i].b, 1, i});
        v.pb ({con[i].c, con[i].d, 2, i});
    }
    for (int i = 0; i < v.size (); i++) {
        for (int j = i + 1; j < v.size (); j++) {
            if (intersect (v[i], v[j])) {
                gr[i].pb (j);
                gr[j].pb (i);
            }
        }
    }
    for (int i = 0; i < v.size (); i++) {
        if (viz[v[i].ind] == 0) {
            bool t = incearca (i);
            if (t)
                continue;
            bool ok = false;
            for (auto x : gr[i]) {
                bool t = incearca (x);
                if (t) {
                    ok = true;
                    break;
                }
            }
            if (!ok) {
                cout << "No\n";
                return 0;
            }
        }
    }
    cout << "Yes\n";
    for (int i = 1; i <= n; i++)
        cout << viz[i] << "\n";
    return 0;
}
