#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using namespace std;

#define pb push_back
#define dbg(x) cerr << #x << " " << x << "\n"
#define get_here() cerr << "-1\n"
typedef long long ll;

inline vector <int> adun (vector <int> &a, vector <int> &b) {
    vector <int> ans;
    ans.resize (max (a.size (), b.size ()));
    int r = 0;
    for (register int i = 0; i < ans.size (); i++) {
        register int t = r;
        if (i < a.size ())
            t += a[i];
        if (i < b.size ())
            t += b[i];
        ans[i] = t % 2;
        r = t / 2;
    }
    if (r)
        ans.pb (r);
    return ans;
}
bool smaller (vector <int> &a, vector <int> &b) {
    if (a.size () != b.size ())
        return a.size () < b.size ();
    for (register int i = a.size () - 1; i >= 0; i--) {
        if (a[i] != b[i])
            return a[i] < b[i];
    }
    return true;
}
int main () {
    ios::sync_with_stdio (false);
    cin.tie (0); cout.tie(0);

    int n;
    cin >> n;
    if (n > 1000) {
        vector <int> nr (n);
        for (int i = n - 1; i >= 0; i -= 2) {
            nr[i] = 1;
        }
        vector <int> sum;
        vector <int> s (n + 2);
        int ans = 0;
        for (int i = n - 1; i > 20; i -= 2) {
            s[i]--;
            s[0]++;
            ans++;
        }
        for (int i = 1; i <= n; i++)
            s[i] += s[i - 1];
        int r = 0;
        int i = 0;
        do {
            sum.pb (s[i] + r);
            r = sum.back () / 2;
            sum[sum.size () - 1] %= 2;
            i++;
        } while (r || i <= n);
        while (sum.back () == 0)
            sum.pop_back ();
        for (int i = 20; i > 0; i--) {
            vector <int> a (i);
            for (int j = 0; j < i; j++)
                a[j] = 1;
            auto rez = adun (sum, a);
            if (smaller (rez, nr))
                sum = rez, ans++;
        }
        if (sum == nr) {
            cout << ans << "\n";
        }
        else
            cout << 0 << "\n";
        return 0;
    }
    vector <int> nr (n);
    for (int i = n - 1; i >= 0; i -= 2) {
        nr[i] = 1;
    }
    vector <int> sum;
    sum.pb (0);
    int ans = 0;
    for (int i = n; i > 0; i--) {
        vector <int> a (i);
        for (int j = 0; j < i; j++)
            a[j] = 1;
        auto rez = adun (sum, a);
        if (smaller (rez, nr))
            sum = rez, ans++;
    }
    if (sum == nr) {
        cout << ans << "\n";
    }
    else
        cout << 0 << "\n";
    return 0;
}
