#include <iostream>
#include <vector>

using namespace std;

int solve(int num_bits, vector<int> bits) {
    int aux = 0;
    for (int i = 0; i < bits.size(); i++)
        aux += (1 << bits[i]);

    int i = 0;
    while (i < bits.size() && bits[i] == i)
        i++;
    if (i == bits.size())
        return 1;

    long long x = num_bits;
    int ans = num_bits;
    i = 0;
    while (i < bits.size() && (1LL << bits[i]) - 1 <= x) {
        x += (1LL << bits[i]) - 1;
        ans --;
        i++;
    }
    vector<int> xbits;
    for (int i = 0; (1LL << i) <= x; i++)
        if ((x >> i) & 1)
            xbits.push_back(i);
    i = 0;
    while (i < xbits.size() && i < bits.size() && xbits[i] == bits[i])
        i++;
    if (i >= bits.size())
        return -1;

    int y = solve(xbits.size(), xbits);
    if (y == -1)
        return -1;

    return ans + y;
}

int main() {
    int n;
    cin >> n;

    vector<int> bits;
    for (int i = 1 - n % 2; i < 40 && i < n; i += 2)
        bits.push_back(i);
    int ans = solve((n + 1) / 2, bits);
    cout << (ans != -1 ? ans : 0);

    return 0;
}
