#include <bits/stdc++.h>

using namespace std;

const int lim = 32;

long long ans[lim + 5];
bool fol[lim + 5];

int brut(long long x) {
	memset(fol, 0, sizeof(fol));
	int ans = 0;
	while (x) {
		long long c = 0;
		int i = 0;
		while (c <= x) {
			c = c * 2 + 1;
			i++;
		}
		c /= 2;
		i--;
		if (fol[i]) {
			return 0;
		}
		fol[i] = 1;
		x -= c;
		ans++;
	}
	return ans;
}

int solve(int n) {
	if (n <= lim) {
		long long x = 0;
		for (int i = 1; i <= n; ++i)
			x = x * 2 + i % 2;
		return brut(x);
	} else {
		int last = 0;
		for (int i = 1 + n % 2; i <= lim; i += 2) {
			if (ans[i] <= (n - i) / 2 + 1)
				last = i;
			else
				break;
		}
		last += 2;
		long long x = 0;
		for (int i = 1; i < last; ++i)
			x = x * 2 + i % 2;
		x += (n - last) / 2 + 1;
		int sol = brut(x);
		if (sol == 0)
			return 0;
		return sol + (n - last) / 2 + 1;
	}
}

int main() {
	//freopen("date.in", "r", stdin);
	//freopen("date.out", "w", stdout);

	ans[1] = ans[2] = 1;
	for (int i = 3; i <= lim; ++i)
		ans[i] = ans[i - 2] + (1 << (i - 3));

	int n;
	scanf("%d", &n);
	printf("%d\n", solve(n));

	return 0;
}
