#include <bits/stdc++.h>

using namespace std;

typedef pair<int,int> Pair;
const int Nmax = 5e5 + 5;

int n, m, cx, cy;

struct ww
{
    int x, y;
};
ww box[Nmax], rock[Nmax];

map<int,int> mpX, mpY;
vector<int> vx[Nmax], vy[Nmax];

vector<int> v[Nmax];
vector<int> nodes;
bool used[Nmax];

vector<Pair> ans;
vector<int> ans2;

bool cmp1(int x, int y)
{
    return box[x].y < box[y].y;
}

bool cmp2(int x, int y)
{
    return box[x].x < box[y].x;
}

void add_edge(int x, int y)
{
    v[x].push_back(y);
    v[y].push_back(x);
}

void dfs(int node)
{
    nodes.push_back(node);
    used[node] = 1;

    for(auto it : v[node])
        if(!used[it])
            dfs(it);
}

int main()
{
  //  freopen("input", "r", stdin);
    cin.sync_with_stdio(false); cin.tie(0);

    cin >> n;

    int i, j;
    for(i=1; i<=n; ++i)
    {
        cin >> box[i].x >> box[i].y;
        mpX[box[i].x] = 1; mpY[box[i].y] = 1;
    }

    cin >> m;

    for(i=1; i<=m; ++i)
    {
        cin >> rock[i].x >> rock[i].y;
        mpX[rock[i].x] = 1; mpY[rock[i].y] = 1;
    }

    for(i=1; i<=m; ++i)
        box[i+n] = rock[i];

    cx = 0;
    for(auto &it : mpX) it.second = ++cx;
    cy = 0;
    for(auto &it : mpY) it.second = ++cy;

    for(i=1; i<=n; ++i)
        vx[mpX[box[i].x]].push_back(i), vy[mpY[box[i].y]].push_back(i);

    for(i=1; i<=m; ++i)
        vx[mpX[rock[i].x]].push_back(i+n), vy[mpY[rock[i].y]].push_back(i+n);

    for(i=1; i<=cx; ++i)
    {
        sort(vx[i].begin(), vx[i].end(), cmp1);

        for(j=0; j+1<vx[i].size(); ++j)
            if(vx[i][j] <= n && vx[i][j+1] <= n)
                add_edge(vx[i][j], vx[i][j+1]);
    }

    for(i=1; i<=cy; ++i)
    {
        sort(vy[i].begin(), vy[i].end(), cmp2);

        for(j=0; j+1<vy[i].size(); ++j)
            if(vy[i][j] <= n && vy[i][j+1] <= n)
                add_edge(vy[i][j], vy[i][j+1]);
    }

    for(i=1; i<=n; ++i)
        if(!used[i])
        {
            nodes.clear();
            dfs(i);

            for(j=0; j+1<nodes.size(); j+=2)
                ans.push_back({nodes[j], nodes[j+1]});

            if(nodes.size() % 2 == 1)
                ans2.push_back(nodes.back());
        }

    cout << ans.size() + ans2.size() << '\n';

    for(auto it : ans2)
        cout << 1 << ' ' << box[it].x << ' ' << box[it].y + 1 << '\n';

    for(auto it : ans)
        cout << (box[it.first].x == box[it.second].x) << ' ' << (box[it.first].x + box[it.second].x) / 2 << ' ' << (box[it.first].y + box[it.second].y) / 2 << '\n';

    return 0;
}
