#include <bits/stdc++.h>
using namespace std;

const int N = 2e6 + 5;

int v[N], mask[N], result[N];

using i64 = long long;
int n, popcnt;

void cazmic() {
	for (int val = 1, i = n - 1; i >= 0; --i, val = 1 - val) {
		v[i] = val;
		popcnt+= val; }

	for (int i = 0; i < N; ++i) {
		int p;
		for (p = 0; v[p] == 1; ++p)
			v[p] = 0;
		v[p] = 1;
		popcnt = popcnt - p + 1;
		if (popcnt == i + 1) {
			cout << i + 1 << '\n';
			return; } }

	cout << "0\n";
	return; }

static int add() {
	int carry = 0, popula = popcnt;
	bool flag = true;
	for (int i = 0; flag || i < 60; ++i) {
		result[i] = (v[i] + mask[i] + carry) % 2;
		carry = (v[i] + mask[i] + carry) / 2;
		popula+= result[i] - v[i];
		if (carry == 0)
			flag = false; }
	return popula; }

static int check(i64 arg) { // (popcnt <=> arg) === (1, 0, -1)
	for (int i = 0; i < 40; ++i)
		mask[i] = 0;
	for (int bit = 0; (1LL << bit) <= arg; ++bit)
		if ((1LL << bit) & arg)
			mask[bit] = 1;

	int popula = add();
	if (popula < arg)
		return -1;
	else if (popula == arg)
		return 0;
	else
		return 1; }

static void cazmare() {
	popcnt = n / 2;
	i64 ans = 0;

	for (int i = 0, val = n % 2; i < N; ++i, val = 1 - val)
		v[i] = val;

	for (i64 caz = 1LL << 32; caz > 0; caz/= 2)
		if (check(ans + caz) > 0)
			ans+= caz;

	for (int i = 0; i < 10; ++i)
		if (check(ans + i) == 0) {
			cout << ans + i << '\n';
			return; } } 

int main() {
#ifdef HOME
	freopen("present.in", "r", stdin);
	freopen("present.out", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	cin >> n;
	if (n <= 1e6)
		cazmic();
	else
		cazmare();

	return 0; }

