#include <iostream>

using namespace std;

int N;
char S[100];

static inline void Build (long long &Nr, int N)
{
    Nr = 0;

    for(int i = 1; i <= N; ++i)
    {
        if(i % 2 == 1)
            S[i] = '1';
        else
            S[i] = '0';
    }

    int B = -1;

    for(int i = N; i >= 1; --i)
    {
        ++B;

        if(S[i] == '1')
            Nr += 1LL * (1LL << B);
    }

    return;
}

static inline int Cnt_Biti (long long Nr)
{
    int r = 0;

    while(Nr)
    {
        if(Nr % 2)
            ++r;

        Nr /= 2;
    }

    return r;
}

static inline int Precalculation (int N)
{
    int ans = 0;
    long long Nr = 0;

    Build(Nr, N);

    for(int T = 1; T <= 60; ++T)
    {
        long long Now = Nr + T;

        if(Cnt_Biti(Now) == T)
        {
            ans = T;

            break;
        }
    }

    return ans;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N;

    cout << Precalculation(N) << '\n';

    return 0;
}
