#include <iostream>
#include <vector>

using namespace std;

const int NMAX = 1e5 + 5;

int N;

struct Cantaret
{
    int a, b, c, d;
};

Cantaret A[NMAX];

vector < pair < int, int > > V;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N;

    for(int i = 1; i <= N; ++i)
        cin >> A[i].a >> A[i].b >> A[i].c >> A[i].d;

    return;
}

static inline void Task1 ()
{
    for(int i = 0; i < (1 << N); ++i)
    {
        V.clear();

        for(int j = 0; j < N; ++j)
            if(i & (1 << j))
                V.push_back({A[j + 1].a, A[j + 1].b});
            else
                V.push_back({A[j + 1].c, A[j + 1].d});

        int M = (int)V.size();

        bool Ok = 1;

        for(int ii = 0; ii < M - 1 && Ok; ++ii)
            for(int jj = ii + 1; jj < M && Ok; ++jj)
            {
                int x1 = V[ii].first;
                int y1 = V[ii].second;

                int x2 = V[jj].first;
                int y2 = V[jj].second;

                if(x1 > x2)
                {
                    swap(x1, x2);
                    swap(y1, y2);
                }
                else if(x1 == x2 && y1 > y2)
                    swap(y1, y2);

                if(x2 >= x1 && x2 <= y1)
                    Ok = 0;
            }

        if(Ok)
        {
            cout << "Yes" << '\n';

            for(int j = 0; j < N; ++j)
                if(i & (1 << j))
                    cout << 1 << '\n';
                else
                    cout << 2 << '\n';

            return;
        }
    }

    cout << "No" << '\n';

    return;
}

int main()
{
    Read();

    if(N <= 20)
        Task1();

    return 0;
}
