#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

typedef pair < int, int > PII;
typedef pair < int, PII > PIII;

const int NMAX = 4e5 + 5;

int N, M;

pair < int, int > Boxes[NMAX], Stones[NMAX];

bool Sel[NMAX];

vector < PIII > Sol;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL);

    cin >> N;

    for(int i = 1; i <= N; ++i)
        cin >> Boxes[i].first >> Boxes[i].second;

    cin >> M;

    for(int i = 1; i <= M; ++i)
        cin >> Stones[i].first >> Stones[i].second;

    return;
}

static inline void Try1 ()
{
    bool done = 1;

    while(done)
    {
        done = 0;

        for(int i = 1; i < N; ++i)
            for(int j = i + 1; j <= N; ++j)
                if(!Sel[i] && !Sel[j])
                {
                    if(Boxes[i].first == Boxes[j].first)
                    {
                        int Min = min(Boxes[i].second, Boxes[j].second);
                        int Max = max(Boxes[i].second, Boxes[j].second);

                        bool Ok = 1;

                        for(int k = 1; k <= N; ++k)
                            if(k == i || k == j)
                                continue;
                            else
                            {
                                if(Sel[k])
                                    continue;

                                if(Boxes[k].first != Boxes[i].first)
                                    continue;

                                if(Boxes[k].second > Min && Boxes[k].second < Max)
                                {
                                    Ok = 0;

                                    break;
                                }
                            }

                        for(int k = 1; k <= M; ++k)
                            if(Stones[k].first == Boxes[i].first && Stones[k].second > Min && Stones[k].second < Max)
                            {
                                Ok = 0;

                                break;
                            }

                        if(Ok)
                        {
                            Sel[i] = Sel[j] = 1;

                            Sol.push_back({1, {Boxes[i].first, Min + 1}});

                            done = 1;

                            continue;
                        }
                    }

                    if(Boxes[i].second == Boxes[j].second)
                    {
                        int Min = min(Boxes[i].first, Boxes[j].first);
                        int Max = max(Boxes[i].first, Boxes[j].first);

                        bool Ok = 1;

                        for(int k = 1; k <= N; ++k)
                            if(k == i || k == j)
                                continue;
                            else
                            {
                                if(Sel[k])
                                    continue;

                                if(Boxes[k].second != Boxes[i].second)
                                    continue;

                                if(Boxes[k].first > Min && Boxes[k].first < Max)
                                {
                                    Ok = 0;

                                    break;
                                }
                            }

                        for(int k = 1; k <= M; ++k)
                            if(Stones[k].second == Boxes[i].second && Stones[k].first > Min && Stones[k].first < Max)
                            {
                                Ok = 0;

                                break;
                            }

                        if(Ok)
                        {
                            Sel[i] = Sel[j] = 1;

                            Sol.push_back({0, {Min + 1, Boxes[i].second}});

                            done = 1;
                        }
                    }
                }
    }

    return;
}

static inline void Try2 ()
{
    for(int i = 1; i <= N; ++i)
        if(!Sel[i])
            Sol.push_back({1, {Boxes[i].first, Boxes[i].second + 1}});

    return;
}

static inline void Write ()
{
    cout << (int)Sol.size() << '\n';

    for(auto it : Sol)
        cout << it.first << ' ' << it.second.first << ' ' << it.second.second << '\n';

    return;
}

int main()
{
    Read();

    Try1();
    Try2();

    Write();

    return 0;
}
