//#include <bits/stdc++.h>
//#include <fstream>
#include <iostream>
#include <algorithm>

//#define LOCAL 1

#define MAX_N 4000

using namespace std;

#ifdef LOCAL
ifstream cin("festival.in");
ofstream cout("festival.out");
#endif // LOCAL

struct spectacol
{
    int st[2];
    int dr[2];
};

spectacol v[MAX_N + 1];

int n;
int stk[MAX_N + 1];

void readFile()
{
    cin >> n;
    for(int i = 1; i <= n; i ++)
    {
        cin >> v[i].st[0] >> v[i].dr[0] >> v[i].st[1] >> v[i].dr[1];
    }
}

bool verif()
{
    for(int i = 1; i <= n; i ++)
    {
        for(int j = i + 1; j <= n; j ++)
        {
            int pi = stk[i];
            int pj = stk[j];
            if(!(v[i].dr[pi] < v[j].st[pj] || v[j].dr[pj] < v[i].st[pi]))
                return 0;
        }
    }

    return 1;
}

void solve()
{
    for(int i = 0; i < (1 << n); i ++)
    {
        for(int j = 0; j < n; j ++)
        {
            if(((1 << j) & i) != 0)
                stk[j + 1] = 1;

            else
                stk[j + 1] = 0;
        }

        if(verif())
        {
            cout << "Yes\n";
            for(int h = 1; h <= n; h ++)
                cout << stk[h] + 1 << "\n";
            return;
        }
    }

    cout << "No\n";
}

void printFile()
{

}

int main()
{
    readFile();

    solve();

    printFile();

    return 0;
}
