//#include <bits/stdc++.h>
//#include <fstream>
#include <iostream>
#include <algorithm>
#include <vector>
#include <cstring>
#include <ctime>

//#define LOCAL 1

#define MAX_N 2000

using namespace std;

typedef long long lint;

#ifdef LOCAL
ifstream cin("bombs.in");
ofstream cout("bombs.out");
#endif // LOCAL

struct coord
{
    int l, c;
};

coord b[MAX_N + 1];
coord r[MAX_N + 1];

int rez;

struct elem
{
    int l, c, tip;
};

elem stk[MAX_N + 1];

elem sol[MAX_N + 1];

int n, m;

void readFile()
{
    cin >> n;
    for(int i = 1; i <= n; i ++)
    {
        cin >> b[i].l >> b[i].c;
      //  lin[b[i].l].insert({b[i].c, 0});
        //col[b[i].c].insert({b[i].l, 0});
    }

    cin >> m;
    for(int i = 1; i <= m; i ++)
    {
        cin >> r[i].l >> r[i].c;
    //    lin[r[i].l].insert({r[i].c, 1});
  //      col[r[i].c].insert({r[i].l, 1});
    }
}


const int dl[] = {-1, 1, 0, 0, -1, 1, 0, 0};
const int dc[] = {0, 0, -1, 1, 0, 0, -1, 1};
const int tip[] = {0, 0, 1, 1, 1, 1, 0, 0};

bool vie[MAX_N + 1];

void bagaLinCol()
{
    for(int i = 1; i <= n; i ++)
        vie[i] = 1;
}

int CL;
int CC;

bool ok(int tip, int l, int c)
{
    if(tip == 1)
        return (l == CL);

    ///tip == 0
    return (c == CC);
}

int mna(int nr, coord a, int tip)
{
    if(tip == 1)
        return (a.c > CC ? min(nr, a.c) : nr);

    ///tip == 0
    return (a.l > CL ? min(nr, a.l) : nr);
}

int mxa(int nr, coord a, int tip)
{
    if(tip == 1)
        return (a.c < CC ? max(nr, a.c) : nr);

    ///tip == 0
    return (a.l < CL ? max(nr, a.l) : nr);
}

bool loveste(int tip, int st, int dr, coord a)
{
    if(tip == 1)
    {
        return (a.c >= st && a.c <= dr);
    }

    ///tip == 0

    return (a.l >= st && a.l <= dr);
}

bool verif(int bombe)
{
    ///
   // if(bombe <= 3)
   //     return 0;

    //cout << " NTRU VERIF " << bombe << "\n";
    bagaLinCol();

/*
    cout << bombe << "\n";
    for(int i = 1; i <= bombe; i ++)
        cout << stk[i].l << " " << stk[i].c << " " << stk[i].tip << "\n";

    for(int i = 1; i <= n; i ++)
        cout << vie[i] << " " ;
    cout << "\n";*/

    int DISTRUS = 0;
    for(int i = 1; i <= bombe; i ++)
    {
        CL = stk[i].l;
        CC = stk[i].c;

        int h = stk[i].tip;
        int st = 1;
        int dr = (int)(1e9);

        for(int x = 1; x <= n; x ++)
        {
            if(vie[x] && ok(h, b[x].l, b[x].c))
            {
                st = mxa(st, b[x], h);
                dr = mna(dr, b[x], h);
            }
        }

        for(int x = 1; x <= m; x ++)
        {
            if(ok(h, r[x].l, r[x].c))
            {
                st = mxa(st, r[x], h);
                dr = mna(dr, r[x], h);
            }
        }

       // cout << "BOMBA " << CL << " " << CC << " TIP " << stk[i].tip << " LOSVESTE " << st << " " << dr << "\n";

        for(int x = 1; x <= n; x ++)
        {
            if(vie[x] && ok(h, b[x].l, b[x].c) && loveste(h, st, dr, b[x]))
            {
                //cout << " DISTRUGE " << b[x].l << " " << b[x].c << "\n";
                DISTRUS ++;
                vie[x] = 0;
            }
        }
    }

    if(DISTRUS == n)
    {
       // if(bombe == 4)
         //   cout << "+++++++\n";

        if(bombe < rez)
        {
            rez = bombe;
            for(int i = 1; i <= bombe; i ++)
                sol[i] = stk[i];
        }
    }

    return (DISTRUS == n);
}

void bkt(int k, int bombe)
{
    if(verif(bombe))
    {
        return;
    }
    if(bombe >= rez)
        return;
    if(k == n + 1)
    {
        verif(bombe);

        return;
    }

    if(bombe >= rez)
        return;


    if(bombe >= rez)
        return;

    bkt(k + 1, bombe);


    if(bombe >= rez)
        return;

    for(int dir = 0; dir < 4; dir ++)
    {
        int nl = b[k].l + dl[dir];
        int nc = b[k].c + dc[dir];

        if(bombe >= rez)
            return;

        stk[bombe + 1] = {nl, nc, tip[dir]};
        bkt(k + 1, bombe + 1);


        if(bombe >= rez)
            return;
    }

    if(bombe >= rez)
        return;
}

void solve()
{
    rez = n + 1;
    bkt(1, 0);
}

void printFile()
{
    cout << rez << "\n";
    for(int i = 1; i <= rez; i ++)
        cout << sol[i].tip << " " << sol[i].l << " " << sol[i].c <<  "\n";
}

int main()
{
    readFile();

    solve();

    printFile();

    return 0;
}
