#include <bits/stdc++.h>
using namespace std;

struct festival{
    int a, b, c, d, p;
    bool operator < (const festival &aux)const{
        if(a != aux.a) return a < aux.a;
        if(c != aux.c) return c < aux.c;
        if(b != aux.b) return b < aux.b;
        return d < aux.d;
    }
};

festival x[100005];
int n;

int nrc, tmp;
int h[400005], low[400005], id[400005], val[400005], run[400005], TT[400005];
bool instack[400005];
bool viz[400005];
vector <int> v[400005];
vector <int> ctc[400005];

int nigation(int x){
    if(x <= 2 * n) return 2 * n + x;
    return x - 2 * n;
}

void build_edge(int x, int y){
    v[x].push_back(nigation(y));
    v[y].push_back(nigation(x));
//    v[nigation(x)].push_back(y);
//    v[nigation(y)].push_back(x);
}

bool intersect(int st, int dr, int x, int y){
    if(x <= st && dr <= y) return 1;
    if(st <= x && y <= dr) return 1;

    if(st <= y && dr >= y)
        return 1;
    if(x <= dr && y >= dr)
        return 1;
    return 0;
}

void build_graph(){
    srand(time(NULL));
    random_shuffle(x + 1, x + n + 1);

    for(int i = 1; i <= n ; ++i){
        int A = 2 * x[i].p - 1, B = 2 * x[i].p;
        build_edge(A, B);
        build_edge(nigation(A), nigation(B));

        for(int j = i + 1; j <= i + 1500 && j <= n ; ++j){
            int X = 2 * x[j].p - 1, Y = 2 * x[j].p;
            bool ok = false;
            if(intersect(x[i].a, x[i].b, x[j].a, x[j].b)) build_edge(nigation(A), nigation(X)), ok = true;
            if(intersect(x[i].a, x[i].b, x[j].c, x[j].d)) build_edge(nigation(A), nigation(Y)), ok = true;
            if(intersect(x[i].c, x[i].d, x[j].a, x[j].b)) build_edge(nigation(B), nigation(X)), ok = true;
            if(intersect(x[i].c, x[i].d, x[j].c, x[j].d)) build_edge(nigation(B), nigation(Y)), ok = true;
        }
    }

//    for(int i = 1; i <= n ; ++i){
//        for(auto it : v[2 * n + 2 * i - 1]){
//            printf("%d %d ", i, 1);
//            int x = (it + 1) / 2, ok = 1;
//            if(it % 2 == 0) ok = 2;
//
//            printf("%d %d\n", x, ok);
//        }
//        for(auto it : v[2 * n + 2 * i]){
//            printf("%d %d ", i, 2);
//            int x = (it + 1) / 2, ok = 1;
//            if(it % 2 == 0) ok = 2;
//
//            printf("%d %d\n", x, ok);
//        }
//    }
}

stack <int> st;
void tarjan(int nod){
    run[nod] = tmp;
    viz[nod] = 1;
    instack[nod] = 1;
    st.push(nod);

    for(auto it : v[nod]){
        if(!viz[it]){
            h[it] = low[it] = h[nod] + 1;
            TT[it] = nod;
            tarjan(it);
            low[nod] = min(low[nod], low[it]);
        }
        else if(run[nod] == run[it] && instack[it]) low[nod] = min(low[nod], h[it]);
    }

    if(low[nod] == h[nod]){
        int x = 0;
        ++nrc;
        do{
            x = st.top();
            st.pop();
            instack[x] = 0;
            id[x] = nrc;
            ctc[nrc].push_back(x);
        }while(x != nod);
    }
}

int main()
{
//    freopen("1.in", "r", stdin);

    scanf("%d", &n);
    for(int i = 1; i <= n ; ++i) scanf("%d%d%d%d", &x[i].a, &x[i].b, &x[i].c, &x[i].d), x[i].p = i;

    build_graph();

    for(int i = 1; i <= 4 * n ; ++i){
        val[i] = -1;
        if(!viz[i]){
            ++tmp;
            h[i] = low[i] = 1;
            tarjan(i);
        }
    }

    for(int i = 1; i <= n ; ++i){
        if(id[2 * i - 1] == id[nigation(2 * i - 1)]){
            printf("No\n");
            return 0;
        }
        if(id[2 * i] == id[nigation(2 * i)]){
            printf("No\n");
            return 0;
        }
    }

    for(int i = nrc; i >= 1 ; --i){
        int x = 1;
        for(auto it : ctc[i])
            if(val[it] == 0) x = 0;

        for(auto it : ctc[i]){
            if(val[it] == -1){
                val[it] = x;
                val[nigation(it)] = 1 - x;
            }
            else if(val[it] != x){
                printf("No\n");
                return 0;
            }

            if(val[it] == 0){
                for(auto nod : v[it]){
                    if(id[nod] != id[it]){
                        if(val[nod] == 1){
                            printf("No\n");
                            return 0;
                        }
                        else val[nod] = 0;
                    }
                }
            }
        }
    }

    for(int i = 1; i <= n ; ++i){
        if(val[2 * i - 1] == val[2 * i] && val[2 * i] == 0){
            printf("No\n");
            return 0;
        }
    }

    printf("Yes\n");
    for(int i = 1; i <= n ; ++i){
        if(val[2 * i - 1] == 1) printf("1\n");
        else printf("2\n");
    }

    return 0;
}
















