#include<bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;
//#define int long long
#define endl '\n'



int n;
pair<int, int> seg[(int)2e5 + 5];
vector<int> g[(int)2e5 + 5], e[(int)2e5 + 5];
int clr[(int)2e5 + 5];
int cur = 1;
void paint(int v){
	clr[v] = cur;
	for(int to: e[v]){
		if(clr[to] == 0) paint(to);
	}
}

struct eve{
	int x;
	int ind;
	char type;
	bool operator<(const eve &oth) const{
		if(x == oth.x){
			return type > oth.type;
		}
		return x < oth.x;
	}
};

int used[(int)2e5 + 5];
vector<int> tops;
void topsort(int v){
	used[v] = 1;
	for(int to: g[v]){
		if(!used[to]) topsort(to);
	}
	tops.push_back(v);
}
signed main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for(int i = 0; i < n; i++){
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		seg[2 * i] = {a, b};
		seg[2 * i + 1] = {c, d};
	}
	unordered_set<int> curr;
	vector<eve> events;
	for(int i = 0; i < 2 * n; i++){
		events.push_back({seg[i].first, i, 1});
		events.push_back({seg[i].second, i, -1});
	}
	sort(events.begin(), events.end());
	for(int i = 0; i < events.size(); i++){
		if(clock() * 2 >= 3 * CLOCKS_PER_SEC){
			cout << "No";
			return 0;
		}
		if(events[i].type == 1){
			for(int j: curr){
				int k = events[i].ind;
				if(k / 2 == j / 2) continue;
				int a = seg[k].first, b = seg[k].second;
				if(seg[j / 2 * 2 + 1 - j % 2].first > b || a > seg[j / 2 * 2 + 1 - j % 2].second){
					g[k].push_back(j / 2 * 2 + 1 - j % 2);
					e[j / 2 * 2 + 1 - j % 2].push_back(k);
				}
			}
			for(int k: curr){
				int j = events[i].ind;
				if(k / 2 == j / 2) continue;
				int a = seg[k].first, b = seg[k].second;
				if(seg[j / 2 * 2 + 1 - j % 2].first > b || a > seg[j / 2 * 2 + 1 - j % 2].second){
					g[k].push_back(j / 2 * 2 + 1 - j % 2);
					e[j / 2 * 2 + 1 - j % 2].push_back(k);
				}
			}
			curr.insert(events[i].ind);
		}
		else curr.erase(events[i].ind);
	}
	// }
	// for(int i = 0; i < 2 * n; i++){
	// 	for(int j = 0; j < 2 * n; j++){
	// 		if(i / 2 == j / 2) continue;
	// 		int a = seg[i].first, b = seg[i].second, c = seg[j].first, d = seg[j].second;
	// 		if(!(c > b || a > d)){
	// 			if(seg[j / 2 * 2 + 1 - j % 2].first > b || a > seg[j / 2 * 2 + 1 - j % 2].second){
	// 				cout << i << ' ' << j << ' ' << "i2" << endl;
	// 			}
	// 		}
	// 	}
	// }
	for(int i = 0; i < 2 * n; i++){
		if(!used[i]) topsort(i);
	}
	reverse(tops.begin(), tops.end());
	for(int to: tops){
		//cout << to << ' ' ;
		if(!clr[to]){
			paint(to);
			cur++;
		}
	}
	for(int i = 0; i < n; i++){
		//cout << clr[2 * i] << ' ' << clr[2 * i + 1] << endl;
		if(clr[2 * i] == clr[2 * i + 1]){
			cout << "No";
			return 0;
		}
	}
	reverse(tops.begin(), tops.end());
	vector<int> ans(n, 2);
	for(int i = 0; i < 2 * n; i++){
		if(ans[tops[i] / 2] == 2) ans[tops[i] / 2] = tops[i] % 2;
	}

	vector<eve> even;
	for(int i = 0; i < n; i++){
		even.push_back({seg[2 * i + ans[i]].first, i, 1});
		even.push_back({seg[2 * i + ans[i]].second, i, -1});
	}
	sort(even.begin(), even.end());
	int bal = 0;
	for(int i = 0; i < even.size(); i++){
		bal += even[i].type;
		if(bal > 1) {
			cout << "No";
			return 0;
		}
	}
	cout << "Yes" << endl;
	for(int i = 0; i < n; i++) cout << ans[i] + 1 << endl;
	return 0;
}
