#include<bits/stdc++.h>

#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define f first
#define s second
#define size(x) (int)x.size()

using namespace std;

typedef long long ll;
typedef long double ld;

void io() {
#ifdef MLOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}

void solve() {
	int n, m;
	cin >> n;
	map<int, vector<pair<int, int>>> x, y;
	for(int i = 0; i < n; i++) {
        int a, b;
        cin >> a >> b;
        x[a].push_back(make_pair(b, 0));
        y[b].push_back(make_pair(a, 0));
	}
	cin >> m;
	for(int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        x[a].push_back(make_pair(b, 1));
        y[b].push_back(make_pair(a, 1));
	}
	set<pair<int, set<int>>> oddx, oddy, evenx, eveny;
	for(auto it : x) {
        sort(all(it.s));
        set<int> t;
        for(auto i : it.s) {
            if(i.s == 1 && !t.empty()) {
                if(size(t) % 2 == 0) {
                    evenx.insert(make_pair(it.f, t));
                }else {
                    oddx.insert(make_pair(it.f, t));
                }
                t.clear();
            }else if(i.s == 0) {
                t.insert(i.f);
            }
        }
        if(!t.empty()) {
            if(size(t) % 2 == 0) {
                evenx.insert(make_pair(it.f, t));
            }else {
                oddx.insert(make_pair(it.f, t));
            }
        }
	}
	for(auto it : y) {
        sort(all(it.s));
        set<int> t;
        for(auto i : it.s) {
            if(i.s == 1 && !t.empty()) {
                if(size(t) % 2 == 0) {
                    eveny.insert(make_pair(it.f, t));
                }else {
                    oddy.insert(make_pair(it.f, t));
                }
                t.clear();
            }else if(i.s == 0) {
                t.insert(i.f);
            }
        }
        if(!t.empty()) {
            if(size(t) % 2 == 0) {
                eveny.insert(make_pair(it.f, t));
            }else {
                oddy.insert(make_pair(it.f, t));
            }
        }
	}
	vector<int> anst, ansx, ansy;
    while(!oddx.empty() || !oddy.empty() || !evenx.empty() || !eveny.empty()) {
        /*cout << "evenx:\n";
        for(auto it : evenx) {
            cout << it.f << "\n";
            for(int i : it.s) {
                cout << i << " ";
            }
            cout << "\n\n";
        }
        cout << "eveny:\n";
        for(auto it : eveny) {
            cout << it.f << "\n";
            for(int i : it.s) {
                cout << i << " ";
            }
            cout << "\n\n";
        }
        cout << "oddx:\n";
        for(auto it : oddx) {
            cout << it.f << "\n";
            for(int i : it.s) {
                cout << i << " ";
            }
            cout << "\n\n";
        }
        cout << "oddy:\n";
        for(auto it : oddy) {
            cout << it.f << "\n";
            for(int i : it.s) {
                cout << i << " ";
            }
            cout << "\n\n";
        }*/
        if(!evenx.empty()) {
            auto p = *evenx.begin();
            evenx.erase(evenx.begin());
            for(int i : p.s) {
                set<int> temp;
                temp.insert(p.f);
                temp.insert(1500000000);
                auto it = oddy.upper_bound(make_pair(i, temp));
                if(it != oddy.begin()) {
                    it = --it;
                    auto t = *it;
                if(t.f == i && *t.s.begin() <= p.f && *t.s.rbegin() >= p.f) {
                    oddy.erase(it);
                    t.s.erase(p.f);
                    if(!t.s.empty()) {
                        eveny.insert(t);
                    }
                }else {
                    it = eveny.upper_bound(make_pair(i, temp));
                    if(it != eveny.begin()) {
                        it = --it;
                    }else {
                        continue;
                    }
                    t = *it;
                    if(t.f == i && *t.s.begin() <= p.f && *t.s.rbegin() >= p.f) {
                        eveny.erase(it);
                        t.s.erase(p.f);
                        oddy.insert(t);
                    }else {
                        continue;
                    }
                }
                }else {
                    it = eveny.upper_bound(make_pair(i, temp));
                    if(it != eveny.begin()) {
                        it = --it;
                    }else {
                        continue;
                    }
                    auto t = *it;
                    if(t.f == i && *t.s.begin() <= p.f && *t.s.rbegin() >= p.f) {
                        eveny.erase(it);
                        t.s.erase(p.f);
                        oddy.insert(t);
                    }else {
                        continue;
                    }
                }

            }
            int pos = ((size(p.s) + 1) / 2 - 1);
            auto it1 = p.s.begin();
            for(int i = 0; i < pos; i++) {
                ++it1;
            }
            for(int i = 0; i < (size(p.s) + 1) / 2; i++) {
                anst.push_back(1);
                ansx.push_back(p.f);
                ansy.push_back(*it1 + 1);
            }
        }else if(!eveny.empty()) {
            auto p = *eveny.begin();
            eveny.erase(eveny.begin());
            for(int i : p.s) {
                set<int> temp;
                temp.insert(p.f);
                temp.insert(1500000000);
                auto it = oddx.upper_bound(make_pair(i, temp));
                if(it != oddx.begin()) {
                    it = --it;
                    auto t = *it;
                if(t.f == i && *t.s.begin() <= p.f && *t.s.rbegin() >= p.f) {
                    oddx.erase(it);
                    t.s.erase(p.f);
                    if(!t.s.empty()) {
                        evenx.insert(t);
                    }
                }else {
                    it = evenx.upper_bound(make_pair(i, temp));
                    if(it != evenx.begin()) {
                        it = --it;
                    }else {
                        continue;
                    }
                    t = *it;
                    if(t.f == i && *t.s.begin() <= p.f && *t.s.rbegin() >= p.f) {
                        evenx.erase(it);
                        t.s.erase(p.f);
                        oddx.insert(t);
                    }else {
                        continue;
                    }
                }
                }else {
                    it = evenx.upper_bound(make_pair(i, temp));
                    if(it != evenx.begin()) {
                        it = --it;
                    }else {
                        continue;
                    }
                    auto t = *it;
                    if(t.f == i && *t.s.begin() <= p.f && *t.s.rbegin() >= p.f) {
                        evenx.erase(it);
                        t.s.erase(p.f);
                        oddx.insert(t);
                    }else {
                        continue;
                    }
                }

            }
            int pos = ((size(p.s) + 1) / 2 - 1);
            auto it1 = p.s.begin();
            for(int i = 0; i < pos; i++) {
                ++it1;
            }
            for(int i = 0; i < (size(p.s) + 1) / 2; i++) {
                anst.push_back(1);
                ansy.push_back(p.f);
                ansx.push_back(*it1 + 1);
            }
        }else if(!oddx.empty()) {
            auto p = *oddx.begin();
            oddx.erase(oddx.begin());
            for(int i : p.s) {
                set<int> temp;
                temp.insert(p.f);
                temp.insert(1500000000);
                auto it = oddy.upper_bound(make_pair(i, temp));
                if(it != oddy.begin()) {
                    it = --it;
                    auto t = *it;
                if(t.f == i && *t.s.begin() <= p.f && *t.s.rbegin() >= p.f) {
                    oddy.erase(it);
                    t.s.erase(p.f);
                    if(!t.s.empty()) {
                        eveny.insert(t);
                    }
                }else {
                    it = eveny.upper_bound(make_pair(i, temp));
                    if(it != eveny.begin()) {
                        it = --it;
                    }else {
                        continue;
                    }
                    t = *it;
                    if(t.f == i && *t.s.begin() <= p.f && *t.s.rbegin() >= p.f) {
                        eveny.erase(it);
                        t.s.erase(p.f);
                        oddy.insert(t);
                    }else {
                        continue;
                    }
                }
                }else {
                    it = eveny.upper_bound(make_pair(i, temp));
                    if(it != eveny.begin()) {
                        it = --it;
                    }else {
                        continue;
                    }
                    auto t = *it;
                    if(t.f == i && *t.s.begin() <= p.f && *t.s.rbegin() >= p.f) {
                        eveny.erase(it);
                        t.s.erase(p.f);
                        oddy.insert(t);
                    }else {
                        continue;
                    }
                }

            }
            int pos = ((size(p.s) + 1) / 2 - 1);
            auto it1 = p.s.begin();
            for(int i = 0; i < pos; i++) {
                ++it1;
            }
            for(int i = 0; i < (size(p.s) + 1) / 2; i++) {
                anst.push_back(1);
                ansx.push_back(p.f);
                ansy.push_back(*it1 + 1);
            }
        }else {
            auto p = *oddy.begin();
            oddy.erase(oddy.begin());
            for(int i : p.s) {
                set<int> temp;
                temp.insert(p.f);
                temp.insert(1500000000);
                auto it = oddx.upper_bound(make_pair(i, temp));
                if(it != oddx.begin()) {
                    it = --it;
                    auto t = *it;
                if(t.f == i && *t.s.begin() <= p.f && *t.s.rbegin() >= p.f) {
                    oddx.erase(it);
                    t.s.erase(p.f);
                    if(!t.s.empty()) {
                        evenx.insert(t);
                    }
                }else {
                    it = evenx.upper_bound(make_pair(i, temp));
                    if(it != evenx.begin()) {
                        it = --it;
                    }else {
                        continue;
                    }
                    t = *it;
                    if(t.f == i && *t.s.begin() <= p.f && *t.s.rbegin() >= p.f) {
                        evenx.erase(it);
                        t.s.erase(p.f);
                        oddx.insert(t);
                    }else {
                        continue;
                    }
                }
                }else {
                    it = evenx.upper_bound(make_pair(i, temp));
                    if(it != evenx.begin()) {
                        it = --it;
                    }else {
                        continue;
                    }
                    auto t = *it;
                    if(t.f == i && *t.s.begin() <= p.f && *t.s.rbegin() >= p.f) {
                        evenx.erase(it);
                        t.s.erase(p.f);
                        oddx.insert(t);
                    }else {
                        continue;
                    }
                }

            }
            int pos = ((size(p.s) + 1) / 2 - 1);
            auto it1 = p.s.begin();
            for(int i = 0; i < pos; i++) {
                ++it1;
            }
            for(int i = 0; i < (size(p.s) + 1) / 2; i++) {
                anst.push_back(1);
                ansy.push_back(p.f);
                ansx.push_back(*it1 + 1);
            }
        }
    }
    cout << size(anst) << "\n";
    for(int i = 0; i < size(anst); i++) {
        cout << anst[i] << " " << ansx[i] << " " << ansy[i] << "\n";
    }
}

int main() {
	io();
	solve();
	return 0;
}
