#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) (x).begin(), (x).end()
#define size(x) (int)x.size()
#define x first
#define y second
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)

ld d = clock();

mt19937_64 gen;

const int N = 1e4;
int f[2][N];

void R(int &x) {
  x = 0;
  int st = 0;
  char c;
  while (1) {
    c = getchar();
    if ('0' <= c && c <= '9') {
      x = x * 10 + (c - '0');
      st = 1;
    } else if (st) break;
  }
}

int used[N];
int a[N], b[N];
int res[N];

void run() {
  int n;
  vector<int> xs;
  cin >> n;
  const int inf = 1e9;
  for(int i = 0; i < 2 * n; i++) {
    cin >> a[i] >> b[i];
    xs.push_back(a[i]);
    xs.push_back(b[i]);
  }
  sort(all(xs));
  xs.resize(unique(all(xs)) - xs.begin());
  vector<vector<int>> s(N);
  for(int i = 0; i < 2 * n; i++) {
    a[i] = lower_bound(all(xs), a[i]) - xs.begin();
    b[i] = lower_bound(all(xs), b[i]) - xs.begin();
    assert(a[i] < N);
    s[a[i]].push_back(i);
  }
  vector<pair<int, int>> ord;
  for(int i = 0; i < N; i++) {
    if (size(s[i]))
      ord.emplace_back(size(s[i]), i);
  }
  sort(all(ord));
  while ((clock() - d) / CLOCKS_PER_SEC <= 2.7) {
    fill(used, used + N, 0);
    fill(res, res + N, -1);
    int fl = 1;
    for(auto v : ord) {
      shuffle(all(s[v.y]), gen);
      for(int x : s[v.y]) {
        if (res[x >> 1] != -1) continue;
        if (!used[v.y]) {
            res[x >> 1] = (x & 1);
            used[v.y] = 1;
        }
        else {
          if (used[a[x ^ 1]]) {
            fl = 0;
            break;
          } else {
            res[x >> 1] = ((x ^ 1) & 1);
            used[a[x ^ 1]] = 1;
          }
        }
      }
      if (!fl) break;
    }
    for(int i = 0; i < n && fl; i++) {
      if (res[i] == -1) {
        fl = 0;
      }
    }
    if (fl) {
      cout << "Yes\n";
      for(int i = 0; i < n; i++) {
        cout << res[i] + 1 << ' ';
      }
      return;
    }
  }
  cout << "No\n";
}

signed main()
{
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  gen.seed(12 * 21);
#else
  gen.seed(time(0));
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  cout << fixed << setprecision(16);
  run();
}
