#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define all(x) (x).begin(), (x).end()
#define size(x) (int)x.size()
#define x first
#define y second
#define chkmin(x, y) x = min(x, y)
#define chkmax(x, y) x = max(x, y)
#define pb emplace_back
mt19937_64 gen;

const int N = 10005;
int x[2 * N], y[2 * N];
struct inf {
  int type, l, r, ln;
};

inf mat[N][N];
vector<int> g[N];

void Do(vector<int> &x, int t, int y) {
  for(int i = 0; i < size(x); i++) {
    for(int j = 0; j < size(x); j++) {
      if (i != j) {
        g[x[i]].pb(x[j]);
        if (i < j)
          mat[x[i]][x[j]] = {t, i + 1, j - 1, y};
        else
          mat[x[i]][x[j]] = {t, j + 1, i - 1, y};
      }
    }
  }
}

void work(vector<pair<int, int>> &s, int t, int y) {
  sort(all(s));
  vector<int> cur;
  for(auto v : s) {
    if (v.y == -1) {
      Do(cur, t, y);
      cur.clear();
    } else cur.pb(v.y);
  }
  Do(cur, t, y);
}

int p[N];
int used[N], k = 1;
int fle = 0;
int pe;

bool dfs(int v) {
  if (used[v] == k) return 0;
  used[v] = k;
  for(int to : g[v]) {
    if (p[to] == -1 && used[to] != k) {
      p[to] = v;
      p[v] = to;
      return 1;
    }
  }
  for(int to : g[v]) {
    if (dfs(p[to])) {
      assert(p[p[to]] == p[to]);
      p[to] = v;
      p[v] = to;
      return 1;
    }
  }
  return 0;
}

vector<int> gege[N];
vector<int> ord;

void doTopsort(int v){
  used[v] = 1;
  for(int to : gege[v]) {
    if (!used[to])
      doTopsort(to);
  }
  ord.pb(v);
}



void run() {
  int m;
  cin >> m;
  unordered_map<int, vector<pair<int, int>>> hor, ver;
  for(int i = 0; i < m; i++) {
    cin >> x[i] >> y[i];
    hor[x[i]].pb(y[i], i);
    ver[y[i]].pb(x[i], i);
  }
  int n;
  cin >> n;
  for(int i = 0; i < n; i++) {
    int a, b;
    cin >> a >> b;
    hor[a].pb(b, -1);
    ver[b].pb(a, -1);
  }
  for(auto v : hor) work(v.y, 0, v.x);
  for(auto v : ver) work(v.y, 1, v.x);
  fill(p, p + N, -1);
  int re = 0;
  fill(used, used + N, 0);
  for(int q = 0; q < 100; q++) {
    int run = 0;
    k++;
    for(int i = 0; i < m; i++) {
      if (p[i] == -1) {
        if (dfs(i)) {
          run = 1;
          re++;
        }
      }
    }

  }
  int b = 0;
  vector<pair<int, pii>> res;
  for(int i = 0; i < m; i++) {
    if (p[i] != -1 && i < p[i]) {
      inf te = mat[i][p[i]];
      if (te.l > te.r) swap(te.l, te.r);
      assert(te.l >= 0);
      int c = i;
      if (te.type == 0) {
        for(int i = te.l; i <= te.r; i++) {
          assert(i < size(hor[te.ln]));
          pii to = hor[te.ln][i];
          if (p[to.y] != -1) {
            gege[c].pb(min(to.y, p[to.y]));
          }
        }

      } else {
        for(int i = te.l; i <= te.r; i++) {
          assert(i < size(ver[te.ln][i]));
          pii to = ver[te.ln][i];
          if (p[to.y] != -1) {
            gege[c].pb(min(to.y, p[to.y]));
          }
        }
      }
    }
  }
  fill(used, used + N, 0);
  for(int i = 0; i < m; i++) {
    if (p[i] != -1 && i < p[i] && !used[i]) {
      doTopsort(i);
    }
  }
  for(int i = 0; i < m; i++) {
    if (p[i] == -1) {
      res.push_back({1, {x[i], y[i] + 1}});
    }
  }
  for(int t : ord) {
    if (x[t] == x[p[t]]) {
      if (y[t] < y[p[t]]) {
        res.push_back({1, {x[t], y[t] + 1}});
      } else {
        res.push_back({1, {x[t], y[t] - 1}});
      }
    } else {
      if (x[t] < x[p[t]]) {
        res.push_back({0, {x[t] + 1, y[t]}});
      } else {
        res.push_back({0, {x[t] - 1, y[t]}});
      }
    }
  }
  cout << size(res) << '\n';
  for(auto v : res) {
    cout << v.x << ' ' << v.y.x << ' ' << v.y.y << '\n';
  }
}

signed main()
{
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
  gen.seed(12 * 21);
#else
  gen.seed(time(0));
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
  cout << fixed << setprecision(16);
  run();
}
