#include <bits/stdc++.h>

using namespace std;

#define ll int
#define ld long double

#pragma GCC optimize("Ofast")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")

ll INF = (ll) 1e20;
ll mod = 1e9 + 7;

mt19937 gen(time(0));

vector <pair <ll, pair <ll, ll>>> perebor(vector <pair <ll, ll>> v, vector  <pair <ll, ll>> &rc, vector <bool> alive, vector <vector <bool>> &dos) {
    ll n = v.size();
    ll m = rc.size();
    pair <ll, vector <pair <ll, pair <ll, ll>>>> minim = {INF, {}};
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j) {
            if(alive[i] && alive[j] && i != j) {
                alive[i] = false;
                alive[j] = false;
                vector <pair <ll, pair <ll, ll>>> vc = perebor(v, rc, alive, dos);
                bool ok = false;
                if(v[i].first == v[j].first) {
                        ok = true;
                for(int k = 0; k < m; ++k) {
                    if(rc[k].first == v[i].first && rc[k].second > min(v[i].second, v[j].second) && rc[k].second < max(v[i].second, v[j].second)) {
                        ok = false;
                    }
                }
                for(int k = 0; k < n; ++k) {
                    if(!alive[k])
                        continue;
                    if(v[k].first == v[i].first && v[k].second > min(v[i].second, v[j].second) &&  v[k].second < max(v[i].second, v[j].second)) {
                        ok = false;
                    }
                }
                }
                if(v[i].second == v[j].second) {
                    ok = true;
                for(int k = 0; k < m; ++k) {
                    if(rc[k].second == v[i].second && rc[k].first > min(v[i].first, v[j].first) && rc[k].first < max(v[i].first, v[j].first)) {
                        ok = false;
                    }
                for(int k = 0; k < n; ++k) {
                    if(!alive[k])
                        continue;
                    if(v[k].first == v[i].first && v[k].second > min(v[i].second, v[j].second) &&  v[k].second < max(v[i].second, v[j].second)) {
                        ok = false;
                    }
                }
                }
                }
                if(ok) {
                    if(v[i].first == v[j].first) {

                        vc.push_back({1, {v[i].first, min(v[i].second, v[j].second) + 1}});
                }
                else if(v[i].second == v[j].second) {
                            vc.push_back({0, {min(v[i].first, v[j].first) + 1, v[i].second}});
                }
                }
                if(!ok){
                    vc.push_back({1, {v[i].first, v[i].second + 1}});
                    vc.push_back({1, {v[i].first, v[j].second + 1}});
                }
                minim = min(minim, {vc.size(), vc});
                alive[i] = true;
                alive[j] = true;
            }
        }
    }
    return minim.second;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    vector <pair <ll, ll>> v(n);
    for(int i = 0; i <n ; ++i) {
        cin >> v[i].first >> v[i].second;
    }
    ll m;
    cin >> m;
    vector <pair <ll, ll>> rc(m);
    for(int i = 0; i < m; ++i) {
        cin >> rc[i].first >> rc[i].second;
    }
    vector <vector <bool>> dos(n);
    for(int i = 0; i < n; ++i) {
        dos[i].resize(n);
        for(int j = 0; j < n; ++j) {
            dos[i][j] = false;
        }
    }
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j) {
            if(i == j)
                continue;
            if(v[i].first == v[j].first) {
                    bool ok = true;
                for(int k = 0; k < m; ++k) {
                    if(rc[i].first == v[i].first && rc[i].second > min(v[i].second, v[j].second) && rc[i].second < max(v[i].second, v[j].second)) {
                        ok = false;
                    }
                }
            if(ok) {
                dos[i][j] = true;
            }
            }
            else if(v[i].second == v[j].second) {
                    bool ok = true;
                for(int k = 0; k < m; ++k) {
                    if(rc[i].second == v[i].second && rc[i].first > min(v[i].first, v[j].first) && rc[i].first < max(v[i].first, v[j].first)) {
                        ok = false;
                    }
                }
            if(ok) {
                dos[i][j] = true;
            }
            }
        }
    }
    vector <bool> alive(n, true);
    vector <pair <ll, pair <ll, ll>>> ans = perebor(v, rc, alive, dos);
    cout << ans.size() << '\n';
    for(int i = 0; i < ans.size(); ++i) {
        cout << ans[i].first << ' ' << ans[i].second.first << ' ' << ans[i].second.second << '\n';
    }
}
/*
4
2 1
1 2
2 4
3 2
1
2 3


4
1 2
1 4
3 2
3 4
0


4
1 2
1 5
3 5
5 5
0



10
21 22 33 35
16 18 26 27
9 10 14 23
0 1 15 34
12 17 19 32
4 28 30 38
5 6 13 31
2 3 20 37
24 25 29 36
7 8 11 39

*/
