#include <iostream>
#include <cstdio>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <deque>
#include <queue>
#include <cmath>
#include <cstring>
#include <cassert>
#include <string>
#include <random>
#include <bitset>
#include <algorithm>
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).end()
#define rep(i, n) for (int i = 0; i < (n); i++)

using namespace std;
using ll = long long;
using ld = long double;
using ul = unsigned long long;

const int N = 400001;
int x[N], y[N], used[N * 2], cc;
vector<pair<int, int>> bx[N], by[N];
vector<vector<int>> ans;
vector<int> g[N * 2];
vector<int> lx, ly, rx, ry;

int lb(vector<int> &l, int q) {
	return lower_bound(all(l), q) - l.begin();
}

void pr(int v) {
	if (v == -1)
		cout << "-1 ";
	else if (v < rx.size())
		cout << 0 << ' ' << rx[v] << ' ';
	else
		cout << 1 << ' ' << ry[v - rx.size()] << ' ';
}

void add(int v1, int v2, int v3) {
	if (v2 < rx.size())
		ans.push_back({1, rx[v2], ry[v1 - rx.size()] + 1});
	else
		ans.push_back({0, rx[v1] + 1, ry[v2 - rx.size()]});
}

int dfs(int v, int p) {
	cc++;
	used[v] = 1;
	vector<int> li;
	for (int u : g[v]) {
		if (u == p)
			continue;
		if (used[u])
			li.push_back(u);
		else if (dfs(u, v))
			li.push_back(u);
	}
	int res = 1;
	if (li.size() % 2) {
		res = 0;
		if (p == -1)
			li.push_back(N);
		else
			li.push_back(p);
	}
	sort(all(li));
	for (int i = 0; i < li.size(); i += 2) {
		if (v < rx.size())
			ans.push_back({1, rx[v], ry[li[i] - rx.size()] + 1});
		else
			ans.push_back({0, rx[li[i]] + 1, ry[v - rx.size()]});
	}
	//cout << li.size() << ' ' << res << "!\n";
	return res;
}

int main() {
#ifdef ONPC
	freopen("in", "r", stdin);
#endif
	ios_base::sync_with_stdio(false); cin.tie(0);
	int n, m, cx, cy, px, py;
	cin >> n;
	rep(i, n) {
		cin >> x[i] >> y[i];
		lx.push_back(x[i]);
		ly.push_back(y[i]);
	}
	sort(all(lx));
	lx.resize(unique(all(lx)) - lx.begin());
	sort(all(ly));
	ly.resize(unique(all(ly)) - ly.begin());
	cin >> m;
	rep(i, n) {
		x[i] = lb(lx, x[i]);
		y[i] = lb(ly, y[i]);
		bx[x[i]].push_back({y[i], i});
		by[y[i]].push_back({x[i], i});
	}
	rep(i, m) {
		cin >> cx >> cy;
		px = lb(lx, cx);
		py = lb(ly, cy);
		if (px < lx.size() && lx[px] == cx)
			bx[px].push_back({py, -1});
		if (py < ly.size() && ly[py] == cy)
			by[py].push_back({px, -1});
	}
	rep(i, lx.size()) {
		sort(all(bx[i]));
		int cf = 1;
		for (auto &pp : bx[i]) {
			if (pp.second == -1)
				cf = 1;
			else {
				if (cf)
					rx.push_back(lx[i]);
				x[pp.second] = (int) rx.size() - 1;
				cf = 0;
			}
		}
	}
	rep(i, ly.size()) {
		sort(all(by[i]));
		int cf = 1;
		for (auto &pp : by[i]) {
			if (pp.second == -1)
				cf = 1;
			else {
				if (cf)
					ry.push_back(ly[i]);
				y[pp.second] = (int) ry.size() - 1;
				cf = 0;
			}
		}
	}
	rep(i, n) {
		g[x[i]].push_back(rx.size() + y[i]);
		g[rx.size() + y[i]].push_back(x[i]);
	}
	int res = n;
	rep(i, rx.size() + ry.size())
		if (!used[i]) {
			dfs(i, -1);
		}
	cout << ans.size() << '\n';
	for (auto &pp : ans)
		cout << pp[0] << ' ' << pp[1] << ' ' << pp[2] << '\n';
}

