#include <iostream>
#include <cstdio>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <vector>
#include <deque>
#include <queue>
#include <cmath>
#include <cstring>
#include <cassert>
#include <string>
#include <random>
#include <bitset>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).end()
#define rep(i, n) for (int i = 0; i < (n); i++)
#define gc getchar_unlocked
using namespace std;
using ll = long long;
using ld = long double;
using ul = unsigned long long;

const int N = 400003;
int x[N], y[N], used[N * 2], vis[N * 2], cc;
vector<pair<int, int>> bx[N], by[N];
vector<vector<int>> ans;
vector<int> g[N * 2], tg[N * 2];
vector<int> lx, ly, rx, ry, ord, c;

char ch;
void ri(int &x) {
	ch = gc();
	while (ch < '0' || ch > '9')
		ch = gc();
	x = 0;
	while ('0' <= ch && ch <= '9') {
		x = x * 10 + ch - '0';
		ch = gc();
	}
}

int lb(vector<int> &l, int q) {
	return lower_bound(all(l), q) - l.begin();
}

int dfs(int v, int p) {
	cc++;
	used[v] = 1;
	vector<int> li;
	for (int u : g[v]) {
		if (u == p)
			continue;
		if (used[u] == 1)
			li.push_back(u);
		else if (!used[u] && dfs(u, v))
			li.push_back(u);
	}
	int res = 1;
	if (li.size() % 2) {
		res = 0;
		if (p == -1)
			li.push_back(N);
		else
			li.push_back(p);
	}
	sort(all(li));
	for (int i = 0; i < li.size(); i += 2) {
//		cout << v << ' ' << li[i] << ' ' << li[i + 1] << "!\n";
		ans.push_back({v, li[i], li[i + 1]});
		/*if (v < rx.size())
			ans.push_back({v
		else
			ans.push_back({0, rx[li[i]] + 1, ry[v - rx.size()]});*/
	}
	//cout << li.size() << ' ' << res << "!\n";
	used[v] = 2;
	return res;
}

int dfs2(int v) {
	vis[v] = 1;
	for (int u : tg[v]) {
		if (vis[u] == 1 || !vis[u] && dfs2(u))
			return 1;
	}
	ord.push_back(v);
	vis[v] = 2;
	return 0;
}

int main() {
#ifdef ONPC
	freopen("in", "r", stdin);
#endif
	int n, m, cx, cy, px, py;
	ri(n);
	rep(i, n) {
		ri(x[i]);
		ri(y[i]);
		lx.push_back(x[i]);
		ly.push_back(y[i]);
	}
	sort(all(lx));
	lx.resize(unique(all(lx)) - lx.begin());
	sort(all(ly));
	ly.resize(unique(all(ly)) - ly.begin());
	ri(m);
	rep(i, n) {
		x[i] = lb(lx, x[i]);
		y[i] = lb(ly, y[i]);
		bx[x[i]].push_back({y[i], i});
		by[y[i]].push_back({x[i], i});
	}
	rep(i, m) {
		ri(cx);
		ri(cy);
		px = lb(lx, cx);
		py = lb(ly, cy);
		if (px < lx.size() && lx[px] == cx)
			bx[px].push_back({py, -1});
		if (py < ly.size() && ly[py] == cy)
			by[py].push_back({px, -1});
	}
	rep(i, lx.size()) {
		sort(all(bx[i]));
		int cf = 1;
		for (auto &pp : bx[i]) {
			if (pp.second == -1)
				cf = 1;
			else {
				if (cf)
					rx.push_back(lx[i]);
				x[pp.second] = (int) rx.size() - 1;
				cf = 0;
			}
		}
	}
	rep(i, ly.size()) {
		sort(all(by[i]));
		int cf = 1;
		for (auto &pp : by[i]) {
			if (pp.second == -1)
				cf = 1;
			else {
				if (cf)
					ry.push_back(ly[i]);
				y[pp.second] = (int) ry.size() - 1;
				cf = 0;
			}
		}
	}
	rep(i, n) {
		g[x[i]].push_back(rx.size() + y[i]);
		g[rx.size() + y[i]].push_back(x[i]);
	}
	int res = n;
	rep(i, rx.size() + ry.size())
		if (!used[i]) {
			dfs(i, -1);
		}
	gp_hash_table<int, vector<pair<int, int>>> m1;
	rep(i, ans.size()) {
		m1[ans[i][1]].push_back({ans[i][0], i});
		m1[ans[i][2]].push_back({ans[i][0], i});
	}
	for (auto &pp : m1)
		sort(all(pp.second));
	rep(i, ans.size()) {
		auto pp = ans[i];
		if (m1.find(pp[0]) == m1.end())
			continue;
		auto &v1 = m1[pp[0]];
		int pos = lower_bound(all(v1), make_pair(pp[1], -1)) - v1.begin();
		for (int j = pos; j < v1.size() && v1[j].first < pp[2]; j++)
			tg[i].push_back(v1[j].second);
	}
	/*rep(i, ans.size())
		rep(j, ans.size()) {
			if (i == j)
				continue;
			if (ans[i][0] < rx.size() && ans[j][0] >= rx.size() && (ans[i][1] == ans[j][0] || ans[i][2] == ans[j][0]) && ans[j][1] < ans[i][0] && ans[i][0] < ans[j][2] ||
					ans[i][0] >= rx.size() && ans[j][0] < rx.size() && (ans[i][1] == ans[j][0] || ans[i][2] == ans[j][0]) && ans[j][1] < ans[i][0] && ans[i][0] < ans[j][2]) {
				//cout << i << ' ' << j << "!\n";
				tg[j].push_back(i);
			}
		}*/
	rep(i, ans.size())
		if (!vis[i] && dfs2(i))
			assert(false);
	ios_base::sync_with_stdio(false); cin.tie(0);
	cout << ans.size() << '\n';
	for (int i : ord) {
		auto pp = ans[i];
		if (pp[0] < rx.size())
			cout << "1 " << rx[pp[0]] << ' ' << ry[pp[1] - rx.size()] + 1 << '\n';
		else
			cout << "0 " <<  rx[pp[1]] + 1 << ' ' << ry[pp[0] - rx.size()] << '\n';
	}
}

