#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define FAST_IO ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)
#define f first
#define s second
using ull = unsigned long long;

void solve(ll need, ll c_left) {
    // if (need != 7) return;
    // cout << "solve " << need << ' ' << c_left << endl;
    ll tar = 0;
    if (need % 2 == 0) {
        rep(i, need) {
            if (i & 1) {
                tar |= (1LL << i);
            }
        }
    } else {
        rep(i, need) {
            if (!(i & 1)) {
                tar |= (1LL << i);
            }
        }
    }

    ll mask = (1LL << need) - 1;

    // cout << tar << ' ' << mask << endl;

    for (int cnt = 1; cnt < 62; ++cnt) {
        ll cur = tar + cnt + c_left;
        if ((cur & mask) != cur) continue;
        if (__builtin_popcountll(cur) == cnt) {
            cout << cnt + c_left << endl;
            exit(0);
        }
    }
}

void solve_stupid(ll n) {
    ll tar = 0;
    if (n % 2 == 0) {
        rep(i, n) {
            if (i & 1) {
                tar |= (1LL << i);
            }
        }
    } else {
        rep(i, n) {
            if (!(i & 1)) {
                tar |= (1LL << i);
            }
        }
    }

    for (int cnt = 1; cnt < 62; ++cnt) {
        ll cur = tar + cnt;
        if (__builtin_popcountll(cur) == cnt) {
            cout << cnt << endl;
            return;
        }
    }

    cout << 0 << endl;
    return;
}

int main() {
    FAST_IO;
    ll n;
    cin >> n;
    if (n < 60) {
        solve_stupid(n);
        return 0;
    }

    // cout << UINT_MAX << endl;

    if (n % 2 == 0) {
        for (ll i = 1; i < 20; ++i) {
            ll c_left = n / 2 - i;
            ll need = i * 2;
            solve(need, c_left);
        }
    } else {
        for (ll i = 1; i < 20; ++i) {
            ll c_left = (n + 1) / 2 - i;
            ll need = i * 2 - 1;
            solve(need, c_left);
        }
    }

    cout << 0 << endl;
}
