#include <bits/stdc++.h>

using namespace std;

const int N = 3e5 + 7;

vector <int> g[N], rg[N];

void add_edge(int a, int b) {
	g[a].push_back(b);
	rg[b].push_back(a);
}

bool u[N], vis[N];
int comp[N];

vector <int> t;

void dfs(int v) {
	u[v] = true;
	for (int to : g[v]) {
		if (!u[to]) {
			dfs(to);
		}
	}
	t.push_back(v);
}

int sz = 0;

void rdfs(int v) {
	comp[v] = sz;
	vis[v] = true;
	for (int to : rg[v]) {
		if (!vis[to]) {
			rdfs(to);
		}
	}
}

int a[N][2], b[N][2];


int read() {
	char c = getchar_unlocked();
	while (c < '0' || c > '9') {
		c = getchar_unlocked();
	}
	int ans = 0;
	while ('0' <= c && c <= '9') {
		ans = ans * 10 + c - '0';
		c = getchar_unlocked();
	}
	return ans;
}



int main() {
#ifdef iq
	freopen("a.in", "r", stdin);
#endif
	int n = read();
	for (int i = 0; i < n; i++) {
		for (int t = 0; t < 2; t++) {
			a[i][t] = read(), b[i][t] = read();
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			for (int x = 0; x < 2; x++) {
				for (int y = 0; y < 2; y++) {
					if (i != j && max(a[i][x], a[j][y]) <= min(b[i][x], b[j][y])) {
						add_edge(i * 2 + x, j * 2 + (y ^ 1));
					}
				}
			}
		}
	}
	for (int i = 0; i < 2 * n; i++) {
		if (!u[i]) dfs(i);
	}
	reverse(t.begin(), t.end());
	for (int v : t) {
		if (!vis[v]) {
			rdfs(v);
			sz++;
		}
	}
	for (int i = 0; i < n; i++) {
		if (comp[2 * i] == comp[2 * i + 1]) {
			cout << "No\n";
			return 0;
		}
	}
	cout << "Yes\n";
	for (int i = 0; i < n; i++) {
		if (comp[2 * i] > comp[2 * i + 1]) {
			cout << 1 << '\n';
		} else {
			cout << 2 << '\n';
		}
	}
}
