#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(x.begin(), x.end(), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

struct pt {
	int x, y;
	pt(int _x, int _y): x(_x), y(_y) {}
	pt(): x(0), y(0) {}
};

int distance(const pt &a, const pt &b) {
	return abs(a.x - b.x) + abs(a.y - b.y);
}

pt middle(const pt &a, const pt &b) {
	return pt((a.x + b.x) / 2, (a.y + b.y) / 2);
}

pt adj(const pt &a) {
	return pt(a.x + 1, a.y);
}

void read(int &n, vector<pt> &a) {
	cin >> n;
	a.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i].x >> a[i].y;
	}
}

const int INF = 1e9;
const int S = (1 << 10);
int n, m, dp[S];
vector<int> go[S];
vector<pt> a, stones;

int can(int i, int j, int sub, int &type) {
	type = -1;
	if (a[i].x == a[j].x) {
		type = 1;
	}
	if (a[i].y == a[j].y) {
		type = 0;
	}
	if (type == -1) {
		return 0;
	}
	for (int x = 0; x < n; ++x) {
		if (x != i && x != j && ((sub >> x) & 1) && distance(a[i], a[x]) + distance(a[x], a[j]) == distance(a[i], a[j])) {
			return 0;
		}
	}
	for (auto pp : stones) {
		if (distance(a[i], pp) + distance(pp, a[j]) == distance(a[i], a[j])) {
			return 0;
		}
	}
	return 1;
}

int main() {
	fast_io();
	read(n, a);
	read(m, stones);

	// int tmp;
	// int res = can(0, 5, 255, tmp);
	// cerr << "res = " << res << endl;
	// exit(0);
	for (int sub = 1; sub < (1 << n); ++sub) {
		dp[sub] = INF;
		for (int i = 0; i < n; ++i) {
			if (((sub >> i) & 1) && chkmin(dp[sub], dp[sub ^ (1 << i)] + 1)) {
				go[sub] = {i};
			}
		}
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				if (((sub >> i) & 1) && ((sub >> j) & 1)) {
					int type;
					if (can(i, j, sub, type) && chkmin(dp[sub], dp[sub ^ (1 << i) ^ (1 << j)] + 1)) {
						go[sub] = {type, i, j};
					}
				}
			}
		}
	}

	int sub = (1 << n) - 1;

	vector<vector<int> > ans;
	while (sub) {
		if (go[sub].size() == 1) {
			int v = go[sub][0];
			pt pp = adj(a[v]);
			ans.push_back({0, pp.x, pp.y});
			sub ^= (1 << v);
		} else {
			pt place = middle(a[go[sub][1]], a[go[sub][2]]);
			ans.push_back({go[sub][0], place.x, place.y});
			sub ^= ((1 << go[sub][1]) ^ (1 << go[sub][2]));
		}
	}

	cout << ans.size() << endl;
	for (auto v : ans) {
		for (auto x : v) {
			cout << x << " ";
		}
		cout << endl;
	}
}
