#include "bits/stdc++.h"

#define random anotehsaontehsnaohesn
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define len(v) ((int)v.size())
#define x first
#define y second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

namespace random {
	using namespace std::chrono;
	mt19937 rng(duration_cast<milliseconds>(
		system_clock::now().time_since_epoch()).count());
	uniform_real_distribution<> prob_dist(0.0, 1.0);
};

using namespace random;

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v) is >> x;
	return is;
}

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v) os << x << " ";
	return os;
}

map<pair<ll, int>, int> mem;
int compose(ll x, int l) {
	if (mem.count(mp(x, l))) return mem[mp(x, l)];
	if (x == 0LL) return 0;
	if ((1LL << l) - 1 > x) return -1;
	int t = compose(x - (1 << l) + 1, l + 1);
	if (t != -1) return mem[mp(x, l)] = t + 1;
	t = compose(x, l + 1);
	return mem[mp(x, l)] = t;
}

void run() {
	int n;
	cin >> n;
	ll num = 0;
	for (int i = 0; i < n; i += 2) {
		num = (num | (1LL << (n - i - 1)));
	}
	int t = compose(num, 0);
	if (t == -1) {
		cout << 0 << endl; 
	} else {
		cout << t << endl;
	}
	// cout << num << endl;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
}