#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("vpt")

using namespace std;

typedef long long ll;
typedef long double ld;

const char el = '\n';
const int inf = 1000 * 1000 * 1000;
const ll llinf = 1e18, mod = 1000000007;

#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define firn(i, n) for (int i = 1; i < (int)n; ++i)
#define all(v) v.begin(), v.end()
#define x first
#define y second
#define right right228
#define left left228
#define prev prev228

template<typename T> void uax(T &a, T b) { if (b > a) a = b; }
template<typename T> void uin(T &a, T b) { if (b < a) a = b; }

mt19937 rnd(time(NULL));

const int N = 400003;
struct reb {
	int u, i;
	bool k;
	reb(int _u, int _i, bool _k) {
		u = _u; i = _i; k = _k;
	}
};
vector<reb> g1[N], g2[N], g3[N];
vector<pair<int, int>> f[N + N];
vector<int> ost[N + N];
vector<int> p, h;
void init(int n) {
	h.assign(n, 1);
	p.resize(n);
	forn(i, n) p[i] = i;
}
int getp(int a) {
	return a == p[a] ? a : p[a] = getp(p[a]);
}
void unite(int a, int b) {
	if (h[a] < h[b]) swap(a, b);
	p[b] = a;
	if (h[b] == h[a]) h[a]++;
}
struct ans {
	int k;
	int x, y;
};
int cnt1;
vector<ans> fir;
vector<pair<int, int>> c;
vector<int> x, y;
inline void push(int v, pair<int, int> to) {
	if (v >= cnt1) fir.push_back(ans{1, x[c[to.y].x] + 1, y[c[to.y].y]});
	else fir.push_back(ans{0, x[c[to.y].x], y[c[to.y].y] + 1});
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(NULL);
	int n, m;
	cin >> n;
	c.resize(n);
	forn(i, n) {
		cin >> c[i].x >> c[i].y;
		x.push_back(c[i].x);
		y.push_back(c[i].y);
	}
	cin >> m;
	vector<pair<int, int>> s(m);
	forn(i, m) {
		cin >> s[i].x >> s[i].y;
		x.push_back(s[i].x);
		y.push_back(s[i].y);
	}
	sort(all(x)); x.resize(distance(x.begin(), unique(all(x))));
	sort(all(y)); y.resize(distance(y.begin(), unique(all(y))));
	forn(i, n) {
		// cout << c[i].x << ' ' << c[i].y << el;
		c[i].x = lower_bound(all(x), c[i].x) - x.begin();
		c[i].y = lower_bound(all(y), c[i].y) - y.begin();
		// cout << c[i].x << ' ' << c[i].y << el;
		g1[c[i].x].emplace_back(c[i].y, i, 0);
	}
	forn(i, m) {
		s[i].x = lower_bound(all(x), s[i].x) - x.begin();
		s[i].y = lower_bound(all(y), s[i].y) - y.begin();
		// cout << s[i].x << ' ' << s[i].y << el;
		g1[s[i].x].emplace_back(s[i].y, i, 1);
	}
	vector<int> a(n), b(n);
	forn(i, x.size()) {
		for (auto to : g1[i]) {
			g2[to.u].emplace_back(i, to.i, to.k);
		}
	}
	forn(i, y.size()) {
		for (auto to : g2[i]) {
			g3[to.u].emplace_back(i, to.i, to.k);
		}
	}
	int cnt = 0;
	forn(i, x.size()) {
		int tmp = 0;
		for (auto to : g3[i]) {
			if (to.k == 0) {
				tmp++;
				a[to.i] = cnt;
			}
			else if (tmp > 0) {
				tmp = 0;
				cnt++;
			}
		}
		if (tmp > 0) cnt++;
	}
	cnt1 = cnt;
	forn(i, y.size()) {
		int tmp = 0;
		for (auto to : g2[i]) {
			if (to.k == 0) {
				tmp++;
				b[to.i] = cnt;
			}
			else if (tmp > 0) {
				tmp = 0;
				cnt++;
			}
		}
		if (tmp > 0) cnt++;
	}
	init(cnt);
	forn(i, n) {
		// f[a[i]].emplace_back(b[i], i);
		// f[b[i]].emplace_back(a[i], i);
		// cout << a[i] << ' ' << b[i] << el;
		int v = getp(a[i]), u = getp(b[i]);
		if (v != u) {
			ost[a[i]].push_back(b[i]);
			ost[b[i]].push_back(a[i]);
			unite(v, u);
		}
	}
	forn(i, x.size()) {
		for (auto to : g3[i]) {
			if (to.k) continue;
			f[a[to.i]].emplace_back(b[to.i], to.i);
		}
	}
	forn(i, y.size()) {
		for (auto to : g2[i]) {
			if (to.k) continue;
			f[b[to.i]].emplace_back(a[to.i], to.i);
		}
	}
	forn(i, cnt) {
		// f[i].resize(distance(f[i].begin(), unique(all(f[i]))));
		// for (auto to : f[i])
		// 	cout << i << ' ' << to.x << ' ' << to.y << el;
	}
	vector<char> used(n, 0), usedv(cnt, 0);
	vector<int> st(cnt), q;
	vector<ans> sec;
	forn(i, cnt) {
		st[i] = (int)ost[i].size();
		if (st[i] == 1) q.push_back(i);
	}
	vector<int> r(cnt);
	vector<pair<int, int>> tmp;
	forn(i, q.size()) {
		int v = q[i];
		if (usedv[v]) continue;
		// cout << v << ' ';
		// cout << (int)fir.size() + (int)sec.size() << ' ';
		tmp.clear();
		tmp.reserve(f[v].size());
		for (auto to : f[v]) {
			if (!used[to.y]) tmp.push_back(to);
		}
		// cout << (int)tmp.size() << el;
		if (!((int)tmp.size() & 1)) {
			for (int i = 0; i < (int)tmp.size(); i += 2) {
				push(v, tmp[i]);
				used[tmp[i].y] = used[tmp[i + 1].y] = 1;
			}
		}
		else {
			int sum = 0;
			for (auto to : tmp) sum += (int)usedv[to.x];
			if (sum == (int)tmp.size()) {
				for (int i = 0; i < (int)tmp.size(); i += 2) {
					push(v, tmp[i]);
					used[tmp[i].y] = 1;
					if (i < (int)tmp.size() - 1) used[tmp[i + 1].y] = 1;
				}
			}
			else {
				forn(i, tmp.size()) {
					if (usedv[tmp[i].x]) continue;
					for (int j = 0; j + 1 < i; j += 2) {
						push(v, tmp[j]);
						used[tmp[j].y] = used[tmp[j + 1].y] = 1;
					}
					int j = i + 1;
					if (i & 1) {
						if (v >= cnt1) sec.push_back(ans{1, x[c[tmp[i - 1].y].x] + 1, y[c[tmp[i - 1].y].y]});
						else sec.push_back(ans{0, x[c[tmp[i - 1].y].x], y[c[tmp[i - 1].y].y] + 1});
						used[tmp[i - 1].y] = used[tmp[i + 1].y] = 1;
						j++;
					}
					for (; j < (int)tmp.size(); j += 2) {
						push(v, tmp[j]);
						used[tmp[j].y] = used[tmp[j + 1].y] = 1;
					}
					break;
				}
			}
		}
		for (auto to : ost[v]) {
			st[to]--;
			if (st[to] < 2 && !usedv[to]) q.push_back(to);
		}
		usedv[v] = 1;
	}
	reverse(all(sec));
	for (auto to : sec) fir.push_back(to);
	cout << (int)fir.size() << el;
	for (auto to : fir) cout << to.k << ' ' << to.x << ' ' << to.y << el;
	return 0;
}