#include <bits/stdc++.h>

using namespace std;
template<class T1, class T2> inline void chkmin(T1 &x, const T2 &y) {x = (x > y ? y: x);}
template<class T1, class T2> inline void chkmax(T1 &x, const T2 &y) {x = (x < y ? y: x);}
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
#define left left228
#define right right228
#define rank rank228
#define y1 y1227
using ll = long long;
using ld = long double;


char readChar() {
	char c = getchar_unlocked();
	while (c <= 32) {
		c = getchar_unlocked();
	}
	return c;
}


int readInt() {
	char c = readChar();
	int sign = 0;
	if (c == '-') {
		sign = true;
		c = getchar_unlocked();
	}
	int res = 0;
	while (c >= '0' && c <= '9') {
		res = ((res << 3) + (res << 1)) + c - '0';
		c = getchar_unlocked();
	}
	return (sign ? -res: res);
}
const int MAXN = 200228;


int n;
int la[MAXN], ra[MAXN];
int uk;
vector<int> g[MAXN];
vector<int> rg[MAXN];
bool used[MAXN];
vector<int> ord;


void dfs(int u) {
	used[u] = true;
	for (auto h: g[u]) {
		if (!used[h]) {
			dfs(h);
		}
	}
	ord.pb(u);
}


int col[MAXN];

void dfs1(int u, int c) {
	used[u] = true;
	col[u] = c;
	for (auto h: rg[u]) {
		if (!used[h]) {
			dfs1(h, c);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
//	assert(freopen("input.in", "r", stdin));
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> la[i * 2] >> ra[i * 2] >> la[i * 2 + 1] >> ra[i * 2 + 1];
	}
	uk = 2 * n;
	for (int i = 0; i < 2 * n; i++) {	
		for (int j = 0; j < 2 * n; j++) {
			if (i == j) {
				continue;
			}
			if (la[j] <= la[i] && la[i] <= ra[j]) {
				g[i].pb(j ^ 1);
				rg[j ^ 1].pb(i);
				g[j].pb(i ^ 1);
				rg[i ^ 1].pb(j);
			} 
		}
	}
	for (int i = 0; i < uk; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	reverse(all(ord));
	memset(used, 0, sizeof(used));
	int c = 0;
	for (auto i: ord) {
		if (!used[i]) {
			c++;
			dfs1(i, c);
		}
	}
	for (int i = 0; i < n; i++) {
		if (col[i * 2] == col[i * 2 + 1]) {
			cout << "No\n";
			return 0;
		}
	}
	cout << "Yes\n";
	for (int i = 0; i < n; i++) {
		if (col[i * 2] > col[i * 2 + 1]) {
			cout << "1\n";
		} else {
			cout << "2\n";
		}
	}
}