#include <bits/stdc++.h>

using namespace std;
template<class T1, class T2> inline void chkmin(T1 &x, const T2 &y) {x = (x > y ? y: x);}
template<class T1, class T2> inline void chkmax(T1 &x, const T2 &y) {x = (x < y ? y: x);}
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define sz(c) (int)(c).size()
#define mp make_pair
#define pb push_back
#define left left228
#define right right228
#define rank rank228
#define y1 y1227
using ll = long long;
using ld = long double;


char readChar() {
	char c = getchar_unlocked();
	while (c <= 32) {
		c = getchar_unlocked();
	}
	return c;
}


int readInt() {
	char c = readChar();
	int sign = 0;
	if (c == '-') {
		sign = true;
		c = getchar_unlocked();
	}
	int res = 0;
	while (c >= '0' && c <= '9') {
		res = ((res << 3) + (res << 1)) + c - '0';
		c = getchar_unlocked();
	}
	return (sign ? -res: res);
}

const int MAXN = 400228;


int n, m;
int x[MAXN], y[MAXN];
map<int, vector<pair<int, int> > > whox, whoy;
int ukx, uky;
int wx[MAXN], wy[MAXN];
set<pair<int, int> > sx[MAXN], sy[MAXN];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//assert(freopen("input.in", "r", stdin));
	cin >> n;
	for (int i = 0; i < n; i++) {
		cin >> x[i] >> y[i];
		whox[x[i]].pb({y[i], i});
		whoy[y[i]].pb({x[i], i});
	}	
	cin >> m;
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		whox[x].pb({y, -1});
		whoy[y].pb({x, -1});
	}
	for (auto z: whox) {
		sort(all(z.second));
		vector<int> cur;
		for (auto cy: z.second) {
			if (cy.second != -1) {
				cur.pb(cy.second);
			} else {
				if (!cur.empty()) {
					for (auto i: cur) {
						sx[ukx].insert({y[i], i});
						wx[i] = ukx;
					}
					ukx++;
					cur.clear();
				}
			}
		}
		if (!cur.empty()) {
			for (auto i: cur) {
				sx[ukx].insert({y[i], i});
				wx[i] = ukx;
			}
			ukx++;
		}
	}
	for (auto z: whoy) {
		sort(all(z.second));
		vector<int> cur;
		for (auto cy: z.second) {
			if (cy.second != -1) {
				cur.pb(cy.second);
			} else {
				if (!cur.empty()) {
					for (auto i: cur) {
						sy[uky].insert({x[i], i});
						wy[i] = uky;
					}
					uky++;
					cur.clear();
				}
			}
		}
		if (!cur.empty()) {
			for (auto i: cur) {
				sy[uky].insert({x[i], i});
				wy[i] = uky;
			}
			uky++;
		}
	}
	vector<pair<int, pair<int, int> > > res;
	while (true) {
		bool was = false;
		pair<int, int> p;
		int opt = -1;
		int kt;
		for (int i = 0; i < ukx; i++) {
			if (!sx[i].empty()) {
				was = true;
				if (sz(sx[i]) >= 2) {
					pair<int, int> last = mp(-1, -1);
					for (auto g: sx[i]) {
						if (last.second != -1) {
							int cur = sy[wy[g.second]].size() % 2 + sy[wy[last.second]].size() % 2;
							if (cur > opt) {
								opt = cur;
								p = mp(last.second, g.second);
								kt = 0;
							}
						}
						last = g;
					}
				}
			}
		}
		if (!was) {
			break;
		}
		for (int i = 0; i < uky; i++) {
			if (!sy[i].empty()) {
				if (sz(sy[i]) >= 2) {
					pair<int, int> last = mp(-1, -1);
					for (auto g: sy[i]) {
						if (last.second != -1) {
							int cur = sx[wx[g.second]].size() % 2 + sx[wx[last.second]].size() % 2;
							if (cur > opt) {
								opt = cur;
								p = mp(last.second, g.second);
								kt = 1;
							}
						}
						last = g;
					}
				}
			}
		}
		//cout << opt << endl;
		//if (opt == -1) {
			for (int i = 0; i < ukx; i++) {
				for (auto j: sx[i]) {
					res.pb({0, {x[j.second], y[j.second] - 1}});
				}
			}
			break;   
		//}
		if (kt == 0) {
			res.pb({kt, {x[p.first], y[p.first] + 1}});
		} else {
			res.pb({kt, {x[p.first] + 1, y[p.first]}});
		}
		sx[wx[p.first]].erase({y[p.first], p.first});
		sy[wy[p.first]].erase({x[p.first], p.first});
		sx[wx[p.second]].erase({y[p.second], p.second});
		sy[wy[p.second]].erase({x[p.second], p.second});
	}
	cout << sz(res) << '\n';
	for (auto x: res) {
		cout << x.first << ' ' << x.second.first << ' ' << x.second.second << '\n';
	}
}