#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)n; ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 10;
struct point {
	int x, y;
	friend bool operator<(point a, point b) {
		if (a.x == b.x) {
			return a.y < b.y;
		}
		return a.x < b.x;
	}
};
point a[N], b[N];
int dp[1 << N];
std::pair<point, int> pred[1 << N];
int predMask[1 << N];
int main() {
	int n, m;
	std::map<point, int> kek;
	std::cin >> n;
	FOR(i, n) {
		std::cin >> a[i].x >> a[i].y;
		kek[a[i]] = i;
	}
	std::cin >> m;
	FOR(i, m) {
		std::cin >> b[i].x >> b[i].y;
	}
	memset(dp, 0x3f, sizeof(dp));
	dp[0] = 0;
	for (int i = 0; i < (1 << n); ++i) {
		std::map<int, std::vector<std::pair<int,int>>> x, y;
		FOR(j, n) {
			if (!((i >> j) & 1)) {
				x[a[j].x].pb(std::make_pair(a[j].y, 0));
				y[a[j].y].pb(std::make_pair(a[j].x, 0));
			}
		}
		FOR(j, m) {
			x[b[j].x].pb({b[j].y, 1});
			y[b[j].y].pb({b[j].x, 1});
		}
		for (auto &e : x) {
			std::sort(e.second.begin(), e.second.end());
		}
		for (auto &e : y) {
			std::sort(e.second.begin(), e.second.end());
		}	
		for (auto &e : x) {
			for (int j = 0; j < (int)e.second.size(); ++j) {
				int now = kek[{e.first, e.second[j].first}];
				if (dp[i | (1 << now)] > dp[i] + 1) {
					dp[i | (1 << now)] = dp[i] + 1;
					pred[i | (1 << now)] = {{e.first - 1, e.second[j].first}, 1};
					predMask[i | (1 << now)] = i;
				}
			}
			for (int j = 0; j < (int)e.second.size() - 1; ++j) {
				if (e.second[j + 1].second + e.second[j].second == 0) {
					int y1 = e.second[j].first, y2 = e.second[j + 1].first;
					int now1 = kek[{e.first, y1}], now2 = kek[{e.first, y2}];
					if (dp[i | (1 << now1) | (1 << now2)] > dp[i] + 1) {
						dp[i | (1 << now1) | (1 << now2)] = dp[i] + 1;
						pred[i | (1 << now1) | (1 << now2)] = {{e.first, y1 + 1}, 0};
						predMask[i | (1 << now1) | (1 << now2)] = i;
					}
				}
			}
		}
		for (auto &e : y) {
			for (int j = 0; j < (int)e.second.size() - 1; ++j) {
				if (e.second[j + 1].second + e.second[j].second == 0) {
					int x1 = e.second[j].first, x2 = e.second[j + 1].first;
					int now1 = kek[{x1, e.first}], now2 = kek[{x2, e.first}];
					if (dp[i | (1 << now1) | (1 << now2)] > dp[i] + 1) {
						dp[i | (1 << now1) | (1 << now2)] = dp[i] + 1;
						pred[i | (1 << now1) | (1 << now2)] = {{x1 + 1, e.first}, 1};
						predMask[i | (1 << now1) | (1 << now2)] = i;
					}
				}
			}
		}
	}
	std::cout << dp[(1 << n) - 1] << '\n';
	int nowMask = (1 << n) - 1;
	std::vector<std::pair<point, int>> v;
	while (nowMask != 0) {
		v.pb(pred[nowMask]);
		nowMask = predMask[nowMask];
		// debug(nowMask)
	}
	std::reverse(v.begin(), v.end());
	for (auto e : v) {
		std::cout << e.second << ' ' << e.first.x << ' ' << e.first.y << '\n';
	}
}