#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) (int((x).size()))
typedef long long ll;
typedef long double ld;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int64_t borders[30], borders2[30];

int64_t f1(int64_t x) {
	int64_t bval = upper_bound(all(borders), x) - borders - 1;
	return x - __builtin_popcountll(x - borders[bval]) + bval;
}

int64_t f2(int64_t x) {
	int64_t bval = upper_bound(all(borders2), x) - borders2;
	return x - __builtin_popcountll(x - borders2[bval - 1]) + bval;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int64_t n;
	cin >> n;
	int64_t prefSums = 2;
	for (int i = 0; i < 30; ++i) {
		borders[i] = prefSums;
		prefSums += 1l << (2 * i + 2);
	}
	prefSums = 3;
	for (int i = 0; i < 30; ++i) {
		borders2[i] = prefSums;
		prefSums += 1l << (2 * i + 3);
	}
	if (n % 2 == 0) {
		if (n == 2) {
			cout << "0\n";
		} else {
			int64_t l = 1, r = 1e12;
			n /= 2;
			while (r - l > 1) {
				int64_t mid = (l + r) / 2;
				if (f1(2 * mid) <= n)
					l = mid;
				else
					r = mid;
			}
			l *= 2;
			if (f1(l) == n)
				cout << l << "\n";
			else
				cout << "0\n";
		}
	} else {
		if (n == 1) {
			cout << "1\n";
		} else if (n == 3) {
			cout << "0\n";
		} else {
			n = (n + 1) / 2;
			int64_t l = 1, r = 1e12;
			while (r - l > 1) {
				int64_t mid = (l + r) / 2;
				if (f2(2 * mid + 1) <= n)
					l = mid;
				else
					r = mid;
			}
			l = l * 2 + 1;
			// cout << l << " " << f2(l) << "\n";
			if (f2(l) == n)
				cout << l << "\n";
			else
				cout << "0\n";
		}
	}
	return 0;
}