#include <bits/stdc++.h>
using namespace std;
#define all(x) x.begin(), x.end()

bool bit(int m, int i) {
	return (m >> i) & 1;
}

int readint() {
	int t;
	cin >> t;
	return t;
}

void writeint(int x, char e = 0) {
	cout << x;
	if (e) {
		cout << e;
	}
}

const int N = 12;
int n;
int m;
int vx[N];
int vy[N];
int sx[N];
int sy[N];

int zx[N];
int zy[N];

vector<pair<int, int>> bx[25];
vector<pair<int, int>> by[25];

vector<tuple<int, int, int>> answer;
int dp[1 << N];
int pr[1 << N];



int main() {
#ifdef LC
	assert(freopen("input.txt", "r", stdin));
#endif
	n = readint();
	for (int i = 0; i < n; ++i) {
		zx[i] = vx[i] = readint();
		zy[i] = vy[i] = readint();
	}
	m = readint();
	for (int i = 0; i < m; ++i) {
		zx[i + n] = sx[i] = readint();
		zy[i + n] = sy[i] = readint();
	}
	sort(zx, zx + n + m);
	sort(zy, zy + n + m);
	for (int i = 0; i < n; ++i) {
		vx[i] = int(lower_bound(zx, zx + n + m, vx[i]) - zx);
		vy[i] = int(lower_bound(zy, zy + n + m, vy[i]) - zy);
	}
	for (int i = 0; i < m; ++i) {
		sx[i] = int(lower_bound(zx, zx + n + m, sx[i]) - zx);
		sy[i] = int(lower_bound(zy, zy + n + m, sy[i]) - zy);
	}
	fill_n(dp, 1 << N, INT_MAX);
	fill_n(pr, 1 << N, -1);
	
	dp[0] = 0;
	for (int ms = 0; ms < (1 << n); ++ms) {
		for (int i = 0; i < 25; ++i) {
			bx[i].clear();
			by[i].clear();
		}
		for (int i = 0; i < n; ++i) {
			if (bit(ms, i)) {
				continue;
			}
			assert(vx[i] < 25 && vy[i] < 25);
			bx[vx[i]].emplace_back(vy[i], i);
			by[vy[i]].emplace_back(vx[i], i);
		}
		for (int i = 0; i < m; ++i) {
			bx[sx[i]].emplace_back(sy[i], -1);
			by[sy[i]].emplace_back(sx[i], -1);
		}
		for (int i = 0; i < 25; ++i) {
			sort(all(bx[i]));
			sort(all(by[i]));
		}
		for (int i = 0; i < n; ++i) {
			if (bit(ms, i)) {
				continue;
			}
			int mm = ms | (1 << i);
			if (dp[mm] > dp[ms] + 1) {
				dp[mm] = dp[ms] + 1;
				pr[mm] = ms;
			}
		}
		for (int x = 0; x < 25; ++x) {
			for (int ind = 0; ind + 1 < (int)bx[x].size(); ++ind) {
				int v = bx[x][ind].second;
				int u = bx[x][ind + 1].second;
				if (v < 0 || u < 0) {
					continue;
				}
				int mm = ms | (1 << v) | (1 << u);
				assert(mm != ms);
				if (dp[mm] > dp[ms] + 1) {
					dp[mm] = dp[ms] + 1;
					pr[mm] = ms;
				}
			}
			for (int ind = 0; ind + 1 < (int)by[x].size(); ++ind) {
				int v = by[x][ind].second;
				int u = by[x][ind + 1].second;
				if (v < 0 || u < 0) {
					continue;
				}
				int mm = ms | (1 << v) | (1 << u);
				assert(ms != mm);
				if (dp[mm] > dp[ms] + 1) {
					dp[mm] = dp[ms] + 1;
					pr[mm] = ms;
				}
			}
		}
	}
	int ms = (1 << n) - 1;
	while (ms) {
		assert(pr[ms] != -1);
		int mm = pr[ms];
		int v = -1;
		int u = -1;
		for (int i = 0; i < n; ++i) {
			if (!bit(ms ^ mm, i)) {
				continue;
			}
			if (v == -1) {
				v = i;
			} else if (u == -1) {
				u = i;
			} else {
				assert(false);
			}
		}
		if (u == -1) {
			assert(v != -1);
			answer.emplace_back(1, zx[vx[v]], zy[vy[v]] + 1);
		} else {
			assert(v != -1);
			answer.emplace_back(vx[v] == vx[u], (zx[vx[v]] + zx[vx[u]]) / 2, (zy[vy[v]] + zy[vy[u]]) / 2);
		}
		ms = mm;
	}
	reverse(all(answer));
	cout << answer.size() << "\n";
	for (auto e : answer) {
		int a, b, c;
		tie(a, b, c) = e;
		cout << a << " " << b << " " << c << "\n";
	}
	return 0;
}
