#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
//#define int ll

const int N = 1e5 + 10;
const int INF = 1e9 + 10;
vector<int> g[4 * N], rg[4 * N], order;
bool used[4 * N];
int color[4 * N], a[N], b[N], c[N], d[N], n;

set<pair<int, int>> t1[4 * N], t2[4 * N];
int sz;
void insert_val1(int v, pair<int, int> vl) {
	for (; v <= sz; v += v & (-v)) {
		t1[v].insert(vl);
	}
}

void erase_val1(int v, pair<int, int> vl) {
	for (; v <= sz; v += v & (-v)) {
		t1[v].erase(vl);
	}
}

pair<int, int> get_max1(int v, pair<int, int> wth) {
	pair<int, int> res;
	for (; v > 0; v -= v & (-v)) {
		if (t1[v].empty()) {
			continue;
		}
		if (*t1[v].rbegin() == wth) {
			if (SZ(t1[v]) > 1) res = max(res, *----t1[v].end());
		}
		else {
			res = max(res, *t1[v].rbegin());
		}
	}
	return res;
}

void insert_val2(int v, pair<int, int> vl) {
	for (; v <= sz; v += v & (-v)) {
		t2[v].insert(vl);
	}
}

void erase_val2(int v, pair<int, int> vl) {
	for (; v <= sz; v += v & (-v)) {
		t2[v].erase(vl);
	}
}

pair<int, int> get_min2(int v, pair<int, int> wth) {
	pair<int, int> res = {INF, INF};
	for (; v > 0; v -= v & (-v)) {
		if (t2[v].empty()) {
			continue;
		}
		if (*t2[v].begin() == wth) {
			if (SZ(t2[v]) > 1) res = min(res, *++t2[v].begin());
		}
		else {
			res = min(res, *t2[v].begin());
		}
	}
	return res;
}

void dfs(int v) {
	used[v] = true;
	int L, R, id;
	if (v <= n) {
		L = a[v], R = b[v];
	}
	else if (v <= 2 * n) {
		L = c[v - n], R = d[v - n];
	}
	else if (v <= 3 * n) {
		L = a[v - 2 * n], R = b[v - 2 * n];
	}
	else {
		L = c[v - 3 * n], R = d[v - 3 * n];
	}
	if (v <= 2 * n) {
		id = v;
	}
	else {
		id = v - 2 * n;
	}
	if (v > 2 * n) {
		erase_val1(L, {R, id});
		erase_val2(sz - R + 1, {L, id});
		for (auto u : g[v]) {
			if (!used[u]) {
				dfs(u);
			}
		}
	}
	else {
		for (;;) {
			pair<int, int> cur = get_max1(R, {R, id});
			if (cur.F < L) {
				break;
			}
			assert(!used[cur.S + 2 * n]);
			dfs(cur.S + 2 * n);
		}
		for (;;) {
			pair<int, int> cur = get_min2(sz - L + 1, {L, id});
			if (cur.F > R) {
				break;
			}
			assert(!used[cur.S + 2 * n]);
			dfs(cur.S + 2 * n);
		}
	}
	order.pb(v);
}

void dfs2(int v, int cl) {
	//cout << v << endl;
	if (!v) {
		exit(0);
	}
	color[v] = cl;
	int L, R, id;
	if (v <= n) {
		L = a[v], R = b[v];
	}
	else if (v <= 2 * n) {
		L = c[v - n], R = d[v - n];
	}
	else if (v <= 3 * n) {
		L = a[v - 2 * n], R = b[v - 2 * n];
	}
	else {
		L = c[v - 3 * n], R = d[v - 3 * n];
	}
	if (v <= 2 * n) {
		id = v;
	}
	else {
		id = v - 2 * n;
	}
	if (v <= 2 * n) {
		erase_val1(L, {R, id});
		erase_val2(sz - R + 1, {L, id});
		for (auto u : rg[v]) {
			if (!color[u]) {
				dfs2(u, cl);
			}
		}
	}
	else {
		for (;;) {
			pair<int, int> cur = get_max1(R, {R, id});
			if (cur.F < L) {
				break;
			}
			assert(!color[cur.S]);
			//assert(cur.S);
			dfs2(cur.S, cl);
		}
		for (;;) {
			pair<int, int> cur = get_min2(sz - L + 1, {L, id});
			if (cur.F > R) {
				break;
			}
			//cout << v << ' ' << cur.F << ' ' << cur.S << '\n';
			assert(!color[cur.S]);
			dfs2(cur.S, cl);
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	vector<int> srt;
	for (int i = 1; i <= n; i++) {
		cin >> a[i] >> b[i] >> c[i] >> d[i];
		g[2 * n + i].pb(n + i);
		g[3 * n + i].pb(i);
		rg[n + i].pb(2 * n + i);
		rg[i].pb(3 * n + i);
		srt.pb(a[i]);
		srt.pb(b[i]);
		srt.pb(c[i]);
		srt.pb(d[i]);
	}
	sort(all(srt));
	srt.resize(unique(all(srt)) - srt.begin());
	unordered_map<int, int> vl;
	for (int i = 0; i < SZ(srt); i++) {
		vl[srt[i]] = i + 1;
	}
	sz = SZ(srt);
	for (int i = 1; i <= n; i++) {
		a[i] = vl[a[i]];
		b[i] = vl[b[i]];
		c[i] = vl[c[i]];
		d[i] = vl[d[i]];
		//cout << a[i] << ' ' << b[i] << ' ' << c[i] << ' ' << d[i] << '\n';
		insert_val1(a[i], {b[i], i});
		insert_val1(c[i], {d[i], n + i});
		insert_val2(sz - b[i] + 1, {a[i], i});
		insert_val2(sz - d[i] + 1, {c[i], n + i});
	}
	for (int i = 1; i <= 4 * n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	reverse(all(order));
	int cnt = 0;
	for (int i = 1; i <= sz; i++) {
		t1[i] = {};
		t2[i] = {};
	}
	for (int i = 1; i <= n; i++) {
		insert_val1(a[i], {b[i], i});
		insert_val1(c[i], {d[i], n + i});
		insert_val2(sz - b[i] + 1, {a[i], i});
		insert_val2(sz - d[i] + 1, {c[i], n + i});
	}
	for (auto it : order) {
		if (!color[it]) {
			dfs2(it, ++cnt);
		}
	}
	for (int i = 1; i <= 2 * n; i++) {
		if (color[i] == color[i + 2 * n]) {
			cout << "No\n";
			exit(0);
		}
	}
	cout << "Yes\n";
	for (int i = 1; i <= n; i++) {
		if (color[i] > color[n + i]) {
			cout << 1 << '\n';
		}
		else {
			cout << 2 << '\n';
		}
	}
}