#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
//#define int ll

const int N = 1e5 + 10;
const int INF = 1e9 + 10;
vector<int> g[4 * N], rg[4 * N], order;
bool used[4 * N];
int color[4 * N], a[N], b[N], c[N], d[N], n;
int ptr11[4 * N], ptr12[4 * N], ptr21[4 * N], ptr22[4 * N];
vector<pair<int, int>> t1[4 * N], t2[4 * N];
bool killed[4 * N];
int sz;
inline void insert_val1(int v, pair<int, int> vl) {
	for (; v <= sz; v += v & (-v)) {
		t1[v].pb(vl);
	}
}

inline void erase_val1(int v) {
	for (; v <= sz; v += v & (-v)) {
		while (ptr11[v] >= 0 && killed[t1[v][ptr11[v]].S]) {
			ptr11[v]--;
		}
		while (ptr12[v] >= 0 && (ptr12[v] >= ptr11[v] || killed[t1[v][ptr12[v]].S])) {
			ptr12[v]--;
		}
	}
}

inline pair<int, int> get_max1(int v, int wth) {
	pair<int, int> res;
	for (; v > 0; v -= v & (-v)) {
		if (ptr11[v] >= 0 && t1[v][ptr11[v]].S != wth) {
			res = max(res, t1[v][ptr11[v]]);
		}
		else if (ptr12[v] >= 0) {
			res = max(res, t1[v][ptr12[v]]);	
		}
	}
	return res;
}

inline void insert_val2(int v, pair<int, int> vl) {
	for (; v <= sz; v += v & (-v)) {
		t2[v].pb(vl);
	}
}

inline void erase_val2(int v) {
	for (; v <= sz; v += v & (-v)) {
		while (ptr21[v] < SZ(t2[v]) && killed[t2[v][ptr21[v]].S]) {
			ptr21[v]++;
		}
		while (ptr22[v] < SZ(t2[v]) && (ptr22[v] <= ptr21[v] || killed[t2[v][ptr22[v]].S])) {
			ptr22[v]++;
		}
	}
}

inline pair<int, int> get_min2(int v, int wth) {
	pair<int, int> res = {INF, INF};
	for (; v > 0; v -= v & (-v)) {
		if (ptr21[v] < SZ(t2[v]) && t2[v][ptr21[v]].S != wth) {
			res = min(res, t2[v][ptr21[v]]);
		}
		else if (ptr22[v] < SZ(t2[v])) {
			res = min(res, t2[v][ptr22[v]]);
		}
	}
	return res;
}

void dfs(int v) {
	used[v] = true;
	int L, R, id;
	if (v <= n) {
		L = a[v], R = b[v];
	}
	else if (v <= 2 * n) {
		L = c[v - n], R = d[v - n];
	}
	else if (v <= 3 * n) {
		L = a[v - 2 * n], R = b[v - 2 * n];
	}
	else {
		L = c[v - 3 * n], R = d[v - 3 * n];
	}
	if (v <= 2 * n) {
		id = v;
	}
	else {
		id = v - 2 * n;
	}
	if (v > 2 * n) {
		killed[id] = true;
		erase_val1(L);
		erase_val2(sz - R + 1);
		for (auto u : g[v]) {
			if (!used[u]) {
				dfs(u);
			}
		}
	}
	else {
		for (;;) {
			pair<int, int> cur = get_max1(R, id);
			if (cur.F < L) {
				break;
			}
			dfs(cur.S + 2 * n);
		}
		for (;;) {
			pair<int, int> cur = get_min2(sz - L + 1, id);
			if (cur.F > R) {
				break;
			}
			dfs(cur.S + 2 * n);
		}
	}
	order.pb(v);
}

void dfs2(int v, int cl) {
	color[v] = cl;
	int L, R, id;
	if (v <= n) {
		L = a[v], R = b[v];
	}
	else if (v <= 2 * n) {
		L = c[v - n], R = d[v - n];
	}
	else if (v <= 3 * n) {
		L = a[v - 2 * n], R = b[v - 2 * n];
	}
	else {
		L = c[v - 3 * n], R = d[v - 3 * n];
	}
	if (v <= 2 * n) {
		id = v;
	}
	else {
		id = v - 2 * n;
	}
	if (v <= 2 * n) {
		killed[id] = true;
		erase_val1(L);
		erase_val2(sz - R + 1);
		for (auto u : rg[v]) {
			if (!color[u]) {
				dfs2(u, cl);
			}
		}
	}
	else {
		for (;;) {
			pair<int, int> cur = get_max1(R, id);
			if (cur.F < L) {
				break;
			}
			dfs2(cur.S, cl);
		}
		for (;;) {
			pair<int, int> cur = get_min2(sz - L + 1, id);
			if (cur.F > R) {
				break;
			}
			dfs2(cur.S, cl);
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	vector<int> srt;
	for (int i = 1; i <= n; i++) {
		cin >> a[i] >> b[i] >> c[i] >> d[i];
		g[2 * n + i].pb(n + i);
		g[3 * n + i].pb(i);
		rg[n + i].pb(2 * n + i);
		rg[i].pb(3 * n + i);
		srt.pb(a[i]);
		srt.pb(b[i]);
		srt.pb(c[i]);
		srt.pb(d[i]);
	}
	sort(all(srt));
	srt.resize(unique(all(srt)) - srt.begin());
	unordered_map<int, int> vl;
	for (int i = 0; i < SZ(srt); i++) {
		vl[srt[i]] = i + 1;
	}
	sz = SZ(srt);
	vector<pair<int, int>> flex1, flex2;
	for (int i = 1; i <= n; i++) {
		a[i] = vl[a[i]];
		b[i] = vl[b[i]];
		c[i] = vl[c[i]];
		d[i] = vl[d[i]];
		flex1.pb({b[i], i});
		flex1.pb({d[i], n + i});
		flex2.pb({a[i], i});
		flex2.pb({c[i], n + i});
		/*insert_val1(a[i], {b[i], i});
		insert_val1(c[i], {d[i], n + i});
		insert_val2(sz - b[i] + 1, {a[i], i});
		insert_val2(sz - d[i] + 1, {c[i], n + i});*/
	}
	sort(all(flex1));
	sort(all(flex2));
	for (auto it : flex1) {
		if (it.S <= n) {
			insert_val1(a[it.S], {b[it.S], it.S});
		}
		else {
			insert_val1(c[it.S - n], {d[it.S - n], it.S});
		}
	}
	for (auto it : flex2) {
		if (it.S <= n) {
			insert_val2(sz - b[it.S] + 1, {a[it.S], it.S});
		}
		else {
			insert_val2(sz - d[it.S - n] + 1, {c[it.S - n], it.S});
		}
	}
	for (int i = 1; i <= sz; i++) {
		ptr11[i] = SZ(t1[i]) - 1;
		ptr12[i] = SZ(t1[i]) - 2;
		ptr21[i] = 0;
		ptr22[i] = 1;
	}
	for (int i = 1; i <= 4 * n; i++) {
		if (!used[i]) {
			dfs(i);
		}
	}
	reverse(all(order));
	int cnt = 0;
	/*for (int i = 1; i <= n; i++) {
		insert_val1(a[i], {b[i], i});
		insert_val1(c[i], {d[i], n + i});
		insert_val2(sz - b[i] + 1, {a[i], i});
		insert_val2(sz - d[i] + 1, {c[i], n + i});
	}*/

	for (int i = 1; i <= sz; i++) {
		ptr11[i] = SZ(t1[i]) - 1;
		ptr12[i] = SZ(t1[i]) - 2;
		ptr21[i] = 0;
		ptr22[i] = 1;
	}
	for (int i = 1; i <= 2 * n; i++) {
		killed[i] = false;
	}
	for (auto it : order) {
		if (!color[it]) {
			dfs2(it, ++cnt);
		}
	}
	for (int i = 1; i <= 2 * n; i++) {
		if (color[i] == color[i + 2 * n]) {
			cout << "No\n";
			exit(0);
		}
	}
	cout << "Yes\n";
	for (int i = 1; i <= n; i++) {
		if (color[i] > color[n + i]) {
			cout << 1 << '\n';
		}
		else {
			cout << 2 << '\n';
		}
	}
}