#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define SZ(x) (int)x.size()
#define int ll

struct T {
	int msk, x, y, type;
	T() {};
	T(int msk, int x, int y, int type) : msk(msk), x(x), y(y), type(type) {}; 
};

struct T2 {
	int F, S, type;
	T2() {};
	T2(int F, int S, int type) : F(F), S(S), type(type) {};
};

bool cmp(T2 a, T2 b) {
	return a.F < b.F;	
}

const int INF = 1e9 + 10;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	if (n <= 10 && m <= 10) {
		map<int, vector<T2>> have, have2;
		vector<int> x(n), y(n);
		for (int i = 0; i < n; i++) {
			cin >> x[i] >> y[i];
			have[x[i]].pb(T2(y[i], i, 1));
			have2[y[i]].pb(T2(x[i], i, 1));
		}
		for (int i = 0; i < m; i++) {
			int cx, cy;
			cin >> cx >> cy;
			have[cx].pb(T2(cy, i, 2));
			have2[cy].pb(T2(cx, i, 2));
		}
		for (auto &it : have) {
			sort(all(it.S), cmp);
		}
		for (auto &it : have2) {
			sort(all(it.S), cmp);
		}
		vector<int> dp(1 << n, INF);
		dp[0] = 0;
		vector<T> from(1 << n);
		for (int mask = 0; mask < (1 << n); mask++) {
			for (int i = 0; i < n; i++) {
				if ((mask >> i) & 1) {
					continue;
				}
				int posx, posy;
				for (int j = 0; j < SZ(have[x[i]]); j++) {
					if (have[x[i]][j].F == y[i]) {
						posx = j;
						break;
					}
				}
				for (int j = 0; j < SZ(have2[y[i]]); j++) {
					if (have2[y[i]][j].F == x[i]) {
						posy = j;
						break;
					}
				}
				int ptr = posx + 1;
				while (ptr < SZ(have[x[i]]) && ((mask >> have[x[i]][ptr].S) & 1) && have[x[i]][ptr].type == 1) {
					ptr++;
				}
				if (!(ptr >= SZ(have[x[i]]) || have[x[i]][ptr].type == 2)) {
					if (dp[mask | (1 << i) | (1 << have[x[i]][ptr].S)] > dp[mask] + 1) {
						dp[mask | (1 << i) | (1 << have[x[i]][ptr].S)] = dp[mask] + 1;
						from[mask | (1 << i) | (1 << have[x[i]][ptr].S)] = T(mask, x[i], y[i] + 1, 1);
					}
				}
				else {
					if (dp[mask | (1 << i)] > dp[mask] + 1) {
						dp[mask | (1 << i)] = dp[mask] + 1;
						from[mask | (1 << i)] = T(mask, x[i], y[i] + 1, 1);
					}
				}
				ptr = posx -1;
				while (ptr >= 0 && ((mask >> have[x[i]][ptr].S) & 1) && have[x[i]][ptr].type == 1) {
					ptr--;
				}
				if (!(ptr < 0 || have[x[i]][ptr].type == 2)) {
					if (dp[mask | (1 << i) | (1 << have[x[i]][ptr].S)] > dp[mask] + 1) {
						dp[mask | (1 << i) | (1 << have[x[i]][ptr].S)] = dp[mask] + 1;
						from[mask | (1 << i) | (1 << have[x[i]][ptr].S)] = T(mask, x[i], y[i] - 1, 1);
					}
				}
				else {
					if (dp[mask | (1 << i)] > dp[mask] + 1) {
						dp[mask | (1 << i)] = dp[mask] + 1;
						from[mask | (1 << i)] = T(mask, x[i], y[i] - 1, 1);
					}
				}

				ptr = posy + 1;
				while (ptr < SZ(have2[y[i]]) && ((mask >> have2[y[i]][ptr].S) & 1) && have2[y[i]][ptr].type == 1) {
					ptr++;
				}
				if (!(ptr >= SZ(have2[y[i]]) || have2[y[i]][ptr].type == 2)) {
					if (dp[mask | (1 << i) | (1 << have2[y[i]][ptr].S)] > dp[mask] + 1) {
						dp[mask | (1 << i) | (1 << have[x[i]][ptr].S)] = dp[mask] + 1;
						from[mask | (1 << i) | (1 << have2[y[i]][ptr].S)] = T(mask, x[i] + 1, y[i], 0);
					}
				}
				else {
					if (dp[mask | (1 << i)] > dp[mask] + 1) {
						dp[mask | (1 << i)] = dp[mask] + 1;
						from[mask | (1 << i)] = T(mask, x[i] + 1, y[i], 1);
					}
				}

				ptr = posy - 1;
				while (ptr >= 0 && ((mask >> have2[y[i]][ptr].S) & 1) && have2[y[i]][ptr].type == 1) {
					ptr--;
				}
				if (!(ptr < 0 || have2[y[i]][ptr].type == 2)) {
					if (dp[mask | (1 << i) | (1 << have2[y[i]][ptr].S)] > dp[mask] + 1) {
						dp[mask | (1 << i) | (1 << have[x[i]][ptr].S)] = dp[mask] + 1;
						
						from[mask | (1 << i) | (1 << have2[y[i]][ptr].S)] = T(mask, x[i] - 1, y[i], 0);
					}
				}
				else {
					if (dp[mask | (1 << i)] > dp[mask] + 1) {
						dp[mask | (1 << i)] = dp[mask] + 1;
						from[mask | (1 << i)] = T(mask, x[i] - 1, y[i], 1);
					}
				}				
			}
		}
		int now = (1 << n) - 1;
		//cout << dp[now] << '\n';
		vector<pair<pair<int, int>, int>> ans;
		while (now) {
			ans.pb(make_pair(make_pair(from[now].x, from[now].y), from[now].type));
			now = from[now].msk;
		}
		reverse(all(ans));
		cout << SZ(ans) << '\n';
		for (auto it : ans) {
			cout << it.S << ' ' << it.F.F << ' ' << it.F.S << '\n';
		}
	}
}