#include <bits/stdc++.h>
using namespace std;

int xb[10005];
int yb[10005];
int xs[10005];
int ys[10005];

struct solution{
    int a, x, y;
};

int n, m;

bool poredak(int a, int b, int c){
    return min(a, c) < b && max(a, c) > b;
}

map <vector <int>, pair <int, vector <solution>>> bio;
map <vector <int>, bool> ime;

pair <int, vector <solution>> resi(vector <int> boxes){
    for(int i=1; i<=n; i++){
        if(boxes[i]) break;
        if(i == n) return {0, {}};
    }
    if(ime[boxes]) return bio[boxes];
    pair <int, vector <solution>> tren;
    tren.first = n+5;
    for(int i=1; i<=n; i++){
        for(int j=i+1; j<=n; j++){
            if(!boxes[i] || !boxes[j]) continue;
            if(xb[i] == xb[j]){
                bool moze = 1;
                for(int k=1; k<=n; k++){
                    if(xb[k] == xb[i] && poredak(yb[i], yb[k], yb[j])) moze = 0;
                }
                for(int k=1; k<=m; k++){
                    if(xs[k] == xb[i] && poredak(yb[i], ys[k], yb[j])) moze = 0;
                }
                if(moze){
                    boxes[i] = boxes[j] = 0;
                    pair <int, vector <solution>> nesto = resi(boxes);
                    boxes[i] = boxes[j] = 1;
                    nesto.first++;
                    nesto.second.push_back({1, xb[i], min(yb[i], yb[j]) + 1});
                    if(tren.first > nesto.first){
                        tren = nesto;
                    }
                }
            }
            else if(yb[i] == yb[j]){
                bool moze = 1;
                for(int k=1; k<=n; k++){
                    if(yb[k] == yb[i] && poredak(xb[i], xb[k], xb[j])) moze = 0;
                }
                for(int k=1; k<=m; k++){
                    if(ys[k] == yb[i] && poredak(xb[i], xs[k], xb[j])) moze = 0;
                }
                if(moze){
                    boxes[i] = boxes[j] = 0;
                    pair <int, vector <solution>> nesto = resi(boxes);
                    boxes[i] = boxes[j] = 1;
                    nesto.first++;
                    nesto.second.push_back({0, min(xb[i], xb[j]) + 1, yb[i]});
                    if(tren.first > nesto.first){
                        tren = nesto;
                    }
                }
            }
        }
    }
    for(int i=1; i<=n; i++){
        if(boxes[i]){
            boxes[i] = 0;
            pair <int, vector <solution>> nesto = resi(boxes);
            nesto.first++;
            nesto.second.push_back({0, xb[i]+1, yb[i]});
            boxes[i] = 1;
            if(tren.first > nesto.first){
                tren = nesto;
            }
        }
    }
    ime[boxes] = 1;
    return bio[boxes] = tren;
}

int main(){
    ios_base::sync_with_stdio(false);

    vector <int> prvo;

    cin >> n;
    if(n > 10) return 0;
    prvo.push_back(0);
    for(int i=1; i<=n; i++){
        cin >> xb[i] >> yb[i];
        prvo.push_back(1);
    }
    cin >> m;
    for(int i=1; i<=m; i++){
        cin >> xs[i] >> ys[i];
    }
    pair <int, vector <solution>> resenje = resi(prvo);
    cout << resenje.first << "\n";
    for(auto c : resenje.second) cout << c.a << " " << c.x << " " << c.y << "\n";
    return 0;
}
