#include <bits/stdc++.h>
#define PRINT(x) cerr<<#x<<'='<<x<<endl
#define all(x) begin(x),end(x)
#define sz(x) int((x).size())
#define pb push_back
#define mid (l+r)/2
#define endl '\n'
#define fi first
#define se second
#define lld long long
#define pii pair<int,int>
#define pil pair<int,lld>
#define pli pair<lld,int>
#define pll pair<lld,lld>
#define INF 1000000000
#define LINF 1000000000000000000LL
#define EPS 1e-6
using namespace std;
#define MAXN 100010
int N, pos[2*MAXN], scc[2*MAXN], degin[2*MAXN], vr[2*MAXN], scccnt;
vector<int> adj[2*MAXN], adj1[2*MAXN], dag[2*MAXN], st, topo;
pii in[2*MAXN];
bool intersect(pii A, pii B) {
    if(A.fi <= B.fi && B.fi <= A.se) return true;
    if(A.fi <= B.se && B.se <= A.se) return true;
    if(B.fi <= A.fi && A.fi <= B.se) return true;
    if(B.fi <= A.fi && A.fi <= B.se) return true;
    return false;
}
int ne(int x) {
    if(x > N) return x-N;
    return x+N;
}
void DFS1(int node) {
    pos[node] = 1;
    for(auto x : adj[node]) {
        if(!pos[x]) DFS1(x);
    }
    st.pb(node);
}
void DFS2(int node, int comp) {
    scc[node] = comp;
    for(auto x : adj1[node]) {
        if(!scc[x]) DFS2(x, comp);
    }
}
int main() {
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0); cerr.tie(0);
    cin >> N;
    for(int i = 1; i <= N; i++) {
        int a, b, c, d; cin >> a >> b >> c >> d;
        in[i] = {a, b};
        in[i+N] = {c, d};
    }
    for(int i = 1; i <= 2*N; i++) {
        for(int j = i+1; j <= 2*N; j++) {
            if(intersect(in[i], in[j])) {
                /*PRINT(i);
                PRINT(ne(j));
                PRINT(j);
                PRINT(ne(i));*/
                adj[i].pb(ne(j));
                adj1[ne(j)].pb(i);
                adj[j].pb(ne(i));
                adj1[ne(i)].pb(j);
            }
        }
    }
    for(int i = 1; i <= 2*N; i++) {
        if(!pos[i]) {
            DFS1(i);
            //PRINT(i);
        }
    }
    reverse(all(st));
    for(auto x : st) {
        if(!scc[x]) {
            //PRINT(x);
            DFS2(x, ++scccnt);
            //PRINT(scccnt);
        }
    }
    for(int i = 1; i <= N; i++) {
        if(scc[i] == scc[i+N]) {
            cout << "No\n";
            return 0;
        }
    }
    st.clear();
    for(int i = 1; i <= 2*N; i++) {
        //PRINT(scc[i]);
        for(auto j : adj[i]) {
            if(scc[i] != scc[j]) dag[scc[i]].pb(scc[j]), degin[scc[j]]++;
        }
    }
    for(int i = 1; i <= scccnt; i++) {
        if(degin[i] == 0) st.pb(i);
    }
    while(!st.empty()) {
        int top = st.back(); st.pop_back();
        topo.pb(top);
        for(auto x : dag[top]) {
            degin[x]--;
            if(degin[x] == 0) st.pb(x);
        }
    }
    int timer = 0;
    for(auto x : topo) {
        vr[x] = ++timer;
    }
    cout << "Yes\n";
    for(int i = 1; i <= N; i++) {
        if(vr[scc[i]] > vr[scc[i+N]]) cout << "1\n";
        else cout << "2\n";
    }
    return 0;
}
