#include <bits/stdc++.h>
#define PRINT(x) cerr<<#x<<'='<<x<<endl
#define all(x) begin(x),end(x)
#define sz(x) int((x).size())
#define pb push_back
#define mid (l+r)/2
#define endl '\n'
#define fi first
#define se second
#define lld long long
#define pii pair<int,int>
#define pil pair<int,lld>
#define pli pair<lld,int>
#define pll pair<lld,lld>
#define INF 1000000000
#define LINF 1000000000000000000LL
#define EPS 1e-6
using namespace std;
#define MAXN 2010
int N, M;
int xk[MAXN], yk[MAXN], xr[MAXN], yr[MAXN], invX[MAXN], invY[MAXN], hor[MAXN], ver[MAXN], pos[MAXN];
vector<pii> v[MAXN], h[MAXN];
set<int> XX, YY;
map<int, int> hshX, hshY;
vector<pair<int, pii> > sol;
pair<int, pii> povezi(int i, int j) {
    pair<int, pii> rez;
    if(xk[i] == xk[j]) {
        rez.fi = 1;
        rez.se.fi = invX[xk[i]];
        rez.se.se = invY[min(yk[i], yk[j])]+1;
    } else if(yk[i] == yk[j]) {
        rez.fi = 0;
        rez.se.fi = invX[min(xk[i], xk[j])]+1;
        rez.se.se = invY[yk[i]];
    }
    return rez;
}
int dfs(int x, bool ubac) {
    pos[x] = true;
    if(ubac == true) {
        if(hor[x] && !pos[hor[x]]) dfs(hor[x], 0);
        if(ver[x] && !pos[ver[x]]) dfs(ver[x], 0);
    } else {
        if(hor[x] && !pos[hor[x]]) {
            ubac = true;
            sol.pb(povezi(x, hor[x]));
            dfs(hor[x], 1);
        }
        if(ver[x] && !pos[ver[x]]) {
            if(!ubac) {
               ubac = true;
               sol.pb(povezi(x, ver[x]));
               dfs(ver[x], 1);
            } else dfs(ver[x], 0);
        }
        if(!ubac) {
            sol.pb({0, {invX[xk[x]]-1, invY[yk[x]]}});
        }
    }
}
int main() {
    ios::sync_with_stdio(false); cin.tie(0); cout.tie(0); cerr.tie(0);
    cin >> N;
    for(int i = 1; i <= N; i++) {
        cin >> xk[i] >> yk[i];
        XX.insert(xk[i]);
        YY.insert(yk[i]);
    }
    cin >> M;
    for(int i = 1; i <= M; i++) {
        cin >> xr[i] >> yr[i];
        XX.insert(xr[i]);
        YY.insert(yr[i]);
    }
    int xcnt = 0, ycnt = 0;
    for(auto x : XX) {
        hshX[x] = ++xcnt;
        invX[xcnt] = x;
        PRINT(xcnt);
        PRINT(invX[xcnt]);
    }
    for(auto y : YY) {
        hshY[y] = ++ycnt;
        invY[ycnt] = y;
        PRINT(ycnt);
        PRINT(invY[ycnt]);
    }
    for(int i = 1; i <= N; i++) {
        xk[i] = hshX[xk[i]];
        yk[i] = hshY[yk[i]];

        v[yk[i]].pb({xk[i], i});
        h[xk[i]].pb({yk[i], i});
    }
    for(int i = 1; i <= M; i++) {
        xr[i] = hshX[xr[i]];
        yr[i] = hshY[yr[i]];

        v[yr[i]].pb({xr[i], -1});
        h[xr[i]].pb({yr[i], -1});
    }
    for(int i = 1; i <= xcnt; i++) {
        if(!h[i].empty()) {
            sort(all(h[i]));
            for(int j = 1; j < h[i].size(); j++) {
                if(h[i][j].se > 0 && h[i][j-1].se > 0) hor[h[i][j].se] = h[i][j-1].se, hor[h[i][j-1].se] = h[i][j].se;
            }
        }
    }
    for(int i = 1; i <= ycnt; i++) {
        if(!v[i].empty()) {
            sort(all(v[i]));
            for(int j = 1; j < v[i].size(); j++) {
                if(v[i][j].se > 0 && v[i][j-1].se > 0) ver[v[i][j].se] = v[i][j-1].se, ver[v[i][j-1].se] = v[i][j].se;
            }
        }
    }
    for(int i = 1; i <= N; i++) {
        if((ver[i] == 0 || hor[i] == 0) && !pos[i]) dfs(i, 0);
    }
    for(int i = 1; i <= N; i++) {
        if(!pos[i]) dfs(i, 0);
    }
    cout << sz(sol) << endl;
    for(auto x : sol) {
        cout << x.fi << ' ' << x.se.fi << ' ' << x.se.se << endl;
    }
    return 0;
}
