#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define mp make_pair
#define mt make_tuple
const int N=100050;
const int H=12005;
struct Edge
{
	int u,v,c;
	Edge(){}
	Edge(int a, int b, int d):u(a),v(b),c(d){}
};
vector<Edge> edges;
vector<int> G[H];
void AddEdge(int u, int v)
{
	G[u].pb(edges.size());
	edges.pb(Edge(u,v,1));
	G[v].pb(edges.size());
	edges.pb(Edge(v,u,0));
}
int dist[H],go[H],s,t;
bool BFS()
{
	for(int i=s;i<=t;i++) dist[i]=0;
	dist[s]=1;
	queue<int> q;
	q.push(s);
	while(q.size())
	{
		int u=q.front();
		q.pop();
		for(int e:G[u])
		{
			int v=edges[e].v;
			int c=edges[e].c;
			if(c && dist[v]==0)
			{
				dist[v]=dist[u]+1;
				go[v]=e;
				q.push(v);
			}
		}
	}
	return dist[t]!=0;
}
int MaxFlow()
{
	int ans=0;
	while(BFS())
	{
		ans++;
		for(int i=t;i!=s;i=edges[go[i]].u)
		{
			edges[go[i]].c--;
			edges[go[i]^1].c++;
		}
	}
	return ans;
}
int a[N],b[N],c[N],d[N],l[N],r[N],ans[N];
vector<int> all;
int main()
{
	int n;
	scanf("%i",&n);
	for(int i=1;i<=n;i++) scanf("%i %i %i %i",&a[i],&b[i],&c[i],&d[i]),all.pb(a[i]),all.pb(c[i]);
	sort(all.begin(),all.end());
	all.erase(unique(all.begin(),all.end()),all.end());
	s=0;t=n+all.size()+1;
	for(int i=1;i<=n;i++) AddEdge(s,i);
	for(int i=1;i<=all.size();i++) AddEdge(n+i,t);
	for(int i=1;i<=n;i++)
	{
		a[i]=lower_bound(all.begin(),all.end(),a[i])-all.begin()+1;
		c[i]=lower_bound(all.begin(),all.end(),c[i])-all.begin()+1;
		AddEdge(i,n+a[i]);
		AddEdge(i,n+c[i]);
	}
	int f=MaxFlow();
	if(f!=n) printf("No\n");
	else
	{
		printf("Yes\n");
		for(auto e:edges)
		{
			int u=e.u,v=e.v,c=e.c;
			if(u>=1 && u<=n && v>n && c==0)
			{
				v-=n;
				if(a[u]==v) ans[u]=1;
				else ans[u]=2;
			}
		}
		for(int i=1;i<=n;i++) printf("%i\n",ans[i]);
	}
	return 0;
}


/*#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define mp make_pair
#define mt make_tuple
const int N=100050;
int a[N],b[N],c[N],d[N],l[N],r[N],ans[N];
int main()
{
	int n;
	scanf("%i",&n);
	for(int i=1;i<=n;i++) scanf("%i %i %i %i",&a[i],&b[i],&c[i],&d[i]);
	for(int mask=0;mask<(1<<n);mask++)
	{
		for(int i=1;i<=n;i++)
		{
			if((mask>>(i-1))&1)
			{
				ans[i]=2;
				l[i]=c[i];
				r[i]=d[i];
			}
			else
			{
				ans[i]=1;
				l[i]=a[i];
				r[i]=b[i];
			}
		}
		bool ok=1;
		for(int i=1;i<=n;i++) for(int j=i+1;j<=n;j++) if(max(l[i],l[j])<=min(r[i],r[j])){ ok=0;break;}
		if(ok)
		{
			printf("Yes\n");
			for(int i=1;i<=n;i++) printf("%i\n",ans[i]);
			return 0;
		}
	}
	printf("No\n");
	return 0;
}*/
