#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define mp make_pair
#define mt make_tuple
const int N=1000050;
set<int> hor[N],ver[N];
struct Compress
{
	vector<int> all;
	void Add(int x){ all.pb(x);}
	void Build(){ sort(all.begin(),all.end());all.erase(unique(all.begin(),all.end()),all.end());}
	int Get(int x){ return lower_bound(all.begin(),all.end(),x)-all.begin()+1;}
	int Val(int x){ return all[x-1];}
	int sz(){ return all.size();}
} xs,ys;
int x[N],y[N];
void Add(int i)
{
	hor[x[i]].insert(y[i]);
	ver[y[i]].insert(x[i]);
}
void Del(int i)
{
	hor[x[i]].erase(y[i]);
	ver[y[i]].erase(x[i]);
}
bool Check(int i, int j)
{
	if(x[i]==x[j])
	{
		if(hor[x[i]].lower_bound(y[i])==hor[x[i]].lower_bound(y[j])) return 1;
		else return 0;
	}
	else if(y[i]==y[j])
	{
		if(ver[y[i]].lower_bound(x[i])==ver[y[i]].lower_bound(x[j])) return 1;
		else return 0;
	}
	else return 0;
}
void Print(int i, int j)
{
	if(x[i]==x[j]) printf("1 %i %i\n",xs.Val(x[i]),ys.Val(min(y[i],y[j]))+1);
	else printf("0 %i %i\n",xs.Val(min(x[i],x[j]))+1,ys.Val(y[i]));
}
void Print(int i)
{
	printf("1 %i %i\n",xs.Val(x[i]),ys.Val(y[i])+1);
}
vector<int> E[N];
int deg[N],was[N];
vector<int> row[N],col[N];
void AddEdge(int u, int v)
{
	E[u].pb(v);
	E[v].pb(u);
	deg[u]++;
	deg[v]++;
}
int main()
{
	int n,m;
	scanf("%i",&n);
	for(int i=1;i<=n;i++) scanf("%i %i",&x[i],&y[i]),xs.Add(x[i]),ys.Add(y[i]);
	scanf("%i",&m);
	for(int i=n+1;i<=n+m;i++) scanf("%i %i",&x[i],&y[i]),xs.Add(x[i]),ys.Add(y[i]);
	xs.Build();ys.Build();
	for(int i=1;i<=n+m;i++) x[i]=xs.Get(x[i]),y[i]=ys.Get(y[i]);
	for(int i=n+1;i<=n+m;i++) Add(i);
	for(int i=1;i<=n;i++) row[x[i]].pb(i),col[y[i]].pb(i);
	for(int i=1;i<=xs.sz();i++) if(row[i].size()==2 && Check(row[i][0],row[i][1])) AddEdge(row[i][0],row[i][1]);
	for(int i=1;i<=ys.sz();i++) if(col[i].size()==2 && Check(col[i][0],col[i][1])) AddEdge(col[i][0],col[i][1]);
	vector<pair<int,int>> ans;
	while(1)
	{
		int mn=-1;
		for(int i=1;i<=n;i++) if(deg[i]>0 && (mn==-1 || deg[i]<deg[mn])) mn=i;
		if(mn==-1) break;
		int u=mn;
		for(int v:E[u]) if(!was[v])
		{
			ans.pb({u,v});
			deg[u]=0;deg[v]=0;
			was[u]=1;was[v]=1;
			for(int w:E[v]) if(!was[w]) deg[w]--;
			for(int w:E[u]) if(!was[w]) deg[w]--;
			break;
		}
	}
	printf("%i\n",n-ans.size());
	for(auto p:ans) Print(p.first,p.second);
	for(int i=1;i<=n;i++) if(!was[i]) Print(i);
	return 0;
}


/*#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define mp make_pair
#define mt make_tuple
const int N=1000050;
set<int> hor[N],ver[N];
struct Compress
{
	vector<int> all;
	void Add(int x){ all.pb(x);}
	void Build(){ sort(all.begin(),all.end());all.erase(unique(all.begin(),all.end()),all.end());}
	int Get(int x){ return lower_bound(all.begin(),all.end(),x)-all.begin()+1;}
	int Val(int x){ return all[x-1];}
} xs,ys;
int x[N],y[N];
void Add(int i)
{
	hor[x[i]].insert(y[i]);
	ver[y[i]].insert(x[i]);
}
void Del(int i)
{
	hor[x[i]].erase(y[i]);
	ver[y[i]].erase(x[i]);
}
bool Check(int i, int j)
{
	if(x[i]==x[j])
	{
		if(hor[x[i]].lower_bound(y[i])==hor[x[i]].lower_bound(y[j])) return 1;
		else return 0;
	}
	else if(y[i]==y[j])
	{
		if(ver[y[i]].lower_bound(x[i])==ver[y[i]].lower_bound(x[j])) return 1;
		else return 0;
	}
	else return 0;
}
void Print(int i, int j)
{
	if(x[i]==x[j]) printf("1 %i %i\n",xs.Val(x[i]),ys.Val(min(y[i],y[j]))+1);
	else printf("0 %i %i\n",xs.Val(min(x[i],x[j]))+1,ys.Val(y[i]));
}
void Print(int i)
{
	printf("1 %i %i\n",xs.Val(x[i]),ys.Val(y[i])+1);
}
int main()
{
	int n,m;
	scanf("%i",&n);
	for(int i=1;i<=n;i++) scanf("%i %i",&x[i],&y[i]),xs.Add(x[i]),ys.Add(y[i]);
	scanf("%i",&m);
	for(int i=n+1;i<=n+m;i++) scanf("%i %i",&x[i],&y[i]),xs.Add(x[i]),ys.Add(y[i]);
	xs.Build();ys.Build();
	for(int i=1;i<=n+m;i++) x[i]=xs.Get(x[i]),y[i]=ys.Get(y[i]);
	vector<int> p(n),best;
	int ans=-1;
	for(int i=0;i<n;i++) p[i]=i/2;
	for(int i=n+1;i<=n+m;i++) Add(i);
	do
	{
		for(int i=1;i<=n;i++) Add(i);
		int cnt=0;
		for(int i=0;i<n/2;i++)
		{
			vector<int> pos;
			for(int j=0;j<n;j++) if(p[j]==i) pos.pb(j+1);
			Del(pos[0]),Del(pos[1]);
			if(Check(pos[0],pos[1])) cnt++;
			else break;
		}
		if(ans<cnt) ans=cnt,best=p;
	}while(next_permutation(p.begin(),p.end()));
	printf("%i\n",n-ans);
	for(int i=0;i<ans;i++)
	{
		vector<int> pos;
		for(int j=0;j<n;j++) if(best[j]==i) pos.pb(j+1);
		Print(pos[0],pos[1]);
	}
	for(int j=0;j<n;j++) if(best[j]>=ans) Print(j+1);
	//for(int j=0;j<n;j++) printf("%i ",best[j]);printf("\n");
	return 0;
}*/
