#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define mp make_pair
#define mt make_tuple
const int N=200050;
const int M=N*20*2*3/2;
struct TwoSat
{
	TwoSat(){}
	int sz;
	vector<int> E[M];
	void Or(int u, int v)
	{
		//printf("or: %i %i\n",u,v);
		E[u^1].pb(v);
		E[v^1].pb(u);
		sz=max(sz,max(u,v)|1);
	}
	void imp(int u, int v)
	{
		//printf("imp: %i %i\n",u,v);
		E[u].pb(v);
		E[v^1].pb(u^1);
		sz=max(sz,max(u,v)|1);
	}
	int disc[M],low[M],tid,csz,cmp[M];
	bool in[M];
	stack<int> s;
	void Tarjan(int u)
	{
		disc[u]=low[u]=++tid;
		in[u]=1;s.push(u);
		for(int v:E[u])
		{
			if(!disc[v])
			{
				Tarjan(v);
				low[u]=min(low[u],low[v]);
			}
			else if(in[v]) low[u]=min(low[u],low[v]);
		}
		if(disc[u]==low[u])
		{
			int v;
			csz++;
			do
			{
				v=s.top();
				s.pop();
				in[v]=0;
				cmp[v]=csz;
			}while(v!=u);
		}
	}
	bool Check()
	{
		for(int i=0;i<=sz;i++) if(!disc[i]) Tarjan(i);
		for(int i=0;i<=sz;i+=2) if(cmp[i]==cmp[i^1]) return 0;
		return 1;
	}
	int tme[M],in_deg[M];
	vector<int> G[M];
	void Solve()
	{
		for(int i=0;i<=sz;i++) for(int j:E[i]) if(cmp[i]!=cmp[j]) G[cmp[i]].pb(cmp[j]),in_deg[cmp[j]]++;
		queue<int> q;
		for(int i=1;i<=csz;i++) if(in_deg[i]==0) q.push(i);
		int now=0;
		while(q.size())
		{
			int u=q.front();
			q.pop();
			tme[u]=++now;
			for(int v:G[u])
			{
				in_deg[v]--;
				if(in_deg[v]==0)
				{
					q.push(v);
				}
			}
		}
	}
} SAT_2;
int pos(int x){ return x<<1;}
int neg(int x){ return x<<1|1;}
const int H=N*8;
int a[N],b[N],c[N],d[N],tsz,id[H];
struct Compress
{
	vector<int> all;
	void Add(int x){ all.pb(x);}
	void Build(){ sort(all.begin(),all.end());all.erase(unique(all.begin(),all.end()),all.end());}
	int Get(int x){ return lower_bound(all.begin(),all.end(),x)-all.begin()+1;}
	int Val(int x){ return all[x-1];}
	int sz(){ return all.size();}
} xs;
vector<int> in_edges[H];
void Build(int c, int ss, int se)
{
	//id[c]=++tsz;
	if(ss==se) return;
	int mid=ss+se>>1;
	Build(c<<1,ss,mid);
	Build(c<<1|1,mid+1,se);
	//in_edges[id[c<<1]].pb(pos(id[c]));
	//in_edges[id[c<<1|1]].pb(pos(id[c]));
	//SAT_2.imp(pos(id[c]),pos(id[c<<1]));
	//SAT_2.imp(pos(id[c]),pos(id[c<<1|1]));
}
vector<int> v[H];
void Set(int c, int ss, int se, int qs, int qe, int x)
{
	if(qs>qe || qs>se || ss>qe) return;
	//if(qs<=ss && qe>=se){ SAT_2.imp(x,id[c]);in_edges[c].pb(x);return;}
	if(qs<=ss && qe>=se){ v[c].pb(x);return;}
	int mid=ss+se>>1;
	Set(c<<1,ss,mid,qs,qe,x);
	Set(c<<1|1,mid+1,se,qs,qe,x);
}
void DFS(int c, int ss, int se, int nd=-1)
{
	for(int i:v[c])
	{
		if(nd==-1) nd=i;
		else
		{
			tsz++;
			SAT_2.imp(i,pos(tsz));
			SAT_2.imp(nd,pos(tsz));
			SAT_2.imp(i,nd^1);
			nd=pos(tsz);
		}
	}
	if(ss==se) return;
	int mid=ss+se>>1;
	DFS(c<<1,ss,mid,nd);
	DFS(c<<1|1,mid+1,se,nd);
}
bool sec(int l, int r, int L, int R){ return min(r,R)>=max(l,L);}
int main()
{
	int n;
	scanf("%i",&n);tsz=n;
	for(int i=0;i<n;i++) scanf("%i %i %i %i",&a[i],&b[i],&c[i],&d[i]),xs.Add(a[i]),xs.Add(b[i]),xs.Add(c[i]),xs.Add(d[i]);
	xs.Build();
	for(int i=0;i<n;i++) a[i]=xs.Get(a[i]),b[i]=xs.Get(b[i]),c[i]=xs.Get(c[i]),d[i]=xs.Get(d[i]);
	//Build(1,1,xs.sz());
	for(int i=0;i<n;i++) Set(1,1,xs.sz(),a[i],b[i],pos(i));
	for(int i=0;i<n;i++) Set(1,1,xs.sz(),c[i],d[i],neg(i));
	DFS(1,1,xs.sz());
	/*for(int i=0;i<H;i++) if(v[i].size()>1)
	{
		int last=in_edges[i][0];
		for(int j=1;j<in_edges[i].size();j++)
		{
			tsz++;
			SAT_2.imp(last,pos(tsz));
			SAT_2.imp(in_edges[i][j],pos(tsz));
			SAT_2.Or(last^1,in_edges[i][j]^1);
			last=pos(tsz);
		}
	}*/
	/*for(int i=0;i<n;i++) for(int j=i+1;j<n;j++) if(j!=i)
	{
		if(sec(a[i],b[i],a[j],b[j])) SAT_2.Or(neg(i),neg(j));
		if(sec(a[i],b[i],c[j],d[j])) SAT_2.Or(neg(i),pos(j));
		if(sec(c[i],d[i],a[j],b[j])) SAT_2.Or(pos(i),neg(j));
		if(sec(c[i],d[i],c[j],d[j])) SAT_2.Or(pos(i),pos(j));
	}*/
	if(SAT_2.Check())
	{
		printf("Yes\n");
		SAT_2.Solve();
		for(int i=0;i<n;i++)
		{
			if(SAT_2.tme[SAT_2.cmp[pos(i)]]<SAT_2.tme[SAT_2.cmp[neg(i)]]) printf("2\n");
			else printf("1\n");
		}
	}
	else printf("No\n");
	return 0;
}


/*#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define mp make_pair
#define mt make_tuple
const int N=100050;
const int H=12005;
struct Edge
{
	int u,v,c;
	Edge(){}
	Edge(int a, int b, int d):u(a),v(b),c(d){}
};
vector<Edge> edges;
vector<int> G[H];
void AddEdge(int u, int v)
{
	G[u].pb(edges.size());
	edges.pb(Edge(u,v,1));
	G[v].pb(edges.size());
	edges.pb(Edge(v,u,0));
}
int dist[H],go[H],s,t;
bool BFS()
{
	for(int i=s;i<=t;i++) dist[i]=0;
	dist[s]=1;
	queue<int> q;
	q.push(s);
	while(q.size())
	{
		int u=q.front();
		q.pop();
		for(int e:G[u])
		{
			int v=edges[e].v;
			int c=edges[e].c;
			if(c && dist[v]==0)
			{
				dist[v]=dist[u]+1;
				go[v]=e;
				q.push(v);
			}
		}
	}
	return dist[t]!=0;
}
int MaxFlow()
{
	int ans=0;
	while(BFS())
	{
		ans++;
		for(int i=t;i!=s;i=edges[go[i]].u)
		{
			edges[go[i]].c--;
			edges[go[i]^1].c++;
		}
	}
	return ans;
}
int a[N],b[N],c[N],d[N],l[N],r[N],ans[N];
vector<int> all;
int main()
{
	int n;
	scanf("%i",&n);
	for(int i=1;i<=n;i++) scanf("%i %i %i %i",&a[i],&b[i],&c[i],&d[i]),all.pb(a[i]),all.pb(c[i]);
	sort(all.begin(),all.end());
	all.erase(unique(all.begin(),all.end()),all.end());
	s=0;t=n+all.size()+1;
	for(int i=1;i<=n;i++) AddEdge(s,i);
	for(int i=1;i<=all.size();i++) AddEdge(n+i,t);
	for(int i=1;i<=n;i++)
	{
		a[i]=lower_bound(all.begin(),all.end(),a[i])-all.begin()+1;
		c[i]=lower_bound(all.begin(),all.end(),c[i])-all.begin()+1;
		AddEdge(i,n+a[i]);
		AddEdge(i,n+c[i]);
	}
	int f=MaxFlow();
	if(f!=n) printf("No\n");
	else
	{
		printf("Yes\n");
		for(auto e:edges)
		{
			int u=e.u,v=e.v,c=e.c;
			if(u>=1 && u<=n && v>n && c==0)
			{
				v-=n;
				if(a[u]==v) ans[u]=1;
				else ans[u]=2;
			}
		}
		for(int i=1;i<=n;i++) printf("%i\n",ans[i]);
	}
	return 0;
}*/


/*#include <bits/stdc++.h>
using namespace std;
#define ll long long
#define pb push_back
#define mp make_pair
#define mt make_tuple
const int N=100050;
int a[N],b[N],c[N],d[N],l[N],r[N],ans[N];
int main()
{
	int n;
	scanf("%i",&n);
	for(int i=1;i<=n;i++) scanf("%i %i %i %i",&a[i],&b[i],&c[i],&d[i]);
	for(int mask=0;mask<(1<<n);mask++)
	{
		for(int i=1;i<=n;i++)
		{
			if((mask>>(i-1))&1)
			{
				ans[i]=2;
				l[i]=c[i];
				r[i]=d[i];
			}
			else
			{
				ans[i]=1;
				l[i]=a[i];
				r[i]=b[i];
			}
		}
		bool ok=1;
		for(int i=1;i<=n;i++) for(int j=i+1;j<=n;j++) if(max(l[i],l[j])<=min(r[i],r[j])){ ok=0;break;}
		if(ok)
		{
			printf("Yes\n");
			for(int i=1;i<=n;i++) printf("%i\n",ans[i]);
			return 0;
		}
	}
	printf("No\n");
	return 0;
}*/
